/*!	@file
	@brief ҏWEBhEiOgjǗNX

	@author Norio Nakatani
*/
/*
	Copyright (C) 1998-2001, Norio Nakatani
	Copyright (C) 2000-2001, genta, jepro, ao
	Copyright (C) 2001, MIK, Stonee, Misaka, hor, YAZAKI
	Copyright (C) 2002, YAZAKI, genta, hor, aroka, minfu, S, MIK, ai
	Copyright (C) 2003, genta, MIK, Moca, wmlhq, ryoji, KEITA
	Copyright (C) 2004, genta, Moca, yasu, MIK, novice, Kazika
	Copyright (C) 2005, genta, MIK, Moca, aroka, ryoji
	Copyright (C) 2006, genta, ryoji, aroka, fon, yukihane
	Copyright (C) 2007, ryoji
	Copyright (C) 2008, ryoji, nasukoji
	Copyright (C) 2009, ryoji, nasukoji

	This source code is designed for sakura editor.
	Please contact the copyright holders to use this code for other purpose.
*/

#include "stdafx.h"
#include <stdio.h>
#include <windows.h>
#include <winuser.h>
#include <io.h>
#include <mbctype.h>
#include <mbstring.h>

#include "CEditApp.h"
#include "CEditWnd.h"
#include "sakura_rc.h"
#include "CEditDoc.h"
#include "CDocLine.h"
#include "debug.h"
#include "CDlgAbout.h"
#include "mymessage.h"
#include "CShareData.h"
#include "CPrint.h"
#include "etc_uty.h"
#include "charcode.h"
#include "global.h"
#include "CDlgPrintSetting.h"
#include "CDlgPrintPage.h"
#include "funccode.h"		// Stonee, 2001/03/12
#include "CPrintPreview.h" /// 2002/2/3 aroka
#include "CMarkMgr.h" /// 2002/2/3 aroka
#include "CCommandLine.h" /// 2003/1/26 aroka
#include "CSMacroMgr.h" // Jun. 16, 2002 genta
#include "COsVersioninfo.h"	// Sep. 6, 2003 genta
#include "CRunningTimer.h"
#include "KeyCode.h"


#define IDT_EDIT		455  // 20060128 aroka
#define IDT_TOOLBAR		456
#define IDT_CAPTION		457
#define IDT_FIRST_IDLE	458
#define IDT_SYSMENU		1357
#define ID_TOOLBAR		100


//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗ̂
//	`폜

#ifndef TBSTYLE_ALTDRAG
	#define TBSTYLE_ALTDRAG	0x0400
#endif
#ifndef TBSTYLE_FLAT
	#define TBSTYLE_FLAT	0x0800
#endif
#ifndef TBSTYLE_LIST
	#define TBSTYLE_LIST	0x1000
#endif

#ifndef	WM_MOUSEWHEEL
	#define WM_MOUSEWHEEL	0x020A
#endif

// 2006.06.17 ryoji WM_THEMECHANGED
#ifndef	WM_THEMECHANGED
#define WM_THEMECHANGED		0x031A
#endif

#define		YOHAKU_X		4		/* EBhE̘gƎ̌ԍŏl */
#define		YOHAKU_Y		4		/* EBhE̘gƎ̌ԍŏl */
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗ̂
//	`폜


/*! TuNXc[o[̃EBhEvV[W
	@author ryoji
	@date 2006.09.06 ryoji
*/
static WNDPROC g_pOldToolBarWndProc;	// c[o[̖{̃EBhEvV[W

static LRESULT CALLBACK ToolBarWndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	// WinXP Visual Style ̂ƂɃc[o[ł̃}EXE{^ŖɂȂ
	//i}EXLv`[܂ܕȂj 邽߂ɉE{^𖳎
	case WM_RBUTTONDOWN:
	case WM_RBUTTONUP:
		return 0L;				// E{^ UP/DOWN ͖{̃EBhEvV[WɓnȂ

	case WM_DESTROY:
		// TuNX
		::SetWindowLongPtr( hWnd, GWLP_WNDPROC, (LONG_PTR)g_pOldToolBarWndProc );
		break;
	}
	return ::CallWindowProc( g_pOldToolBarWndProc, hWnd, msg, wParam, lParam );
}


//	/* bZ[W[v */
//	DWORD MessageLoop_Thread( DWORD pCEditWndObject );

LRESULT CALLBACK CEditWndProc(
	HWND	hwnd,	// handle of window
	UINT	uMsg,	// message identifier
	WPARAM	wParam,	// first message parameter
	LPARAM	lParam 	// second message parameter
)
{
	CEditWnd* pSEWnd;
	// Modified by KEITA for WIN64 2003.9.6
	pSEWnd = ( CEditWnd* )::GetWindowLongPtr( hwnd, GWLP_USERDATA );
	if( NULL != pSEWnd ){
		return pSEWnd->DispatchEvent( hwnd, uMsg, wParam, lParam );
	}
	return ::DefWindowProc( hwnd, uMsg, wParam, lParam );
}


//	@date 2002.2.17 YAZAKI CShareDatãCX^X́ACProcessɂЂƂ̂݁B
CEditWnd::CEditWnd() :
	m_hWnd( NULL ),
	m_bDragMode( FALSE ),
	m_hwndParent( NULL ),
	m_hwndReBar( NULL ),	// 2006.06.17 ryoji
	m_hwndToolBar( NULL ),
	m_hwndStatusBar( NULL ),
	m_hwndProgressBar( NULL ),
// 20020331 aroka ĕϊΉ for 95/NT
	m_uMSIMEReconvertMsg( ::RegisterWindowMessage( RWM_RECONVERT ) ),
	m_uATOKReconvertMsg( ::RegisterWindowMessage( MSGNAME_ATOK_RECONVERT ) ),

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	m_pPrintPreview( NULL ),
	m_pszAppName( GSTR_EDITWINDOWNAME ),
	m_pszLastCaption( NULL ),
	m_hwndSearchBox( NULL ),
	m_fontSearchBox( NULL ),
	m_nCurrentFocus( 0 ),
	m_bIsActiveApp( FALSE ),
	m_IconClicked(icNone) //by S(2)
{
	//	Dec. 4, 2002 genta
	InitMenubarMessageFont();

	// Sep. 10, 2002 genta
	m_cEditDoc.m_pcEditWnd = this;
	/* Lf[^\̂̃AhXԂ */
	m_pShareData = CShareData::getInstance()->GetShareData();

	m_pcDropTarget = new CDropTarget( this );	// E{^hbvp	// 2008.06.20 ryoji

	// 2009.01.12 nasukoji	zC[XN[LԂNA
	ClearMouseState();

//	MYTRACE( "CEditWnd::CEditWnd()\n" );
	return;
}




CEditWnd::~CEditWnd()
{
	delete []m_pszLastCaption;

	//	Dec. 4, 2002 genta
	/* Lbg̍sʒu\ptHg */
	::DeleteObject( m_hFontCaretPosInfo );

	delete m_pcDropTarget;	// 2008.06.20 ryoji
	m_pcDropTarget = NULL;

	if( NULL != m_hWnd ){
		m_hWnd = NULL;
	}
	return;
}





/*!	쐬

	@param hInstance [in] Instance Handle
	@param hwndParent [in] eEBhẼnh
	@param nGroup [in] O[vID
	@param pszPath [in] ŏɊJt@C̃pXDNULL̂ƂJt@CD
	@param nCharCode [in] R[h
	@param bReadOnly [in] ǂ݂ƂpŊJǂ
	@param nDocumentType [in] ^CvD-1̂Ƃw薳D
	
	@date 2002.03.07 genta nDocumentTypeǉ
	@date 2007.06.26 ryoji nGroupǉ
	@date 2008.04.19 ryoji AChOop[b^C}[̃Zbgǉ
*/
HWND CEditWnd::Create(
	HINSTANCE	hInstance,
	HWND		hwndParent,
	int			nGroup,
	const char*	pszPath,
	int			nCharCode,
	BOOL		bReadOnly,
	int			nDocumentType
)
{
	MY_RUNNINGTIMER( cRunningTimer, "CEditWnd::Create" );

	//	Dec. 6, 2002 genta
	//	small iconŵ RegisterClassExɕύX
	WNDCLASSEX	wc;
	HWND		hWnd;
	HWND		hwndTop;
	WINDOWPLACEMENT	wpTop;
	EditNode*	pEditNode;
	ATOM		atom;
	BOOL		bOpened;
	char szMsg[512];

	if( m_pShareData->m_nEditArrNum >= MAX_EDITWINDOWS ){	//őlC	//@@@ 2003.05.31 MIK
		wsprintf( szMsg, "ҏWEBhȄ%dłB\nȏ͓ɊJ܂B", MAX_EDITWINDOWS );
		::MessageBox( NULL, szMsg, GSTR_APPNAME, MB_OK );
		return NULL;
	}


	m_hInstance = hInstance;
	m_hwndParent = hwndParent;
	//	Apr. 27, 2000 genta
	//	TCYύX̂}邽CS_HREDRAW | CS_VREDRAW O
	wc.style			= CS_DBLCLKS | CS_BYTEALIGNCLIENT | CS_BYTEALIGNWINDOW;
	wc.lpfnWndProc		= CEditWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 32;
	wc.hInstance		= m_hInstance;
	//	Dec, 2, 2002 genta ACRǂݍݕ@ύX
	wc.hIcon			= GetAppIcon( m_hInstance, ICON_DEFAULT_APP, FN_APP_ICON, false );

	wc.hCursor			= NULL/*LoadCursor( NULL, IDC_ARROW )*/;
	wc.hbrBackground	= (HBRUSH)NULL/*(COLOR_3DSHADOW + 1)*/;
	wc.lpszMenuName		= MAKEINTRESOURCE( IDR_MENU1 );
	wc.lpszClassName	= m_pszAppName;

	//	Dec. 6, 2002 genta
	//	small iconŵ RegisterClassExɕύX
	wc.cbSize			= sizeof( wc );
	wc.hIconSm			= GetAppIcon( m_hInstance, ICON_DEFAULT_APP, FN_APP_ICON, true );
	if( 0 == ( atom = RegisterClassEx( &wc ) ) ){
		//	2004.05.13 Moca return NULLLɂ
		return NULL;
	}

	/* EBhETCYp */
	int	nWinCX, nWinCY;
	//	2004.05.13 Moca m_Common.m_nSaveWindowSizeBOOLenumɕς
	if( WINSIZEMODE_DEF != m_pShareData->m_Common.m_nSaveWindowSize ){
		nWinCX = m_pShareData->m_Common.m_nWinSizeCX;
		nWinCY = m_pShareData->m_Common.m_nWinSizeCY;
	}else{
		nWinCX = CW_USEDEFAULT;
		nWinCY = 0;
	}

	/* EBhETCYw */
	FileInfo fi;
	CCommandLine::Instance()->GetFileInfo(fi);
	if( fi.m_nWindowSizeX >= 0 ){
		nWinCX = fi.m_nWindowSizeX;
	}
	if( fi.m_nWindowSizeY >= 0 ){
		nWinCY = fi.m_nWindowSizeY;
	}

	/* EBhEʒuw */

	int nWinOX, nWinOY;
	nWinOX = CW_USEDEFAULT;
	nWinOY = 0;
	// EBhEʒuŒ
	//	2004.05.13 Moca ۑEBhEʒugꍇ͋LZbg
	if( WINSIZEMODE_DEF != m_pShareData->m_Common.m_nSaveWindowPos ){
		nWinOX =  m_pShareData->m_Common.m_nWinPosX;
		nWinOY =  m_pShareData->m_Common.m_nWinPosY;
	}

	//	2004.05.13 Moca }`fBXvCł͕̒lLȂ̂ŁC
	//	ݒ̔@ύXD(̒lCW_USEDEFAULT)
	if( fi.m_nWindowOriginX != CW_USEDEFAULT ){
		nWinOX = fi.m_nWindowOriginX;
	}
	if( fi.m_nWindowOriginY != CW_USEDEFAULT ){
		nWinOY = fi.m_nWindowOriginY;
	}

	//From Here @@@ 2003.05.31 MIK
	//^uEChȄꍇ͌lw
	if( m_pShareData->m_Common.m_bDispTabWnd && !m_pShareData->m_Common.m_bDispTabWndMultiWin )
	{
		if( nGroup < 0 )	// sȃO[vID
			nGroup = 0;	// O[vw薳iŋ߃ANeBũO[vɓj
		pEditNode = CShareData::getInstance()->GetEditNodeAt( nGroup, 0 );	// O[v̐擪EBhE擾	// 2007.06.20 ryoji
		hwndTop = pEditNode? pEditNode->m_hWnd: NULL;

		if( hwndTop )
		{
			//	Sep. 11, 2003 MIK VKTABEBhËʒuɂȂ悤
			// 2007.06.20 ryoji vC}j^܂̓^XNo[𓮂łȂ悤
			RECT rcWork;
			RECT rcMon;
			GetMonitorWorkRect( hwndTop, &rcWork, &rcMon );

			wpTop.length = sizeof(WINDOWPLACEMENT);
			if( ::GetWindowPlacement( hwndTop, &wpTop ) ){	// ݂̐擪EBhEʒu擾
				nWinCX = wpTop.rcNormalPosition.right - wpTop.rcNormalPosition.left;
				nWinCY = wpTop.rcNormalPosition.bottom - wpTop.rcNormalPosition.top;
				nWinOX = wpTop.rcNormalPosition.left + (rcWork.left - rcMon.left);
				nWinOY = wpTop.rcNormalPosition.top + (rcWork.top - rcMon.top);
				if( wpTop.showCmd == SW_SHOWMINIMIZED )
					wpTop.showCmd = pEditNode->m_showCmdRestore;
			}
			else{
				hwndTop = NULL;
			}
		}
	}
	//To Here @@@ 2003.05.31 MIK

	hWnd = ::CreateWindowEx(
		0 	// extended window style
//		| WS_EX_CLIENTEDGE
		,
		m_pszAppName,		// pointer to registered class name
		m_pszAppName,		// pointer to window name
//		WS_VISIBLE |
		WS_OVERLAPPEDWINDOW |
		WS_CLIPCHILDREN	|
//		WS_HSCROLL | WS_VSCROLL	|
		0,	// window style

		nWinOX,				// horizontal position of window
		nWinOY,				// vertical position of window
		nWinCX,				// window width
		nWinCY,				// window height
		NULL,				// handle to parent or owner window
		NULL,				// handle to menu or child-window identifier
		m_hInstance,		// handle to application instance
		NULL				// pointer to window-creation data
	);
	m_hWnd = hWnd;

	// 2004.05.13 Moca EBhE쐬sBI
	if( NULL == hWnd ){
		return NULL;
	}

	// AChOop̃[b^C}[Zbg	// 2008.04.19 ryoji
	// [b^C}[iAChOoj MYWM_FIRST_IDLE NvZXɃ|XgB
	// Nł̋NAChOoɂĂ CEditApp::OpenNewEditor Q
	::SetTimer( m_hWnd, IDT_FIRST_IDLE, 0, NULL );

	MyInitCommonControls();	// 2006.06.19 ryoji RRg[̏ CreateToolBar() ړ


	m_cIcons.Create( m_hInstance, m_hWnd );	//	CreateImage List

	m_CMenuDrawer.Create( m_hInstance, m_hWnd, &m_cIcons );

	// eo[ m_cEditDoc.Create() sĂ	// 2007.01.30 ryoji
	// im_cEditDoc o[̏Dj
	if( FALSE == m_cEditDoc.Create( m_hInstance, m_hWnd, &m_cIcons/*, 1, 1, 0, 0*/ ) ){
		::MessageBox(
			m_hWnd,
			"NCAgEBhE̍쐬Ɏs܂", GSTR_APPNAME,
			MB_OK
		);
	}

	// 2007.03.08 ryoji eo[̍쐬 Layoutxxx(), EndLayoutBars() Ŋȑf

// SetWindowLongPtrȍ~ƃfobOɗ邱Ƃ̂ŏԂւB // 2005/8/9 aroka
	/* c[o[ */
	LayoutToolBar();

//	if( NULL != m_hWnd ){
		// Modified by KEITA for WIN64 2003.9.6
		::SetWindowLongPtr( m_hWnd, GWLP_USERDATA, (LONG_PTR)this );


//	}

	/* Xe[^Xo[ */
	LayoutStatusBar();

	/* t@NVL[ o[ */
	LayoutFuncKey();

	/* ^uEChE */
	LayoutTabBar();

	/* o[̔zuI */
	EndLayoutBars( FALSE );

	/* fXNgbv͂ݏoȂ悤ɂ */
	RECT	rcOrg;
	RECT	rcDesktop;
//	int		nWork;

	//	May 01, 2004 genta }`j^Ή
	::GetMonitorWorkRect( m_hWnd, &rcDesktop );
	::GetWindowRect( m_hWnd, &rcOrg );

	// 2005.11.23 Moca }`j^Ŗ肪ߌvZ@ύX
	/* EBhEʒu */
	if( rcOrg.bottom > rcDesktop.bottom ){
		rcOrg.top -= rcOrg.bottom - rcDesktop.bottom;
		rcOrg.bottom = rcDesktop.bottom;	//@@@ 2002.01.08
	}
	if( rcOrg.right > rcDesktop.right ){
		rcOrg.left -= rcOrg.right - rcDesktop.right;
		rcOrg.right = rcDesktop.right;	//@@@ 2002.01.08
	}
	
	if( rcOrg.top < rcDesktop.top ){
		rcOrg.bottom += rcDesktop.top - rcOrg.top;
		rcOrg.top = rcDesktop.top;
	}
	if( rcOrg.left < rcDesktop.left ){
		rcOrg.right += rcDesktop.left - rcOrg.left;
		rcOrg.left = rcDesktop.left;
	}

	/* EBhETCY */
	if( rcOrg.bottom > rcDesktop.bottom ){
		//rcOrg.bottom = rcDesktop.bottom - 1;	//@@@ 2002.01.08
		rcOrg.bottom = rcDesktop.bottom;	//@@@ 2002.01.08
	}
	if( rcOrg.right > rcDesktop.right ){
		//rcOrg.right = rcDesktop.right - 1;	//@@@ 2002.01.08
		rcOrg.right = rcDesktop.right;	//@@@ 2002.01.08
	}

	//From Here @@@ 2003.06.13 MIK
	if( m_pShareData->m_Common.m_bDispTabWnd && !m_pShareData->m_Common.m_bDispTabWndMultiWin
		&& hwndTop )
	{
		// ݂̐擪EBhE WS_EX_TOPMOST Ԃp	// 2007.05.18 ryoji
		DWORD dwExStyle = (DWORD)::GetWindowLongPtr( hwndTop, GWL_EXSTYLE );
		::SetWindowPos( m_hWnd, (dwExStyle & WS_EX_TOPMOST)? HWND_TOPMOST: HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );

		//^uEChE͌ێ
		/* EBhETCYp */
		if( wpTop.showCmd == SW_SHOWMAXIMIZED )
		{
			::ShowWindow( m_hWnd, SW_SHOWMAXIMIZED );
		}
		else
		{
			::ShowWindow( m_hWnd, SW_SHOW );
		}
	}
	else
	{
		::SetWindowPos(
			m_hWnd, 0,
			rcOrg.left, rcOrg.top,
			rcOrg.right - rcOrg.left, rcOrg.bottom - rcOrg.top,
			SWP_NOOWNERZORDER | SWP_NOZORDER
		);

		/* EBhETCYp */
		if( WINSIZEMODE_DEF != m_pShareData->m_Common.m_nSaveWindowSize &&
			m_pShareData->m_Common.m_nWinSizeType == SIZE_MAXIMIZED ){
			::ShowWindow( m_hWnd, SW_SHOWMAXIMIZED );
		}else
		// 2004.05.14 Moca EBhETCY𒼐ڎw肷ꍇ́Aŏ\󂯓
		if( WINSIZEMODE_SET == m_pShareData->m_Common.m_nSaveWindowSize &&
			m_pShareData->m_Common.m_nWinSizeType == SIZE_MINIMIZED ){
			::ShowWindow( m_hWnd, SW_SHOWMINIMIZED );
		}else{
			::ShowWindow( m_hWnd, SW_SHOW );
		}
	}
	//To Here @@@ 2003.06.13 MIK

//	if( NULL != m_hWnd ){
		/* hbvꂽt@C󂯓 */
		::DragAcceptFiles( m_hWnd, TRUE );
		m_pcDropTarget->Register_DropTarget( m_hWnd );	// E{^hbvp	// 2008.06.20 ryoji

		m_bIsActiveApp = ( ::GetActiveWindow() == m_hWnd );	// 2007.03.08 ryoji

		/* GfB^|gCԂłUI̊mFiVista UIPI@\j */	// 2007.06.07 ryoji
		if( COsVersionInfo().IsWinVista_or_later() ){
			m_bUIPI = FALSE;
			::SendMessage( m_pShareData->m_hwndTray, MYWM_UIPI_CHECK,  (WPARAM)0, (LPARAM)m_hWnd );
			if( !m_bUIPI ){	// ԎԂȂ
				::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONSTOP | MB_TOPMOST, GSTR_APPNAME,
					_T("GfB^Ԃ̑ΘbɎs܂B\nẍقȂGfB^ɋNĂ\܂B")
				);
				::DestroyWindow( m_hWnd );
				m_hWnd = hWnd = NULL;
				return hWnd;
			}
		}

		/* ҏWEBhEXgւ̓o^ */
		if( FALSE == CShareData::getInstance()->AddEditWndList( m_hWnd, nGroup ) ){	// 2007.06.26 ryoji nGroupǉ
			wsprintf( szMsg, "ҏWEBhȄ%dłB\nȏ͓ɊJ܂B", MAX_EDITWINDOWS );
			::MessageBox( m_hWnd, szMsg, GSTR_APPNAME, MB_OK );
			::DestroyWindow( m_hWnd );
			m_hWnd = hWnd = NULL;
			return hWnd;
		}
		CShareData::getInstance()->SetTraceOutSource( m_hWnd );	// TraceOut()NEBhE̐ݒ	// 2006.06.26 ryoji

		//	Aug. 29, 2003 wmlhq
		m_nTimerCount = 0;
		/* ^C}[N */ // ^C}[IDƊԊuύX 20060128 aroka
		if( 0 == ::SetTimer( m_hWnd, IDT_EDIT, 500, NULL ) ){
			::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONEXCLAMATION, GSTR_APPNAME,
				"CEditWnd::Create()\n^C}[Nł܂B\nVXe\[XsĂ̂܂B"
			);
		}
		// c[o[̃^C}[𕪗 20060128 aroka
		Timer_ONOFF( TRUE );
//	}
	::InvalidateRect( m_hWnd, NULL, TRUE );
	if( NULL != pszPath ){
		char*	pszPathNew = new char[_MAX_PATH];
		strcpy( pszPathNew, pszPath );
		::ShowWindow( m_hWnd, SW_SHOW );
		//	Oct. 03, 2004 genta R[hmF͐ݒɈˑ
		if( !m_cEditDoc.FileRead( pszPathNew, &bOpened, nCharCode, bReadOnly,
			m_pShareData->m_Common.m_bQueryIfCodeChange ) ){
			/* t@CɊJĂ */
			if( bOpened ){
				::PostMessage( m_hWnd, WM_CLOSE, 0, 0 );
				delete [] pszPathNew;
				// 2004.07.12 Moca return NULLƁAbZ[W[vʂ炸ɂ̂܂ܔjĂ܂A^ȕI
				//	̌͐탋[gŃbZ[W[vɓWM_CLOSEMĒCLOSE & DESTROYƂȂD
				//	̒ŕҏWEBhE̍폜sD
				return m_hWnd;
			}
			else {
				//	Nov. 20, 2000 genta
				m_cEditDoc.SetImeMode( m_pShareData->m_Types[0].m_nImeState );
			}
		}
		delete [] pszPathNew;
	}
	else {
		//	Nov. 20, 2000 genta
		m_cEditDoc.SetImeMode( m_pShareData->m_Types[0].m_nImeState );
	}
	//	Mar. 7, 2002 genta ^Cv̋w
	//	Jun. 4 ,2004 genta t@Cw肪Ă^CvwLɂ
	if( nDocumentType >= 0 ){
		m_cEditDoc.SetDocumentType( nDocumentType, true );
		//	2002/05/07 YAZAKI ^Cvʐݒꗗ̈ꎞKp̃R[h𗬗p
		m_cEditDoc.LockDocumentType();
		/* ݒύX𔽉f */
		m_cEditDoc.OnChangeSetting();
	}
	//	Jun. 4 ,2004 genta t@Cw肪Ăǂ݂ƂpwLɂ
	m_cEditDoc.m_bReadOnly = bReadOnly;
	m_cEditDoc.SetParentCaption();
	
	//	YAZAKI 2002/05/30 IMEEBhËʒûCB
	m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].SetIMECompFormPos();
	return m_hWnd;
}


//	L[[hFXe[^Xo[
/* Xe[^Xo[쐬 */
void CEditWnd::CreateStatusBar( void )
{
//	int		nStArr[] = { 300, 400, 500. -1 };
//	int		nStArrNum = sizeof( nStArr ) / sizeof( nStArr[0] );

	/* Xe[^Xo[ */
	m_hwndStatusBar = ::CreateStatusWindow(
		WS_CHILD/* | WS_VISIBLE*/ | WS_EX_RIGHT | SBARS_SIZEGRIP,	// 2007.03.08 ryoji WS_VISIBLE 
		"",
		m_hWnd,
		IDW_STATUSBAR
	);

	/* vOXo[ */
	m_hwndProgressBar = ::CreateWindowEx(
		WS_EX_TOOLWINDOW,
		PROGRESS_CLASS,
		(LPSTR) NULL,
		WS_CHILD /*|  WS_VISIBLE*/,
		3,
		5,
		150,
		13,
		m_hwndStatusBar,
		NULL,
		m_hInstance,
		0
	);
//	::ShowWindow( m_hwndProgressBar, SW_SHOW );

	if( NULL != m_CFuncKeyWnd.m_hWnd ){
		m_CFuncKeyWnd.SizeBox_ONOFF( FALSE );
	}
	//Xvb^[́ATCY{bNẌʒuύX
	m_cEditDoc.m_cSplitterWnd.DoSplit( -1, -1);
	return;
}


/* Xe[^Xo[j */
void CEditWnd::DestroyStatusBar( void )
{
	if( NULL != m_hwndProgressBar ){
		::DestroyWindow( m_hwndProgressBar );
		m_hwndProgressBar = NULL;
	}
	::DestroyWindow( m_hwndStatusBar );
	m_hwndStatusBar = NULL;

	if( NULL != m_CFuncKeyWnd.m_hWnd ){
		BOOL bSizeBox;
		if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 0 ){	/* t@NVL[\ʒu^0: 1: */
			/* TCY{bNX̕\^\؂ւ */
			bSizeBox = FALSE;
		}else{
			bSizeBox = TRUE;
			/* Xe[^Xp[\Ăꍇ̓TCY{bNX\Ȃ */
			if( NULL != m_hwndStatusBar ){
				bSizeBox = FALSE;
			}
		}
		m_CFuncKeyWnd.SizeBox_ONOFF( bSizeBox );
	}
	//Xvb^[́ATCY{bNẌʒuύX
	m_cEditDoc.m_cSplitterWnd.DoSplit( -1, -1 );

	return;
}

/* c[o[쐬
	@date @@@ 2002.01.03 YAZAKI m_tbMyButtonȂǂCShareDataCMenuDrawerֈړƂɂCB
	@date 2005.08.29 aroka c[o[̐܂Ԃ
	@date 2006.06.17 ryoji rWAX^CL̏ꍇ̓c[o[ Rebar ɓăTCYύX̂𖳂
*/
void CEditWnd::CreateToolBar( void )
{
	REBARINFO		rbi;
	REBARBANDINFO	rbBand;
	int				nFlag;
	TBBUTTON		tbb;
	int				i;
	int				nIdx;
	UINT			uToolType;
	nFlag = 0;

	// 2006.06.17 ryoji
	// Rebar EBhE̍쐬
	if( IsVisualStyle() ){	// rWAX^CL
		m_hwndReBar = ::CreateWindowEx(
			WS_EX_TOOLWINDOW,
			REBARCLASSNAME,
			NULL,
			WS_CHILD/* | WS_VISIBLE*/ | WS_CLIPSIBLINGS | WS_CLIPCHILDREN |	// 2007.03.08 ryoji WS_VISIBLE 
			RBS_BANDBORDERS | CCS_NODIVIDER,
			0, 0, 0, 0,
			m_hWnd,
			NULL,
			m_hInstance,
			NULL);

		if( NULL == m_hwndReBar ){
			::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST, GSTR_APPNAME,
				"Rebar ̍쐬Ɏs܂B"
			);
			return;
		}

		if( m_pShareData->m_Common.m_bToolBarIsFlat ){	/* tbgc[o[ɂ^Ȃ */
			PreventVisualStyle( m_hwndReBar );	// rWAX^CKp̃tbg Rebar ɂ
		}

		::ZeroMemory(&rbi, sizeof(REBARINFO));
		rbi.cbSize = sizeof(REBARINFO);
		::SendMessage(m_hwndReBar, RB_SETBARINFO, 0, (LPARAM)&rbi);

		nFlag = CCS_NORESIZE | CCS_NODIVIDER | CCS_NOPARENTALIGN | TBSTYLE_FLAT;	// c[o[ւ̒ǉX^C
	}

	/* c[o[EBhE̍쐬 */
	m_hwndToolBar = ::CreateWindowEx(
		0,
		TOOLBARCLASSNAME,
		NULL,
		WS_CHILD/* | WS_VISIBLE*/ | WS_CLIPCHILDREN | /*WS_BORDER | */	// 2006.06.17 ryoji WS_CLIPCHILDREN ǉ	// 2007.03.08 ryoji WS_VISIBLE 
/*		WS_EX_WINDOWEDGE| */
		TBSTYLE_TOOLTIPS |
//		TBSTYLE_WRAPABLE |
//		TBSTYLE_ALTDRAG |
//		CCS_ADJUSTABLE |
		nFlag,
		0, 0,
		0, 0,
		m_hWnd,
		(HMENU)ID_TOOLBAR,
		m_hInstance,
		NULL
	);
	if( NULL == m_hwndToolBar ){
		if( m_pShareData->m_Common.m_bToolBarIsFlat ){	/* tbgc[o[ɂ^Ȃ */
			m_pShareData->m_Common.m_bToolBarIsFlat = FALSE;
		}
		::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONEXCLAMATION | MB_TOPMOST, GSTR_APPNAME,
			"c[o[̍쐬Ɏs܂B"
		);
		DestroyToolBar();	// 2006.06.17 ryoji
	}else{
		// 2006.09.06 ryoji c[o[TuNX
		g_pOldToolBarWndProc = (WNDPROC)::SetWindowLongPtr( m_hwndToolBar, GWLP_WNDPROC, (LONG_PTR)ToolBarWndProc );

		::SendMessage( m_hwndToolBar, TB_BUTTONSTRUCTSIZE, (WPARAM)sizeof(TBBUTTON), 0 );
		//	Oct. 12, 2000 genta
		//	ɗpӂĂImage ListACRƂēo^
		m_cIcons.SetToolBarImages( m_hwndToolBar );
		/* c[o[Ƀ{^ǉ */
		int count = 0;	//@@@ 2002.06.15 MIK
		int nToolBarButtonNum = 0;// 2005/8/29 aroka
		//	From Here 2005.08.29 aroka
		// ͂߂Ƀc[o[\̂̔zĂ
		TBBUTTON *pTbbArr = new TBBUTTON[m_pShareData->m_Common.m_nToolBarButtonNum];
		for( i = 0; i < m_pShareData->m_Common.m_nToolBarButtonNum; ++i ){
			nIdx = m_pShareData->m_Common.m_nToolBarButtonIdxArr[i];
			pTbbArr[nToolBarButtonNum] = m_CMenuDrawer.getButton(nIdx);
			// Zp[^Ƃ͂ЂƂɂ܂Ƃ߂
			// ܂Ԃ{^TBSTYLE_SEPĂ̂
			// ܂Ԃ̑ÕZp[^͑Sč폜D
			if( (pTbbArr[nToolBarButtonNum].fsStyle & TBSTYLE_SEP) && (nToolBarButtonNum!=0)){
				if( (pTbbArr[nToolBarButtonNum-1].fsStyle & TBSTYLE_SEP) ){
					pTbbArr[nToolBarButtonNum-1] = pTbbArr[nToolBarButtonNum];
					nToolBarButtonNum--;
				}
			}
			// zܕԂ{^璼Õ{^ɐܕԂt
			if( pTbbArr[nToolBarButtonNum].fsState & TBSTATE_WRAP ){
				if( nToolBarButtonNum!=0 ){
					pTbbArr[nToolBarButtonNum-1].fsState |= TBSTATE_WRAP;
				}
				continue;
			}
			nToolBarButtonNum++;
		}
		//	To Here 2005.08.29 aroka

		for( i = 0; i < nToolBarButtonNum; ++i ){
			tbb = pTbbArr[i];
			//::SendMessage( m_hwndToolBar, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&tbb );

			//@@@ 2002.06.15 MIK start
			switch( tbb.fsStyle )
			{
			case TBSTYLE_DROPDOWN:	//hbv_E
				//gX^Cɐݒ
				::SendMessage( m_hwndToolBar, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_DRAWDDARROWS );
				::SendMessage( m_hwndToolBar, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&tbb );
				count++;
				break;

			case TBSTYLE_COMBOBOX:	//R{{bNX
				{
					RECT			rc;
					TBBUTTONINFO	tbi;
					//HWND			my_hwnd;
					TBBUTTON		my_tbb;
					//int			width;
					LOGFONT			lf;
					//HFONT			my_font;
					int				my_i;

					switch( tbb.idCommand )
					{
					case F_SEARCH_BOX:
						if( m_hwndSearchBox )
						{
							break;
						}
						
						//Zp[^
						memset( &my_tbb, 0, sizeof(my_tbb) );
						my_tbb.fsStyle   = TBSTYLE_BUTTON;  //{^ɂȂƕ`悪 2005/8/29 aroka
						my_tbb.idCommand = tbb.idCommand;	//IDɂĂ
						if( tbb.fsState & TBSTATE_WRAP ){   //܂Ԃ 2005/8/29 aroka
							my_tbb.fsState |=  TBSTATE_WRAP;
						}
						::SendMessage( m_hwndToolBar, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&my_tbb );
						count++;

						//TCYݒ肷
						tbi.cbSize = sizeof(tbi);
						tbi.dwMask = TBIF_SIZE;
						tbi.cx     = 160;	//{bNX̕
						::SendMessage( m_hwndToolBar, TB_SETBUTTONINFO, (WPARAM)(tbb.idCommand), (LPARAM)&tbi );

						//TCY擾
						rc.right = rc.left = rc.top = rc.bottom = 0;
						::SendMessage( m_hwndToolBar, TB_GETITEMRECT, (WPARAM)(count-1), (LPARAM)&rc );

						//R{{bNX
						//	Mar. 8, 2003 genta {bNX1hbgɂ炵
						m_hwndSearchBox = CreateWindow( "COMBOBOX", "Combo",
								WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_VSCROLL | CBS_DROPDOWN
								/*| CBS_SORT*/ | CBS_AUTOHSCROLL /*| CBS_DISABLENOSCROLL*/,
								rc.left, rc.top + 1, rc.right - rc.left, (rc.bottom - rc.top) * 10,
								m_hwndToolBar, (HMENU)(INT_PTR)tbb.idCommand, m_hInstance, NULL );
						if( m_hwndSearchBox )
						{
							m_nCurrentFocus = 0;

							memset( &lf, 0, sizeof(LOGFONT) );
							lf.lfHeight			= 12; // Jan. 14, 2003 genta _CAOɂ킹ĂƏ
							lf.lfWidth			= 0;
							lf.lfEscapement		= 0;
							lf.lfOrientation	= 0;
							lf.lfWeight			= FW_NORMAL;
							lf.lfItalic			= FALSE;
							lf.lfUnderline		= FALSE;
							lf.lfStrikeOut		= FALSE;
							lf.lfCharSet		= SHIFTJIS_CHARSET;
							lf.lfOutPrecision	= OUT_DEFAULT_PRECIS;
							lf.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
							lf.lfQuality		= DEFAULT_QUALITY;
							lf.lfPitchAndFamily	= FF_MODERN | DEFAULT_PITCH;
							//strcpy( lf.lfFaceName, "lr SVbN" );
							strcpy( lf.lfFaceName, "lr oSVbN" );
							m_fontSearchBox = ::CreateFontIndirect( &lf );
							if( m_fontSearchBox )
							{
								::SendMessage( m_hwndSearchBox, WM_SETFONT, (WPARAM)m_fontSearchBox, MAKELONG (TRUE, 0) );
							}

							//͒
							::SendMessage( m_hwndSearchBox, CB_LIMITTEXT, (WPARAM)_MAX_PATH - 1, 0 );

							//gC^tF[X
							//::SendMessage( m_hwndSearchBox, CB_SETEXTENDEDUI, (WPARAM)(BOOL)TRUE, 0 );

							//{bNXXV
							::SendMessage( m_hwndSearchBox, CB_RESETCONTENT, 0, 0 );
							for( my_i = 0; my_i < m_pShareData->m_nSEARCHKEYArrNum; my_i++ )
							{
								::SendMessage( m_hwndSearchBox, CB_ADDSTRING, 0, (LPARAM)m_pShareData->m_szSEARCHKEYArr[my_i] );
							}
							::SendMessage( m_hwndSearchBox, CB_SETCURSEL, 0, 0 );
						}
						break;

					default:
						//width = 0;
						//my_hwnd = NULL;
						//my_font = NULL;
						break;
					}
				}
				break;

			case TBSTYLE_BUTTON:	//{^
			case TBSTYLE_SEP:		//Zp[^
			default:
				::SendMessage( m_hwndToolBar, TB_ADDBUTTONS, (WPARAM)1, (LPARAM)&tbb );
				count++;
				break;
			}
			//@@@ 2002.06.15 MIK end
		}
		if( m_pShareData->m_Common.m_bToolBarIsFlat ){	/* tbgc[o[ɂ^Ȃ */
			uToolType = (UINT)::GetWindowLong(m_hwndToolBar, GWL_STYLE);
			uToolType |= (TBSTYLE_FLAT);
			::SetWindowLong(m_hwndToolBar, GWL_STYLE, uToolType);
			::InvalidateRect(m_hwndToolBar, NULL, TRUE);
		}
		delete []pTbbArr;// 2005/8/29 aroka
	}

	// 2006.06.17 ryoji
	// c[o[ Rebar ɓ
	if( m_hwndReBar && m_hwndToolBar ){
		// c[o[̍擾
		DWORD dwBtnSize = ::SendMessage( m_hwndToolBar, TB_GETBUTTONSIZE, 0, 0 );
		DWORD dwRows = ::SendMessage( m_hwndToolBar, TB_GETROWS, 0, 0 );

		// ohݒ肷
		// ȑÕvbgtH[ _WIN32_WINNT >= 0x0600 Œ`\̂̃tTCYnƎs	// 2007.12.21 ryoji
		rbBand.cbSize = CCSIZEOF_STRUCT( REBARBANDINFO, wID );
		rbBand.fMask  = RBBIM_STYLE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_SIZE;
		rbBand.fStyle = RBBS_CHILDEDGE;
		rbBand.hwndChild  = m_hwndToolBar;	// c[o[
		rbBand.cxMinChild = 0;
		rbBand.cyMinChild = HIWORD(dwBtnSize) * dwRows;
		rbBand.cx         = 250;

		// ohǉ
		::SendMessage( m_hwndReBar, RB_INSERTBAND, (WPARAM)-1, (LPARAM)&rbBand );
		::ShowWindow( m_hwndToolBar, SW_SHOW );
	}

	return;
}

void CEditWnd::DestroyToolBar( void )
{
	if( m_hwndToolBar )
	{
		if( m_hwndSearchBox )
		{
			if( m_fontSearchBox )
			{
				::DeleteObject( m_fontSearchBox );
				m_fontSearchBox = NULL;
			}

			::DestroyWindow( m_hwndSearchBox );
			m_hwndSearchBox = NULL;

			m_nCurrentFocus = 0;
		}

		::DestroyWindow( m_hwndToolBar );
		m_hwndToolBar = NULL;

		//if( m_cTabWnd.m_hWnd ) ::UpdateWindow( m_cTabWnd.m_hWnd );
		//if( m_CFuncKeyWnd.m_hWnd ) ::UpdateWindow( m_CFuncKeyWnd.m_hWnd );
	}

	// 2006.06.17 ryoji Rebar j
	if( m_hwndReBar )
	{
		::DestroyWindow( m_hwndReBar );
		m_hwndReBar = NULL;
	}

	return;
}

/*! c[o[̔zu
	@date 2006.12.19 ryoji VK쐬
*/
void CEditWnd::LayoutToolBar( void )
{
	if( m_pShareData->m_Common.m_bDispTOOLBAR ){	/* c[o[\ */
		if( NULL == m_hwndToolBar ){
			CreateToolBar();
		}
	}else{
		DestroyToolBar();
	}
}

/*! Xe[^Xo[̔zu
	@date 2006.12.19 ryoji VK쐬
*/
void CEditWnd::LayoutStatusBar( void )
{
	if( m_pShareData->m_Common.m_bDispSTATUSBAR ){	/* Xe[^Xo[\ */
		if( NULL == m_hwndStatusBar ){
			/* Xe[^Xo[쐬 */
			CreateStatusBar();
		}
	}else{
		/* Xe[^Xo[j */
		DestroyStatusBar();
	}
}

/*! t@NVL[̔zu
	@date 2006.12.19 ryoji VK쐬
*/
void CEditWnd::LayoutFuncKey( void )
{
	BOOL		bSizeBox;

	if( m_pShareData->m_Common.m_bDispFUNCKEYWND ){	/* t@NVL[\ */
		if( NULL == m_CFuncKeyWnd.m_hWnd ){
			if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 0 ){	/* t@NVL[\ʒu^0: 1: */
				bSizeBox = FALSE;
			}else{
				bSizeBox = TRUE;
				/* Xe[^Xo[Ƃ̓TCY{bNX\Ȃ */
				if( NULL != m_hwndStatusBar ){
					bSizeBox = FALSE;
				}
			}
			m_CFuncKeyWnd.Open( m_hInstance, m_hWnd, &m_cEditDoc, bSizeBox );
		}
	}else{
		m_CFuncKeyWnd.Close();
	}
}

/*! ^uo[̔zu
	@date 2006.12.19 ryoji VK쐬
*/
void CEditWnd::LayoutTabBar( void )
{
	if( m_pShareData->m_Common.m_bDispTabWnd ){	/* ^uo[\ */
		if( NULL == m_cTabWnd.m_hWnd ){
			m_cTabWnd.Open( m_hInstance, m_hWnd );
		}
	}else{
		m_cTabWnd.Close();
	}
}

/*! o[̔zuI
	@date 2006.12.19 ryoji VK쐬
	@data 2007.03.04 ryoji vr[̓o[B
*/
void CEditWnd::EndLayoutBars( BOOL bAdjust/* = TRUE*/ )
{
	int nCmdShow = m_pPrintPreview? SW_HIDE: SW_SHOW;
	HWND hwndToolBar = (NULL != m_hwndReBar)? m_hwndReBar: m_hwndToolBar;
	if( NULL != hwndToolBar )
		::ShowWindow( hwndToolBar, nCmdShow );
	if( NULL != m_hwndStatusBar )
		::ShowWindow( m_hwndStatusBar, nCmdShow );
	if( NULL != m_CFuncKeyWnd.m_hWnd )
		::ShowWindow( m_CFuncKeyWnd.m_hWnd, nCmdShow );
	if( NULL != m_cTabWnd.m_hWnd )
		::ShowWindow( m_cTabWnd.m_hWnd, nCmdShow );

	if( bAdjust )
	{
		RECT		rc;
		m_cEditDoc.m_cSplitterWnd.DoSplit( -1, -1 );
		::GetClientRect( m_hWnd, &rc );
		::SendMessage( m_hWnd, WM_SIZE, m_nWinSizeType, MAKELONG( rc.right - rc.left, rc.bottom - rc.top ) );
		::RedrawWindow( m_hWnd, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW );	// Xe[^Xo[ɕKvH

		m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].SetIMECompFormPos();
	}
}


//vZX
/* bZ[W[v */
void CEditWnd::MessageLoop( void )
{
	MSG	msg;
	int ret;
	
#ifndef SAKAIHDT_FIX
	HACCEL hAccel = CKeyBind::CreateAccerelator(
		m_pShareData->m_nKeyNameArrNum,
		m_pShareData->m_pKeyNameArr );
#endif /* SAKAI_FIX */


	//2004.02.17 Moca GetMessagẽG[`FbN
	while ( NULL != m_hWnd && ( ret = GetMessage( &msg, NULL, 0, 0 ) ) ){
		if( ret == -1 ){
			break;
		}

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		if( m_pPrintPreview && NULL != m_pPrintPreview->GetPrintPreviewBarHANDLE() && ::IsDialogMessage( m_pPrintPreview->GetPrintPreviewBarHANDLE(), &msg ) ){	/* vr[ o[ */
		}else
		if( NULL != m_cEditDoc.m_cDlgFind.m_hWnd && ::IsDialogMessage( m_cEditDoc.m_cDlgFind.m_hWnd, &msg ) ){	/* uv_CAO */
		}else
		if( NULL != m_cEditDoc.m_cDlgFuncList.m_hWnd && ::IsDialogMessage( m_cEditDoc.m_cDlgFuncList.m_hWnd, &msg ) ){	/* uAEgCv_CAO */
		}else
		if( NULL != m_cEditDoc.m_cDlgReplace.m_hWnd && ::IsDialogMessage( m_cEditDoc.m_cDlgReplace.m_hWnd, &msg ) ){	/* uuv_CAO */
		}else
		if( NULL != m_cEditDoc.m_cDlgGrep.m_hWnd && ::IsDialogMessage( m_cEditDoc.m_cDlgGrep.m_hWnd, &msg ) ){	/* uGrepv_CAO */
		}else
		if( NULL != m_cEditDoc.m_cHokanMgr.m_hWnd && ::IsDialogMessage( m_cEditDoc.m_cHokanMgr.m_hWnd, &msg ) ){	/* u͕⊮v */
		}else
		if( NULL != m_hwndSearchBox && ::IsDialogMessage( m_hwndSearchBox, &msg ) ){	/* u{bNXv */
			ProcSearchBox( &msg );
		}else
		{
#ifndef SAKAIHDT_FIX
			if( NULL != hAccel ){
				if( TranslateAccelerator( msg.hwnd, hAccel, &msg ) ){
				}else{
					TranslateMessage( &msg );
					DispatchMessage( &msg );
				}
			}else{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
#else /* SAKAIHDT_FIX */
			if( NULL != m_pShareData->m_hAccel ){
				if( TranslateAccelerator( msg.hwnd, m_pShareData->m_hAccel, &msg ) ){
				}else{
					TranslateMessage( &msg );
					DispatchMessage( &msg );
				}
			}else{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
#endif /* SAKAIHDT_FIX */
		}
	}

#ifndef SAKAIHDT_FIX
	DestroyAcceleratorTable( hAccel );
#endif /* SAKAI_FIX */


	return;
}


LRESULT CEditWnd::DispatchEvent(
	HWND	hwnd,	// handle of window
	UINT	uMsg,	// message identifier
	WPARAM	wParam,	// first message parameter
	LPARAM	lParam 	// second message parameter
)
{
	int					nRet;
	int					idCtrl;
	LPNMHDR				pnmh;
	LPTOOLTIPTEXT		lptip;
	int					nPane;
	FileInfo*			pfi;
	int					nCaretPosX;
	int					nCaretPosY;
	POINT*				ppoCaret;
	LPHELPINFO			lphi;
	const char*			pLine;
	int					nLineLen;

	UINT				idCtl;	/* Rg[ID */
	MEASUREITEMSTRUCT*	lpmis;
	LPDRAWITEMSTRUCT	lpdis;	/* ڕ` */
	int					nItemWidth;
	int					nItemHeight;
	UINT				uItem;
	UINT				fuFlags;
	HMENU				hmenu;
	const char*			pszItemStr;
	LRESULT				lRes;

	switch( uMsg ){
	case WM_PAINTICON:
//		MYTRACE( "WM_PAINTICON\n" );
		return 0;
	case WM_ICONERASEBKGND:
//		MYTRACE( "WM_ICONERASEBKGND\n" );
		return 0;
	case WM_LBUTTONDOWN:
		return OnLButtonDown( wParam, lParam );
	case WM_MOUSEMOVE:
		return OnMouseMove( wParam, lParam );
	case WM_LBUTTONUP:
		return OnLButtonUp( wParam, lParam );
	case WM_MOUSEWHEEL:
		return OnMouseWheel( wParam, lParam );
	case WM_HSCROLL:
		return OnHScroll( wParam, lParam );
	case WM_VSCROLL:
		return OnVScroll( wParam, lParam );


	case WM_MENUCHAR:
		/* j[ANZXL[̏(WM_MENUCHAR) */
		return m_CMenuDrawer.OnMenuChar( hwnd, uMsg, wParam, lParam );

	// From Here 2007.09.09 Moca ݊BMPɂʃobt@
	case WM_SHOWWINDOW:
	if( FALSE == (BOOL)wParam ){
		m_cEditDoc.DeleteCompatibleBitmap();
	}
	return ::DefWindowProc( hwnd, uMsg, wParam, lParam );
	// To Here 2007.09.09 Moca

	case WM_MENUSELECT:
		if( NULL == m_hwndStatusBar ){
			return 1;
		}
		uItem = (UINT) LOWORD(wParam);		// menu item or submenu index
		fuFlags = (UINT) HIWORD(wParam);	// menu flags
		hmenu = (HMENU) lParam;				// handle to menu clicked
		{
			/* j[@\̃eLXgZbg */
			CMemory		cmemWork;
			pszItemStr = "";

			/* @\ɑΉL[̎擾() */
			CMemory**	ppcAssignedKeyList;
			int			nAssignedKeyNum;
			int			j;
			nAssignedKeyNum = CKeyBind::GetKeyStrList(
				m_hInstance, m_pShareData->m_nKeyNameArrNum,
				(KEYDATA*)m_pShareData->m_pKeyNameArr, &ppcAssignedKeyList, uItem
			);
			if( 0 < nAssignedKeyNum ){
				for( j = 0; j < nAssignedKeyNum; ++j ){
					if( j > 0 ){
						cmemWork.AppendSz( " , " );
					}
					cmemWork.Append( ppcAssignedKeyList[j] );
					delete ppcAssignedKeyList[j];
				}
				delete [] ppcAssignedKeyList;
			}
			pszItemStr = cmemWork.GetPtr();


			::SendMessage( m_hwndStatusBar, SB_SETTEXT, 0 | SBT_NOBORDERS, (LPARAM) (LPINT)pszItemStr );


		}
		return 0;


	case WM_DRAWITEM:
		idCtl = (UINT) wParam;				/* Rg[ID */
		lpdis = (DRAWITEMSTRUCT*) lParam;	/* ڕ` */
		if( IDW_STATUSBAR == idCtl ){
			if( 5 == lpdis->itemID ){ // 2003.08.26 Moca idč悳Ȃ
				int	nColor;
				if( m_pShareData->m_bRecordingKeyMacro	/* L[{[h}N̋L^ */
				 && m_pShareData->m_hwndRecordingKeyMacro == m_hWnd	/* L[{[h}NL^̃EBhE */
				){
					nColor = COLOR_BTNTEXT;
				}else{
					nColor = COLOR_3DSHADOW;
				}
				::SetTextColor( lpdis->hDC, ::GetSysColor( nColor ) );
				::SetBkMode( lpdis->hDC, TRANSPARENT );
				
				// 2003.08.26 Moca ㉺ʒuɍ
				TEXTMETRIC tm;
				::GetTextMetrics( lpdis->hDC, &tm );
				int y = ( lpdis->rcItem.bottom - lpdis->rcItem.top - tm.tmHeight + 1 ) / 2 + lpdis->rcItem.top;
				::TextOut( lpdis->hDC, lpdis->rcItem.left, y, "REC", lstrlen( "REC" ) );
				if( COLOR_BTNTEXT == nColor ){
					::TextOut( lpdis->hDC, lpdis->rcItem.left + 1, y, "REC", lstrlen( "REC" ) );
				}
			}
			return 0;
		}else{
			switch( lpdis->CtlType ){
			case ODT_MENU:	/* I[i[`惁j[ */
				/* j[ACe` */
				m_CMenuDrawer.DrawItem( lpdis );
				return TRUE;
			}
		}
		return FALSE;
	case WM_MEASUREITEM:
		idCtl = (UINT) wParam;					// control identifier
		lpmis = (MEASUREITEMSTRUCT*) lParam;	// item-size information
		switch( lpmis->CtlType ){
		case ODT_MENU:	/* I[i[`惁j[ */
//			CMenuDrawer* pCMenuDrawer;
//			pCMenuDrawer = (CMenuDrawer*)lpmis->itemData;


//			MYTRACE( "WM_MEASUREITEM  lpmis->itemID=%d\n", lpmis->itemID );
			/* j[ACe̕`TCYvZ */
			nItemWidth = m_CMenuDrawer.MeasureItem( lpmis->itemID, &nItemHeight );
			if( -1 == nItemWidth ){
			}else{
				lpmis->itemWidth = nItemWidth;
				lpmis->itemHeight = nItemHeight;
			}
			return TRUE;
		}
		return FALSE;




	case WM_PAINT:
		return OnPaint( hwnd, uMsg, wParam, lParam );

	case WM_PASTE:
		return m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].HandleCommand( F_PASTE, TRUE, 0, 0, 0, 0 );

	case WM_COPY:
		return m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].HandleCommand( F_COPY, TRUE, 0, 0, 0, 0 );

	case WM_HELP:
		lphi = (LPHELPINFO) lParam;
		switch( lphi->iContextType ){
		case HELPINFO_MENUITEM:
			OnHelp_MenuItem( hwnd, lphi->iCtrlId );
			break;
		}
		return TRUE;

	case WM_ACTIVATEAPP:
		m_bIsActiveApp = (BOOL)wParam;	// AvANeBuǂ

		// ANeBuȂҏWEBhEXg̐擪Ɉړ		// 2007.04.08 ryoji WM_SETFOCUS ړ
		if( m_bIsActiveApp ){
			CShareData::getInstance()->AddEditWndList( m_hWnd );	// Xgړ

			// 2009.01.12 nasukoji	zC[XN[LԂNA
			ClearMouseState();
		}

		// LvVݒA^C}[ON/OFF		// 2007.03.08 ryoji WM_ACTIVATEړ
		m_cEditDoc.SetParentCaption();
		m_CFuncKeyWnd.Timer_ONOFF( m_bIsActiveApp ); // 20060126 aroka
		this->Timer_ONOFF( m_bIsActiveApp ); // 20060128 aroka

		return 0L;

	case WM_ENABLE:
		// Ehbvt@C̎󂯓ݒ^	// 2009.01.09 ryoji
		// Note: DragAcceptFilesKphbvɂĂ Enable/Disable ŎIɎ󂯓ݒ^؂ւ
		if( (BOOL)wParam ){
			m_pcDropTarget->Register_DropTarget( m_hWnd );
		}else{
			m_pcDropTarget->Revoke_DropTarget();
		}
		return 0L;

	case WM_WINDOWPOSCHANGED:
		// |bvAbvEBhE̕\ؑ֎w|Xg	// 2007.10.22 ryoji
		// EWM_SHOWWINDOWׂ͂Ă̕\ؑւŌĂ΂킯ł͂Ȃ̂WM_WINDOWPOSCHANGEDŏ
		//   i^uO[vȂǂ̐ݒύXWM_SHOWWINDOW͌Ă΂Ȃj
		// Eؑւƃ^uؑւɊČ̃^uɖ߂Ă܂Ƃ̂ŌŐ؂ւ
		WINDOWPOS* pwp;
		pwp = (WINDOWPOS*)lParam;
		if( pwp->flags & SWP_SHOWWINDOW )
			::PostMessage( hwnd, MYWM_SHOWOWNEDPOPUPS, TRUE, 0 );
		else if( pwp->flags & SWP_HIDEWINDOW )
			::PostMessage( hwnd, MYWM_SHOWOWNEDPOPUPS, FALSE, 0 );

		return ::DefWindowProc( hwnd, uMsg, wParam, lParam );

	case MYWM_SHOWOWNEDPOPUPS:
		::ShowOwnedPopups( m_hWnd, (BOOL)wParam );	// 2007.10.22 ryoji
		return 0L;

	case WM_SIZE:
//		MYTRACE( "WM_SIZE\n" );
		/* WM_SIZE  */
		if( SIZE_MINIMIZED == wParam ){
			m_cEditDoc.SetParentCaption();
		}
		return OnSize( wParam, lParam );

	//From here 2003.05.31 MIK
	case WM_MOVE:
		// From Here 2004.05.13 Moca EBhEʒup
		//	Ō̈ʒu𕜌邽߁Cړ邽тɋLɈʒuۑD
		if( WINSIZEMODE_SAVE == m_pShareData->m_Common.m_nSaveWindowPos ){
			if( !::IsZoomed( m_hWnd ) && !::IsIconic( m_hWnd ) ){
				// 2005.11.23 Moca [NGAWƂ̂ŃXN[WɕύX
				RECT rcWork;
				::GetWindowRect( hwnd, &rcWork);
				m_pShareData->m_Common.m_nWinPosX = rcWork.left;
				m_pShareData->m_Common.m_nWinPosY = rcWork.top;
			}
		}
		// To Here 2004.05.13 Moca EBhEʒup
		return DefWindowProc( hwnd, uMsg, wParam, lParam );
	//To here 2003.05.31 MIK
	case WM_SYSCOMMAND:
		// ^u܂Ƃߕ\ł͕铮̓IvVwɏ]	// 2006.02.13 ryoji
		//	Feb. 11, 2007 genta Iׂ悤(MDIƏ])
		// 2007.02.22 ryoji Alt+F4 ̃ftHg@\Ń[h̓삪悤ɂȂ
		if( wParam == SC_CLOSE ){
			// vr[[hŃEBhE鑀̂Ƃ̓vr[	// 2007.03.04 ryoji
			if( m_pPrintPreview ){
				PrintPreviewModeONOFF();	// vr[[h̃I/It
				return 0L;
			}
			OnCommand( 0, CKeyBind::GetDefFuncCode( VK_F4, _ALT ), NULL );
			return 0L;
		}
		return DefWindowProc( hwnd, uMsg, wParam, lParam );
	case WM_IME_COMPOSITION:
		if ( lParam & GCS_RESULTSTR ) {
			/* bZ[W̔z */
			return m_cEditDoc.DispatchEvent( hwnd, uMsg, wParam, lParam );
		}else{
			return DefWindowProc( hwnd, uMsg, wParam, lParam );
		}
	//case WM_KILLFOCUS:
	case WM_CHAR:
	case WM_IME_CHAR:
	case WM_KEYUP:
	case WM_SYSKEYUP:	// 2004.04.28 Moca ALT+L[̃L[s[ĝߒǉ
	case WM_ENTERMENULOOP:
	case MYWM_IME_REQUEST:   /*  ĕϊΉ by minfu 2002.03.27  */ // 20020331 aroka
		/* bZ[W̔z */
		return m_cEditDoc.DispatchEvent( hwnd, uMsg, wParam, lParam );

	case WM_EXITMENULOOP:
//		MYTRACE( "WM_EXITMENULOOP\n" );
		if( NULL != m_hwndStatusBar ){
			::SendMessage( m_hwndStatusBar, SB_SETTEXT, 0 | SBT_NOBORDERS, (LPARAM) (LPINT)"" );
		}

		/* bZ[W̔z */
		return m_cEditDoc.DispatchEvent( hwnd, uMsg, wParam, lParam );
	case WM_SETFOCUS:
//		MYTRACE( "WM_SETFOCUS\n" );

		// Aug. 29, 2003 wmlhq & ryojit@C̃^CX^ṽ`FbN OnTimer Ɉڍs
		m_nTimerCount = 9;

		// r[ɃtH[JXړ	// 2007.10.16 ryoji
		::SetFocus( m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_hWnd );
		lRes = 0;

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		/* vr[[ĥƂ́AL[͑SPrintPreviewBar֓] */
		if( m_pPrintPreview ){
			m_pPrintPreview->SetFocusToPrintPreviewBar();
		}

		//{bNXXV
		if( m_hwndSearchBox )
		{
			int	i;
			::SendMessage( m_hwndSearchBox, CB_RESETCONTENT, 0, 0 );
			for( i = 0; i < m_pShareData->m_nSEARCHKEYArrNum; i++ )
			{
				::SendMessage( m_hwndSearchBox, CB_ADDSTRING, 0, (LPARAM)m_pShareData->m_szSEARCHKEYArr[i] );
			}
			::SendMessage( m_hwndSearchBox, CB_SETCURSEL, 0, 0 );
		}
		
		return lRes;


	case WM_NOTIFY:
		idCtrl = (int) wParam;
		pnmh = (LPNMHDR) lParam;
		//	From Here Feb. 15, 2004 genta 
		//	Xe[^Xo[̃_uNbNŃ[hؑւł悤ɂ
		if( m_hwndStatusBar && pnmh->hwndFrom == m_hwndStatusBar ){
			if( pnmh->code == NM_DBLCLK ){
				LPNMMOUSE mp = (LPNMMOUSE) lParam;
				if( mp->dwItemSpec == 6 ){	//	㏑/}
					m_cEditDoc.HandleCommand( F_CHGMOD_INS );
				}
				else if( mp->dwItemSpec == 5 ){	//	}N̋L^JnEI
					m_cEditDoc.HandleCommand( F_RECKEYMACRO );
				}
				else if( mp->dwItemSpec == 1 ){	//	ʒusԍWv
					m_cEditDoc.HandleCommand( F_JUMP_DIALOG );
				}
			}
			else if( pnmh->code == NM_RCLICK ){
				LPNMMOUSE mp = (LPNMMOUSE) lParam;
				if( mp->dwItemSpec == 2 ){	//	͉s[h
					m_CMenuDrawer.ResetContents();
					HMENU hMenuPopUp = ::CreatePopupMenu();
					m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_CRLF, 
						"͉sR[hw(&CRLF)" ); // ͉sR[hw(CRLF)
					m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_LF,
						"͉sR[hw(&LF)" ); // ͉sR[hw(LF)
					m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_CR,
						"͉sR[hw(C&R)" ); // ͉sR[hw(CR)
						
					//	mp->pt̓Xe[^Xo[̍WȂ̂ŁCXN[Wւ̕ϊKv
					POINT	po = mp->pt;
					::ClientToScreen( m_hwndStatusBar, &po );
					int nId = ::TrackPopupMenu(
						hMenuPopUp,
						TPM_CENTERALIGN
						| TPM_BOTTOMALIGN
						| TPM_RETURNCMD
						| TPM_LEFTBUTTON
						,
						po.x,
						po.y,
						0,
						m_hWnd,
						NULL
					);
					::DestroyMenu( hMenuPopUp );
					m_cEditDoc.HandleCommand( nId );
				}
			}
			return 0L;
		}
		//	To Here Feb. 15, 2004 genta 

		switch( pnmh->code ){
		case TTN_NEEDTEXT:
			lptip = (LPTOOLTIPTEXT)pnmh;
			{
				/* c[o[̃c[`bṽeLXgZbg */
				CMemory**	ppcAssignedKeyList;
				int			nAssignedKeyNum;
				int			j;
				char*		pszKey;
				char		szLabel[1024];


				// From Here Oct. 15, 2001 genta
				// @\̎擾Lookupg悤ɕύX
				m_cEditDoc.m_cFuncLookup.Funccode2Name( lptip->hdr.idFrom, szLabel, 1024 );

				// To Here Oct. 15, 2001 genta
				/* @\ɑΉL[̎擾() */
				nAssignedKeyNum = CKeyBind::GetKeyStrList(
					m_hInstance, m_pShareData->m_nKeyNameArrNum,
					(KEYDATA*)m_pShareData->m_pKeyNameArr, &ppcAssignedKeyList, lptip->hdr.idFrom
				);
				if( 0 < nAssignedKeyNum ){
					for( j = 0; j < nAssignedKeyNum; ++j ){
						strcat( szLabel, "\n        " );
						pszKey = ppcAssignedKeyList[j]->GetPtr();
						strcat( szLabel, pszKey );
						delete ppcAssignedKeyList[j];
					}
					delete [] ppcAssignedKeyList;
				}
				lptip->hinst = NULL;
				lptip->lpszText	= szLabel;
			}
			break;

		case TBN_DROPDOWN:
			{
				int	nId;
				nId = CreateFileDropDownMenu( pnmh->hwndFrom );
				if( nId != 0 ) OnCommand( (WORD)0 /*j[*/, (WORD)nId, (HWND)0 );
			}
			return FALSE;
		//	From Here Jul. 21, 2003 genta
		case NM_CUSTOMDRAW:
			if( pnmh->hwndFrom == m_hwndToolBar ){
				//	c[o[Owner Draw
				return ToolBarOwnerDraw( (LPNMCUSTOMDRAW)pnmh );
			}
			break;
		//	To Here Jul. 21, 2003 genta
		}
		return 0L;
	case WM_COMMAND:
		OnCommand( HIWORD(wParam), LOWORD(wParam), (HWND) lParam );
		return 0L;
	case WM_INITMENUPOPUP:
		InitMenu( (HMENU)wParam, (UINT)LOWORD( lParam ), (BOOL)HIWORD( lParam ) );
		return 0L;
	case WM_DROPFILES:
		/* t@Chbvꂽ */
		OnDropFiles( (HDROP) wParam );
		return 0L;
	case WM_QUERYENDSESSION:
		if( OnClose() ){
			DestroyWindow( hwnd );
			return TRUE;
		}else{
			return FALSE;
		}
	case WM_CLOSE:
		if( OnClose() ){
			DestroyWindow( hwnd );
		}
		return 0L;
	case WM_DESTROY:
		if( m_pShareData->m_bRecordingKeyMacro ){					/* L[{[h}N̋L^ */
			if( m_pShareData->m_hwndRecordingKeyMacro == m_hWnd ){	/* L[{[h}NL^̃EBhE */
				m_pShareData->m_bRecordingKeyMacro = FALSE;			/* L[{[h}N̋L^ */
				m_pShareData->m_hwndRecordingKeyMacro = NULL;		/* L[{[h}NL^̃EBhE */
			}
		}

		/* ^C}[폜 */
		::KillTimer( m_hWnd, IDT_TOOLBAR );

		/* hbvꂽt@C󂯓̂ */
		::DragAcceptFiles( hwnd, FALSE );
		m_pcDropTarget->Revoke_DropTarget();	// E{^hbvp	// 2008.06.20 ryoji
		/* ҏWEBhEXg̍폜 */
		CShareData::getInstance()->DeleteEditWndList( m_hWnd );

		if( m_pShareData->m_hwndDebug == m_hWnd ){
			m_pShareData->m_hwndDebug = NULL;
		}
		m_hWnd = NULL;


		/* ҏWEBhEIuWFNg̃IuWFNg폜v */
		::PostMessage( m_pShareData->m_hwndTray, MYWM_DELETE_ME, 0, 0 );

		/* Windows ɃXbh̏Iv܂ */
		::PostQuitMessage( 0 );

		return 0L;

	case WM_THEMECHANGED:
		// 2006.06.17 ryoji
		// rWAX^C^NVbNX^C؂ւc[o[č쐬
		// irWAX^C: Rebar LANVbNX^C: Rebar j
		if( NULL != m_hwndToolBar ){
			if( IsVisualStyle() == (NULL == m_hwndReBar) ){
				DestroyToolBar();
				LayoutToolBar();
				EndLayoutBars();
			}
		}
		return 0L;

	case MYWM_UIPI_CHECK:
		/* GfB^|gCԂłUI̊mFbZ[W */	// 2007.06.07 ryoji
		m_bUIPI = TRUE;	// gC̕Ԏ󂯎
		return 0L;

	case MYWM_CLOSE:
		/* GfB^ւ̏Iv */
		if( FALSE != ( nRet = OnClose()) ){	// Jan. 23, 2002 genta x}
			// ^u܂Ƃߕ\ł͕铮̓IvVwɏ]	// 2006.02.13 ryoji
			if( !(BOOL)wParam ){	// SIvłȂꍇ
				// ^u܂Ƃߕ\()cw̏ꍇAcEBhEPȂVKGfB^NďI
				if( m_pShareData->m_Common.m_bDispTabWnd &&
					!m_pShareData->m_Common.m_bDispTabWndMultiWin &&
					m_pShareData->m_Common.m_bTab_RetainEmptyWin
					){
					// O[v̎cEBhE𒲂ׂ	// 2007.06.20 ryoji
					int nGroup = CShareData::getInstance()->GetGroupId( m_hWnd );
					if( 1 == CShareData::getInstance()->GetEditorWindowsNum( nGroup ) ){
						EditNode* pEditNode = CShareData::getInstance()->GetEditNode( m_hWnd );
						if( pEditNode )
							pEditNode->m_bClosing = TRUE;	// ̓^u\ĂȂĂ
						CEditApp::OpenNewEditor( m_hInstance, m_hWnd, (char*)NULL, 0, FALSE, TRUE );
					}
				}
			}
			DestroyWindow( hwnd );
		}
		return nRet;


	case MYWM_GETFILEINFO:
		/* gCGfB^ւ̕ҏWt@Cvʒm */
		pfi = (FileInfo*)&m_pShareData->m_FileInfo_MYWM_GETFILEINFO;

		/* ҏWt@Ci[ */
		m_cEditDoc.SetFileInfo( pfi );
		return 0L;
	case MYWM_CHANGESETTING:
		/* ݒύX̒ʒm */
// Oct 10, 2000 ao
/* ݒύXAc[o[č쐬悤ɂio[̓eύXfj */
		DestroyToolBar();
		LayoutToolBar();
// Oct 10, 2000 ao ܂

		// 2008.09.23 nasukoji	ANeBuȃEBhẼc[o[XV
		// ANeBuȃEBhE̓^C}ɂXV邪AȊÕEBhE
		// ^C}~ĂݒύXƑSLƂȂĂ܂߁A
		// c[o[XV
		if( !m_bIsActiveApp )
			UpdateToolbar();

		// t@NVL[č쐬io[̓eAʒuAO[v{^̕ύXfj	// 2006.12.19 ryoji
		m_CFuncKeyWnd.Close();
		LayoutFuncKey();

		// ^uo[̕\^\؂ւ	// 2006.12.19 ryoji
		LayoutTabBar();

		// Xe[^Xo[̕\^\؂ւ	// 2006.12.19 ryoji
		LayoutStatusBar();

		// XN[o[̕\^\؂ւ	// 2006.12.19 ryoji
		{
			int i;
			bool b1;
			bool b2;
			b1 = (m_pShareData->m_Common.m_bScrollBarHorz == FALSE);
			for( i = 0; i < 4; i++ )
			{
				b2 = (m_cEditDoc.m_cEditViewArr[i].m_hwndHScrollBar == NULL);
				if( b1 != b2 )		/* XN[o[g */
				{
					m_cEditDoc.m_cEditViewArr[i].DestroyScrollBar();
					m_cEditDoc.m_cEditViewArr[i].CreateScrollBar();
				}
			}
		}

		// o[ύXŉʂȂ悤	// 2006.12.19 ryoji
		EndLayoutBars();

		if( m_pShareData->m_Common.m_bDispTabWnd )
		{
			// ^u\̂܂܃O[v^ȂύXĂ^uXVKv
			m_cTabWnd.Refresh( FALSE );
		}
		if( m_pShareData->m_Common.m_bDispTabWnd && !m_pShareData->m_Common.m_bDispTabWndMultiWin )
		{
			if( CShareData::getInstance()->IsTopEditWnd( m_hWnd ) )
			{
				if( !::IsWindowVisible( m_hWnd ) )
				{
					// ::ShowWindow( m_hWnd, SW_SHOWNA ) Ɣ\\ɐ؂ւƂ Z-order Ȃ邱Ƃ̂ ::SetWindowPos g
					::SetWindowPos( m_hWnd, NULL,0,0,0,0,
									SWP_SHOWWINDOW | SWP_NOACTIVATE
									| SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER );

					// ̃EBhE WS_EX_TOPMOST ԂSEBhEɔf	// 2007.05.18 ryoji
					WindowTopMost( ((DWORD)::GetWindowLongPtr( m_hWnd, GWL_EXSTYLE ) & WS_EX_TOPMOST)? 1: 2 );
				}
			}
			else
			{
				if( ::IsWindowVisible( m_hWnd ) )
				{
					::ShowWindow( m_hWnd, SW_HIDE );
				}
			}
		}
		else
		{
			if( !::IsWindowVisible( m_hWnd ) )
			{
				// ::ShowWindow( m_hWnd, SW_SHOWNA ) Ɣ\\ɐ؂ւƂ Z-order Ȃ邱Ƃ̂ ::SetWindowPos g
				::SetWindowPos( m_hWnd, NULL,0,0,0,0,
								SWP_SHOWWINDOW | SWP_NOACTIVATE
								| SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER );
			}
		}

		//	Aug, 21, 2000 genta
		m_cEditDoc.ReloadAutoSaveParam();

//1999.09.03 ȁ[񂩂܂̂ŁA߂B^pŃJo[ĂقB
//
//t@NVL[ʒuύXƂATCY{bNẌʒuύX
//		m_cEditDoc.m_cSplitterWnd.DoSplit( -1, -1);
//t@NVL[ʒuύXƂAt@NVL[ʒuύX
//		::GetWindowRect( hwnd, &rc );
//		::SetWindowPos( hwnd, 0, 0, 0, rc.right - rc.left, rc.bottom - rc.top + 1, SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER );
//		::SetWindowPos( hwnd, 0, 0, 0, rc.right - rc.left, rc.bottom - rc.top, SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER );
		m_cEditDoc.SetDocumentIcon();	// Sep. 10, 2002 genta ACR̍Đݒ
		m_cEditDoc.OnChangeSetting();	/* r[ɐݒύX𔽉f */
		return 0L;
	case MYWM_SETACTIVEPANE:
		if( -1 == (int)wParam ){
			if( 0 == lParam ){
				nPane = m_cEditDoc.m_cSplitterWnd.GetFirstPane();
			}else{
				nPane = m_cEditDoc.m_cSplitterWnd.GetLastPane();
			}
		}
		m_cEditDoc.SetActivePane( nPane );
		return 0L;


	case MYWM_SETCARETPOS:	/* J[\ʒuύXʒm */
		{
			//	2006.07.09 genta LPARAMɐVȈӖǉ
			//	bit 0 (MASK 1): (bit 1==0̂Ƃ) 0/INA, 1/IJnEύX
			//	bit 1 (MASK 2): 0: bit 0̐ݒɏ]D1:݂̑IbNsԂp
			//	̎ł ǂ0Ȃ̂ŋƉ߂D
			//	Ăяoe_PM_SETCARETPOS_SELECTSTATE̒lgƁD
			int bSelect = lParam & 1;
			if( lParam & 2 ){
				// ݂̏ԂKEEP
				bSelect = m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_bSelectingLock;
			}
			
			ppoCaret = (POINT*)m_pShareData->m_szWork;
			//	2006.07.09 genta Ȃ
			/*
			J[\ʒuϊ
			 ʒu(s̃oCgA܂Ԃsʒu)
			
			 CAEgʒu(s̕\ʒuA܂Ԃsʒu)
			*/
			m_cEditDoc.m_cLayoutMgr.CaretPos_Phys2Log(
				ppoCaret->x,
				ppoCaret->y,
				&nCaretPosX,
				&nCaretPosY
			);
			// s̐^񒆂ɃJ[\Ȃ悤	// 2007.08.22 ryoji
			// Note. ƂsPʂ̌ʒuȂ̂ŃCAEg܂Ԃ̌ʒu𒴂邱Ƃ͂ȂB
			//       Iw(bSelect==TRUE)̏ꍇɂ͂ǂ̂Ó悭킩ȂA
			//       2007.08.22݂ł̓AEgC̓_CAO猅ʒu0ŌĂяo
			//       p^[Ȃ̂Ŏpɖ͖B
			if( !bSelect ){
				const CDocLine *pTmpDocLine = m_cEditDoc.m_cDocLineMgr.GetLineInfo( ppoCaret->y );
				if( pTmpDocLine ){
					if( pTmpDocLine->GetLengthWithoutEOL() < ppoCaret->x ) nCaretPosX--;
				}
			}
			//	2006.07.09 genta I͈͂lĈړ
			//	MoveCursor̈ʒu@\̂ŁCŏIsȍ~ւ
			//	ړw̒MoveCursorɂ܂
			m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].MoveCursorSelecting( nCaretPosX, nCaretPosY, bSelect, _CARETMARGINRATE / 3 );
		}
		return 0L;


	case MYWM_GETCARETPOS:	/* J[\ʒu擾v */
		ppoCaret = (POINT*)m_pShareData->m_szWork;
		/*
		J[\ʒuϊ
		 CAEgʒu(s̕\ʒuA܂Ԃsʒu)
		
		ʒu(s̃oCgA܂Ԃsʒu)
		*/
		m_cEditDoc.m_cLayoutMgr.CaretPos_Log2Phys(
			m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nCaretPosX,
			m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nCaretPosY,
			(int*)&ppoCaret->x,
			(int*)&ppoCaret->y
		);
		return 0L;

	case MYWM_GETLINEDATA:	/* s(sP)f[^̗v */
		pLine = m_cEditDoc.m_cDocLineMgr.GetLineStr( (int)wParam, &nLineLen );
		if( NULL == pLine ){
			return 0;
		}
		if( nLineLen > sizeof( m_pShareData->m_szWork ) ){
			memcpy( m_pShareData->m_szWork, pLine, sizeof( m_pShareData->m_szWork ) );
		}else{
			memcpy( m_pShareData->m_szWork, pLine, nLineLen );
		}
		return nLineLen;


	case MYWM_ADDSTRING:
//		MYTRACE( "MYWM_ADDSTRING[%s]\n", m_pShareData->m_szWork );
		m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].HandleCommand( F_ADDTAIL, TRUE, (LPARAM)m_pShareData->m_szWork, (LPARAM)lstrlen( m_pShareData->m_szWork ), 0, 0 );
		m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].HandleCommand( F_GOFILEEND, TRUE, 0, 0, 0, 0 );
		return 0L;
// 2004/06/21 novice ^OWv@\ǉ
#if 0
	case MYWM_SETREFERER:
		ppoCaret = (POINT*)m_pShareData->m_szWork;

		m_cEditDoc.SetReferer( (HWND)wParam, ppoCaret->x, ppoCaret->y );
		return 0L;
#endif

	//^uEChE	//@@@ 2003.05.31 MIK
	case MYWM_TAB_WINDOW_NOTIFY:
		m_cTabWnd.TabWindowNotify( wParam, lParam );
		return 0L;

	//o[̕\E\	//@@@ 2003.06.10 MIK
	case MYWM_BAR_CHANGE_NOTIFY:
		if( m_hWnd != (HWND)lParam )
		{
			switch( wParam )
			{
			case MYBCN_TOOLBAR:
				LayoutToolBar();	// 2006.12.19 ryoji
				break;
			case MYBCN_FUNCKEY:
				LayoutFuncKey();	// 2006.12.19 ryoji
				break;
			case MYBCN_TAB:
				LayoutTabBar();		// 2006.12.19 ryoji
				if( m_pShareData->m_Common.m_bDispTabWnd
					&& !m_pShareData->m_Common.m_bDispTabWndMultiWin )
				{
					::ShowWindow(m_hWnd, SW_HIDE);
				}
				else
				{
					// ::ShowWindow( hwnd, SW_SHOWNA ) Ɣ\\ɐ؂ւƂ Z-order Ȃ邱Ƃ̂ ::SetWindowPos g
					::SetWindowPos( hwnd, NULL,0,0,0,0,
									SWP_SHOWWINDOW | SWP_NOACTIVATE
									| SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER );
				}
				break;
			case MYBCN_STATUSBAR:
				LayoutStatusBar();		// 2006.12.19 ryoji
				break;
			}
			EndLayoutBars();	// 2006.12.19 ryoji
		}
		return 0L;

	//by S (2) MYWM_CHECKSYSMENUDBLCLK͕sv, WM_LBUTTONDBLCLKǉ
	case WM_NCLBUTTONDOWN:
		return OnNcLButtonDown(wParam, lParam);

	case WM_NCLBUTTONUP:
		return OnNcLButtonUp(wParam, lParam);

	case WM_LBUTTONDBLCLK:
		return OnLButtonDblClk(wParam, lParam);

	case WM_IME_NOTIFY:	// Nov. 26, 2006 genta
		if( wParam == IMN_SETCONVERSIONMODE || wParam == IMN_SETOPENSTATUS){
			m_cEditDoc.ActiveView().ShowEditCaret();
		}
		return DefWindowProc( hwnd, uMsg, wParam, lParam );

	case WM_NCACTIVATE:
		// ҏWEBhEؑ֒i^u܂Ƃߎj̓^Cgo[̃ANeBu^ANeBuԂł邾ύXȂ悤ɁiPj	// 2007.04.03 ryoji
		// Oʂɂ̂ҏWEBhEȂANeBuԂێ
		if( m_pShareData->m_bEditWndChanging && CShareData::IsEditWnd(::GetForegroundWindow()) ){
			wParam = TRUE;	// ANeBu
		}
		return DefWindowProc( hwnd, uMsg, wParam, lParam );

	case WM_SETTEXT:
		// ҏWEBhEؑ֒i^u܂Ƃߎj̓^Cgo[̃ANeBu^ANeBuԂł邾ύXȂ悤ɁiQj	// 2007.04.03 ryoji
		// ^C}[gpă^Cg̕ύXx
		if( m_pShareData->m_bEditWndChanging ){
			delete []m_pszLastCaption;
			m_pszLastCaption = new TCHAR[ ::lstrlen((LPCTSTR)lParam) + 1 ];
			::lstrcpy( m_pszLastCaption, (LPCTSTR)lParam );	// ύX̃^CgLĂ
			::SetTimer( m_hWnd, IDT_CAPTION, 50, NULL );
			return 0L;
		}
		return DefWindowProc( hwnd, uMsg, wParam, lParam );

	case WM_TIMER:
		if( !OnTimer(wParam, lParam) )
			return 0L;
		return DefWindowProc( hwnd, uMsg, wParam, lParam );

	default:
// << 20020331 aroka ĕϊΉ for 95/NT
		if( uMsg == m_uMSIMEReconvertMsg || uMsg == m_uATOKReconvertMsg){
			return m_cEditDoc.DispatchEvent( hwnd, uMsg, wParam, lParam );
		}
// >> by aroka
		return DefWindowProc( hwnd, uMsg, wParam, lParam );
	}
}

/*! Ȉ

	@retval TRUE: Iėǂ / FALSE: IȂ
*/
int	CEditWnd::OnClose( void )
{
	/* EBhEANeBuɂ */
	/* ANeBuɂ */
//	ActivateFrameWindow( m_hWnd );	//폜(KvȂOnFileClose)	@@@ 2003.06.25 MIK
//	if( ::IsIconic( m_hWnd ) ){
//		::ShowWindow( m_hWnd, SW_RESTORE );
//	}else{
//		::ShowWindow( m_hWnd, SW_SHOW );
//	}
//	::SetForegroundWindow( m_hWnd );
//	::SetActiveWindow( m_hWnd );
	/* t@CƂMRUo^ & ۑmF & ۑs */
	int nRet = m_cEditDoc.OnFileClose();
	if( !nRet ) return nRet;

	// 2005.09.01 ryoji ^u܂Ƃߕ\̏ꍇ͎̃EBhEOʂɁiĨEBhE}j

	// 2007.07.07 ryoji
	// Note. ^u܂Ƃ߂łȂꍇɂȉ̏ʂĂ̂́AȑOA^u܂Ƃߐݒ𓯊ĂȂƂ̖cłB
	//       i^u܂Ƃ߉Ă\̂܂܂ɂȂĂEBhE\ɖ߂Kvj
	//       ɂĂ錻݂ł́AɕsĔ\ɂȂĂꍇł\ɖ߂AƂیIȈӖ܂B

	int i, j;
	EditNode*	p = NULL;
	int nCount = CShareData::getInstance()->GetOpenedWindowArr( &p, FALSE );
	if( nCount > 1 )
	{
		for( i = 0; i < nCount; i++ )
		{
			if( p[ i ].m_hWnd == m_hWnd )
				break;
		}
		if( i < nCount )
		{
			for( j = i + 1; j < nCount; j++ )
			{
				if( p[ j ].m_nGroup == p[ i ].m_nGroup )
					break;
			}
			if( j >= nCount )
			{
				for( j = 0; j < i; j++ )
				{
					if( p[ j ].m_nGroup == p[ i ].m_nGroup )
						break;
				}
			}
			if( j != i )
			{
				HWND hwnd = p[ j ].m_hWnd;
				{
					// 2006.01.28 ryoji
					// ^u܂Ƃߕ\ł̉ʂ\\ɕςĂꍇ(^u̒NbN)A
					// ȑÕEBhEɈCɂ܂ŏił܂
					// Ƃŉʂ̂ŁAȑÕEBhÊƂ҂
					if( m_pShareData->m_Common.m_bDispTabWnd
						&& !m_pShareData->m_Common.m_bDispTabWndMultiWin )
					{
						int iWait = 0;
						while( ::IsWindowVisible( hwnd ) && iWait++ < 20 )
							::Sleep(1);
					}
				}
				if( !::IsWindowVisible( hwnd ) )
				{
					ActivateFrameWindow( hwnd );
				}
			}
		}
	}
	if( p ) delete []p;

	return nRet;
}






void CEditWnd::OnCommand( WORD wNotifyCode, WORD wID , HWND hwndCtl )
{
//	MYTRACE( "CEditWnd::OnCommand()\n" );

	int				nFuncCode;
	HWND			hwndWork;

	switch( wNotifyCode ){
	/* j[̃bZ[W */
	case 0:
	case CMD_FROM_MOUSE: // 2006.05.19 genta }EXĂтꂽꍇ
		switch( wID ){
		case F_EXITALL:	//Dec. 26, 2000 JEPRO F_ɕύX
			/* TNGfB^̑SI */
			CEditApp::TerminateApplication( m_hWnd );	// 2006.12.25 ryoji ǉ
			break;
//Sept. 15, 2000Nov. 25, 2000 JEPRO //V[gJbgL[܂Ȃ̂ŎEĂ2sCE
		case F_HELP_CONTENTS:
			/* wvڎ */
			{
				char	szHelp[_MAX_PATH + 1];
				/* wvt@C̃tpXԂ */
				::GetHelpFilePath( szHelp );
				ShowWinHelpContents( m_hWnd, szHelp );	//	ڎ\
			}
			break;
		case F_HELP_SEARCH:
			/* wvL[[h */
			{
				char	szHelp[_MAX_PATH + 1];
				/* wvt@C̃tpXԂ */
				::GetHelpFilePath( szHelp );
				MyWinHelp( m_hWnd, szHelp, HELP_KEY, (ULONG_PTR)"" );	// 2006.10.10 ryoji MyWinHelpɕύXɕύX
			}
			break;
		case F_ABOUT:	//Dec. 25, 2000 JEPRO F_ɕύX
			/* o[W */
			{
				CDlgAbout cDlgAbout;
				cDlgAbout.DoModal( m_hInstance, m_hWnd );
			}
			break;
		default:
			if( wID - IDM_SELWINDOW >= 0 &&
				wID - IDM_SELWINDOW < m_pShareData->m_nEditArrNum ){
				hwndWork = m_pShareData->m_pEditArr[wID - IDM_SELWINDOW].m_hWnd;
				
				/* ANeBuɂ */
				ActivateFrameWindow( hwndWork );
			}else
			if( wID - IDM_SELMRU >= 0 &&
				wID - IDM_SELMRU < 999
			){
				/* wt@CJĂ邩ׂ */
//@@@ 2001.12.26 YAZAKI MRUXǵACMRUɈ˗
				CMRU cMRU;
				FileInfo checkFileInfo;
				cMRU.GetFileInfo(wID - IDM_SELMRU, &checkFileInfo);
				//	Oct.  9, 2004 genta ʊ֐
				m_cEditDoc.OpenFile( checkFileInfo.m_szPath, checkFileInfo.m_nCharCode);

			}else
			if( wID - IDM_SELOPENFOLDER >= 0 &&
				wID - IDM_SELOPENFOLDER < 999
			){
				{
					//Stonee, 2001/12/21 UNCłΐڑ݂
//@@@ 2001.12.26 YAZAKI OPENFOLDERXǵACMRUFolderɂׂĈ˗
					CMRUFolder cMRUFolder;
					NetConnect( cMRUFolder.GetPath( wID - IDM_SELOPENFOLDER ) );

					/* ut@CJv_CAO */
					int nCharCode = CODE_AUTODETECT;	/* R[h */
					BOOL bReadOnly = FALSE;
					char		szPath[_MAX_PATH + 3];
					szPath[0] = '\0';
					if( !m_cEditDoc.OpenFileDialog( m_hWnd, cMRUFolder.GetPath(wID - IDM_SELOPENFOLDER), szPath, &nCharCode, &bReadOnly ) ){
						return;
					}
					//	Oct.  9, 2004 genta ʊ֐
					m_cEditDoc.OpenFile( szPath, nCharCode, bReadOnly );
				}
			}else{
				//r[ɃtH[JXړĂ
				if( wID != F_SEARCH_BOX && m_nCurrentFocus == F_SEARCH_BOX )
					::SetFocus( m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_hWnd );

				/* R}hR[hɂ鏈U蕪 */
				//	May 19, 2006 genta ʃrbgn
				m_cEditDoc.HandleCommand( MAKELONG( wID, wNotifyCode ));
			}
			break;
		}
		break;
	/* ANZ[^̃bZ[W */
	case 1:
		//r[ɃtH[JXړĂ
		if( wID != F_SEARCH_BOX && m_nCurrentFocus == F_SEARCH_BOX )
			::SetFocus( m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_hWnd );

		nFuncCode = CKeyBind::GetFuncCode(
			wID,
			m_pShareData->m_nKeyNameArrNum,
			m_pShareData->m_pKeyNameArr
		);
//		MYTRACE( "CEditWnd::OnCommand()  nFuncCode=%d\n", nFuncCode );
		m_cEditDoc.HandleCommand( MAKELONG( nFuncCode, wNotifyCode ) );
		break;

	case CBN_SETFOCUS:
		if( NULL != m_hwndSearchBox && hwndCtl == m_hwndSearchBox )
		{
			m_nCurrentFocus = F_SEARCH_BOX;
		}
		break;

	case CBN_KILLFOCUS:
		if( NULL != m_hwndSearchBox && hwndCtl == m_hwndSearchBox )
		{
			m_nCurrentFocus = 0;

			//tH[JX͂ꂽƂɌL[ɂĂ܂B
			//L[[h擾
			char	szText[_MAX_PATH];
			memset( szText, 0, sizeof(szText) );
			::SendMessage( m_hwndSearchBox, WM_GETTEXT, _MAX_PATH - 1, (LPARAM)szText );
			if( szText[0] )	//L[񂪂
			{
				//L[o^
				CShareData::getInstance()->AddToSearchKeyArr( (const char*)szText );
			}

		}
		break;

	/* Rg[̃bZ[Wɂ͒ʒmR[h */
	default:
		break;
	}
	return;
}



//	L[[hFj[o[
//	Sept.14, 2000 Jepro note: j[o[̍ڂ̃LvV⏇ԐݒȂǂ͈ȉōsĂ炵
//	Sept.16, 2000 Jepro note: ACRƂ̊֘AtCShareData_new2.cppt@CōsĂ
void CEditWnd::InitMenu( HMENU hMenu, UINT uPos, BOOL fSystemMenu )
{
	int			cMenuItems;
	int			nPos;
	UINT		id;
	UINT		fuFlags;
	int			i;
	BOOL		bRet;
	int			nRowNum;

	HMENU		hMenuPopUp;
	HMENU		hMenuPopUp_2;
	const char*	pszLabel;


	if( hMenu != ::GetSubMenu( ::GetMenu( m_hWnd ), uPos ) ){
		goto end_of_func_IsEnable;
	}


	if( fSystemMenu ){
	}else{
//		MYTRACE( "hMenu=%08xh uPos=%d, fSystemMenu=%s\n", hMenu, uPos, fSystemMenu ? "TRUE":"FALSE" );
		switch( uPos ){
		case 0:
			/* ut@Cvj[ */
			m_CMenuDrawer.ResetContents();
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILENEW			, "VK쐬(&N)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILEOPEN		, "J(&O)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILESAVE		, "㏑ۑ(&S)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILESAVEAS_DIALOG	, "Otĕۑ(&A)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILESAVEALL		, "ׂď㏑ۑ(&Z)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			//	Feb. 28, 2003 genta ۑĕǉD郁j[߂Ɉړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILESAVECLOSE	, "ۑĕ(&E)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WINCLOSE		, "(&C)" );	//Feb. 18, 2001	JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILECLOSE		, "() (&R)" );	//Oct. 17, 2000 jepro LvVuvύX	//Feb. 18, 2001 JEPRO ANZXL[ύX(CB; Blank̈Ӗ)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILECLOSE_OPEN	, "ĊJ(&L)..." );

			// uR[hZbgv|bvAbvj[
			//	Aug. 19. 2003 genta ANZXL[\L𓝈
			hMenuPopUp_2 = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			//	Dec. 4, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN	, "J(&W)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_SJIS, "SJISŊJ(&S)" );		//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_JIS, "JISŊJ(&J)" );			//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_EUC, "EUCŊJ(&E)" );			//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_UNICODE, "UnicodeŊJ(&U)" );	//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_UNICODEBE, "UnicodeBEŊJ(&N)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_UTF8, "UTF-8ŊJ(&8)" );		//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp_2, MF_BYPOSITION | MF_STRING, F_FILE_REOPEN_UTF7, "UTF-7ŊJ(&7)" );		//Nov. 7, 2000 jepro LvV'ŊJ'ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp_2 , "J(&W)" );//Oct. 11, 2000 JEPRO ANZXL[ύX(MH)

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PRINT				, "(&P)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PRINT_PREVIEW		, "vr[(&V)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PRINT_PAGESETUP		, "y[Wݒ(&U)..." );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			// ut@Cv|bvAbvj[
			//hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			//m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PROPERTY_FILE				, "t@C̃vpeB(&T)" );		//Nov. 7, 2000 jepro LvV't@C'ǉ
			//m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "t@C(&R)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_BROWSE						, "uEY(&B)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			/* MRUXg̃t@C̃Xgj[ɂ */
			{
				//@@@ 2001.12.26 YAZAKI MRUXǵACMRUɈ˗
				CMRU cMRU;
				hMenuPopUp = cMRU.CreateMenu( &m_CMenuDrawer );	//	t@Cj[
				if ( cMRU.Length() > 0 ){
					//	ANeBu
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "ŋߎgt@C(&F)" );
				}
				else {
					//	ANeBu
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP | MF_GRAYED, (UINT)hMenuPopUp , "ŋߎgt@C(&F)" );
				}
			}

			/* ŋߎgtH_̃j[쐬 */
			{
				//@@@ 2001.12.26 YAZAKI OPENFOLDERXǵACMRUFolderɂׂĈ˗
				CMRUFolder cMRUFolder;
				hMenuPopUp = cMRUFolder.CreateMenu( &m_CMenuDrawer );
				if (cMRUFolder.Length() > 0){
					//	ANeBu
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "ŋߎgtH_(&D)" );
				}
				else {
					//	ANeBu
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP | MF_GRAYED, (UINT)hMenuPopUp , "ŋߎgtH_(&D)" );
				}
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GROUPCLOSE, "O[v(&G)" );	// O[v	// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXITALLEDITORS, "ҏW̑SI(&Q)" );	//Feb/ 19, 2001 JEPRO ǉ	// 2006.10.21 ryoji \ύX	// 2007.02.13 ryoji F_EXITALLEDITORS
			//	Jun. 9, 2001 genta \tgEFA
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXITALL			, "TNGfB^̑SI(&X)" );	//Sept. 11, 2000 jepro LvVuAvP[VIvύX	//Dec. 26, 2000 JEPRO F_ɕύX
			break;

		case 1:
			/* uҏWvj[ */
			m_CMenuDrawer.ResetContents();
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}
			//	Aug. 19. 2003 genta ANZXL[\L𓝈
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_UNDO		, "ɖ߂(&U)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_REDO		, "蒼(&R)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_CUT			, "؂(&T)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COPY		, "Rs[(&C)" );
			//	Jul, 3, 2000 genta
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COPYLINESASPASSAGE, "SspRs[(&N)" );
			//	Sept. 14, 2000 JEPRO	LvVɁuLtvǉAANZXL[ύX(N.)
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COPYLINESASPASSAGE, "I͈͓SsptRs[(&.)" );
//			Sept. 30, 2000 JEPRO	ptRs[̃ACR쐬̂ŏLj[͏dāuxȑvɂɂ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PASTE		, "\t(&P)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DELETE		, "폜(&D)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SELECTALL	, "ׂđI(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );							/* j[̍ĕϊΉ minfu 2002.04.09 */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_RECONVERT	, "ĕϊ(&R)" );		/* j[̍ĕϊΉ minfu 2002.04.09 */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			//	Aug. 19. 2003 genta ANZXL[\L𓝈
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COPY_CRLF	, "CRLFsŃRs[(&L)" );				//Nov. 9, 2000 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COPY_ADDCRLF	, "܂ԂʒuɉsăRs[(&H)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PASTEBOX	, "`\t(&X)" );					//Sept. 13, 2000 JEPRO ړɔANZXL[t^	//Oct. 22, 2000 JEPRO ANZXL[ύX(PX)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DELETE_BACK	, "J[\O폜(&B)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			// u}v|bvAbvj[
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_INS_DATE, "t(&D)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_INS_TIME, "(&T)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CTRL_CODE_DIALOG, "Rg[R[h(&C)..." );	// 2004.05.06 MIK ...ǉ

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "}(&I)" );

			// uxȑv|bvAbvj[
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WordDeleteToStart	,	"P̍[܂ō폜(&L)" );			//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WordDeleteToEnd	,	"P̉E[܂ō폜(&R)" );			//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_SELECTWORD			,	"݈ʒu̒PI(&W)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WordCut			,	"P؂(&T)" );				//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WordDelete			,	"P폜(&D)" );					//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_LineCutToStart		,	"s܂Ő؂(sP) (&U)" );//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_LineCutToEnd		,	"s܂Ő؂(sP) (&K)" );//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_LineDeleteToStart	,	"s܂ō폜(sP) (&H)" );	//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_LineDeleteToEnd	,	"s܂ō폜(sP) (&E)" );	//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CUT_LINE			,	"s؂(܂ԂP) (&X)" );	//Jan. 16, 2001 JEPRO s(E)֌W̏ւ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_DELETE_LINE		,	"s폜(܂ԂP) (&Y)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_DUPLICATELINE		,	"s̓d(܂ԂP) (&2)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_INDENT_TAB			,	"TABCfg(&A)" );				//Oct. 22, 2000 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_UNINDENT_TAB		,	"tTABCfg(&B)" );			//Oct. 22, 2000 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_INDENT_SPACE		,	"SPACECfg(&S)" );			//Oct. 22, 2000 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_UNINDENT_SPACE		,	"tSPACECfg(&P)" );			//Oct. 22, 2000 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYLINES				, "I͈͓SsRs[(&@)" );		//Sept. 14, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYLINESASPASSAGE		, "I͈͓SsptRs[(&.)" );//Sept. 13, 2000 JEPRO LvVuLtvǉAANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYLINESWITHLINENUMBER, "I͈͓SssԍtRs[(&:)" );//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYFNAME			,	"̃t@CRs[(&-)" );	// 2002/2/3 aroka
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYPATH			,	"̃t@C̃pXRs[(&\\)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_COPYTAG			,	"̃t@C̃pXƃJ[\ʒuRs[(&^)" );
//			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, IDM_TEST_CREATEKEYBINDLIST	, "L[蓖ĈꗗRs[(&Q)" );	//Sept. 15, 2000 JEPRO LvV́u...XgvAANZXL[ύX(KQ)
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WORDSREFERENCE, "Pꃊt@X(&W)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "xȑ(&V)" );

		//From Here Feb. 19, 2001 JEPRO [ړ(M)], [I(R)]j[[ҏW]̃Tuj[ƂĈړ
			// uړv|bvAbvj[
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_UP2		, "J[\ړ(Qs) (&Q)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_DOWN2		, "J[\ړ(Qs) (&K)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WORDLEFT	, "P̍[Ɉړ(&L)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WORDRIGHT	, "P̉E[Ɉړ(&R)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOPREVPARAGRAPH	, "O̒iɈړ(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GONEXTPARAGRAPH	, "̒iɈړ(&Z)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOLINETOP	, "sɈړ(܂ԂP) (&H)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOLINEEND	, "sɈړ(܂ԂP) (&E)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_1PageUp	, "Py[WAbv(&U)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_1PageDown	, "Py[W_E(&D)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOFILETOP	, "t@C̐擪Ɉړ(&T)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOFILEEND	, "t@C̍ŌɈړ(&B)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CURLINECENTER, "J[\sEBhE(&C)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_JUMP_DIALOG, "wsփWv(&J)..." );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_JUMP_SRCHSTARTPOS, "Jnʒu֖߂(&I)" );	// Jnʒu֖߂ 02/06/26 ai
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_JUMPHIST_PREV	, "ړ: O(&P)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_JUMPHIST_NEXT	, "ړ: (&N)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_JUMPHIST_SET	, "݈ʒuړɓo^(&S)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "ړ(&O)" );

			// uIv|bvAbvj[
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_SELECTWORD		, "݈ʒu̒PI(&W)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_SELECTALL		, "ׂđI(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BEGIN_SEL		, "͈͑IJn(&S)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_UP2_SEL		, "(I)J[\ړ(Qs) (&Q)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_DOWN2_SEL		, "(I)J[\ړ(Qs) (&K)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WORDLEFT_SEL	, "(I)P̍[Ɉړ(&L)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_WORDRIGHT_SEL	, "(I)P̉E[Ɉړ(&R)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOPREVPARAGRAPH_SEL	, "(I)O̒iɈړ(&2)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GONEXTPARAGRAPH_SEL	, "(I)̒iɈړ(&8)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOLINETOP_SEL	, "(I)sɈړ(܂ԂP) (&H)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOLINEEND_SEL	, "(I)sɈړ(܂ԂP) (&T)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_1PageUp_Sel	, "(I)Py[WAbv(&U)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_1PageDown_Sel	, "(I)Py[W_E(&D)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOFILETOP_SEL	, "(I)t@C̐擪Ɉړ(&1)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GOFILEEND_SEL	, "(I)t@C̍ŌɈړ(&9)" );

			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			//	Mar. 11, 2004 genta `Ij[Ij[ɓ
			//	̂Ƃ1Ȃ̂
			// u`Iv|bvAbvj[
			// hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BEGIN_BOX	, "`͈͑IJn(&B)" );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_UP_BOX			, "(I)J[\ړ(&)" );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DOWN_BOX		, "(I)J[\ړ(&)" );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_LEFT_BOX		, "(I)J[\ړ(&)" );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_RIGHT_BOX		, "(I)J[\Eړ(&)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_UP2_BOX			, "(I)J[\ړ(Qs) (&Q)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DOWN2_BOX		, "(I)J[\ړ(Qs) (&K)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WORDLEFT_BOX	, "(I)P̍[Ɉړ(&L)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WORDRIGHT_BOX	, "(I)P̉E[Ɉړ(&R)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GOLINETOP_BOX	, "(I)sɈړ(܂ԂP) (&H)" x);
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GOLINEEND_BOX	, "(I)sɈړ(܂ԂP) (&E)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HalfPageUp_Box	, "(I)y[WAbv(&)" );
////			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HalfPageDown_Box, "(I)y[W_E(&)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_1PageUp_Box		, "(I)Py[WAbv(&U)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_1PageDown_Box	, "(I)Py[W_E(&D)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GOFILETOP_BOX	, "(I)t@C̐擪Ɉړ(&T)" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GOFILEEND_BOX	, "(I)t@C̍ŌɈړ(&B)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "I(&S)" );

//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "`I(&E)" );

			// u`v|bvAbvj[
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_LTRIM, "(擪)̋󔒂폜(&L)" );	// 2001.12.06 hor
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_RTRIM, "E()̋󔒂폜(&R)" );	// 2001.12.06 hor
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_SORT_ASC, "Is̏\[g(&A)" );	// 2001.12.06 hor
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_SORT_DESC, "Is̍~\[g(&D)" );	// 2001.12.06 hor
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_MERGE, "Ads̍폜(uniq)(&U)" );			// 2001.12.06 hor
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "`(&K)" );

			break;
		//Feb. 19, 2001 JEPRO [ړ][ړ], [I][ҏW]zɈڂ̂ō폜

//		case 4://case 2: (Oct. 22, 2000 JEPRO [ړ][I]V݂ߔԍ2Vtg)
		case 2://Feb. 19, 2001 JEPRO [ړ][I][ҏW]zɈړߔԍɖ߂
			m_CMenuDrawer.ResetContents();
			/* uϊvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOLOWER				, "(&L)" );			//Sept. 10, 2000 jepro LvVpꂩύX
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOUPPER				, "啶(&U)" );			//Sept. 10, 2000 jepro LvVpꂩύX
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
//	From Here Sept. 18, 2000 JEPRO
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOHANKAKU			, "Spp" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOZENKAKUKATA		, "pSpJ^Ji" );
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOZENKAKUHIRA		, "pSpЂ炪" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOHANKAKU			, "Spp(&F)" );					//Sept. 13, 2000 JEPRO ANZXL[t^
	// From Here 2007.01.24 maru j[̕ѕύXƃANZXL[ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOZENKAKUKATA		, "p{SЂ灨SpEJ^Ji(&Z)" );	//Sept. 13, 2000 JEPRO LvVύX & ANZXL[t^ //Oct. 11, 2000 JEPRO LvVύX
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOZENKAKUHIRA		, "p{SJ^SpEЂ炪(&N)" );	//Sept. 13, 2000 JEPRO LvVύX & ANZXL[t^ //Oct. 11, 2000 JEPRO LvVύX
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOHANEI				, "Spppp(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOZENEI				, "ppSpp(&M)" );				//July. 29, 2001 Misaka ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOHANKATA			, "SpJ^JipJ^Ji(&J)" );		//Aug. 29, 2002 ai
	// To Here 2007.01.24 maru j[̕ѕύXƃANZXL[ǉ
//	To Here Sept. 18, 2000
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HANKATATOZENKAKUKATA, "pJ^JiSpJ^Ji(&K)" );	//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HANKATATOZENKAKUHIRA, "pJ^JiSpЂ炪(&H)" );	//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TABTOSPACE			, "TAB(&S)" );	//Feb. 19, 2001 JEPRO ړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SPACETOTAB			, "󔒁TAB(&T)" );	//#### Stonee, 2001/05/27
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			//uR[hϊv|bvAbv
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_AUTO2SJIS		, "ʁSJISR[hϊ(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_EMAIL			, "E-Mail(JISSJIS)R[hϊ(&M)" );//Sept. 11, 2000 JEPRO LvVɁuE-MailvǉANZXL[ύX(VM:Mail)
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_EUC2SJIS		, "EUCSJISR[hϊ(&W)" );		//Sept. 11, 2000 JEPRO ANZXL[ύX(EW:Work Station)
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_UNICODE2SJIS	, "UnicodeSJISR[hϊ(&U)" );	//Sept. 11, 2000 JEPRO ANZXL[ύXI:shIft
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_UNICODEBE2SJIS	, "UnicodeBESJISR[hϊ(&N)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_UTF82SJIS		, "UTF-8SJISR[hϊ(&T)" );	//Sept. 11, 2000 JEPRO ANZXL[t^(T:uTF/shifT)	//Oct. 6, 2000 Ȍ\ɂ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_UTF72SJIS		, "UTF-7SJISR[hϊ(&F)" );	//Sept. 11, 2000 JEPRO ANZXL[t^(F:utF/shiFt)	//Oct. 6, 2000 Ȍ\ɂ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_SJIS2JIS		, "SJISJISR[hϊ(&J)" );		//Sept. 11, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_SJIS2EUC		, "SJISEUCR[hϊ(&E)" );		//Sept. 11, 2000 JEPRO ANZXL[t^
//			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_SJIS2UNICODE	, "SJIS&UnicodeR[hϊ" );		//Sept. 11, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_SJIS2UTF8		, "SJISUTF-8R[hϊ(&8)" );	//Sept. 11, 2000 JEPRO ANZXL[t^ //Oct. 6, 2000 Ȍ\ɂ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CODECNV_SJIS2UTF7		, "SJISUTF-7R[hϊ(&7)" );	//Sept. 11, 2000 JEPRO ANZXL[t^ //Oct. 6, 2000 Ȍ\ɂ
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BASE64DECODE			, "Base64fR[hĕۑ(&B)" );	//Oct. 6, 2000 JEPRO ANZXL[ύX(6B)
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_UUDECODE				, "uudecodeĕۑ(&D)" );			//Sept. 11, 2000 JEPRO ANZXL[ύX(UD)

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp, "R[hϊ(&C)" );

			break;

//		case 5://case 3: (Oct. 22, 2000 JEPRO [ړ][I]V݂ߔԍ2Vtg)
		case 3://Feb. 19, 2001 JEPRO [ړ][I][ҏW]zɈړߔԍɖ߂
			m_CMenuDrawer.ResetContents();
			/* uvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SEARCH_DIALOG	, "(&F)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SEARCH_NEXT		, "(&N)" );				//Sept. 11, 2000 JEPRO """O"̑OɈړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SEARCH_PREV		, "O(&P)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_REPLACE_DIALOG	, "u(&R)..." );				//Oct. 7, 2000 JEPRO ̃ZNV炱Ɉړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SEARCH_CLEARMARK, "}[N̐ؑւ(&C)" );	// "}[ÑNA(&C)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_JUMP_SRCHSTARTPOS, "Jnʒu֖߂(&I)" );	// Jnʒu֖߂ 02/06/26 ai
		
			// Jan. 10, 2005 genta CN^T[`
			hMenuPopUp = ::CreatePopupMenu();
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_NEXT, "OCN^T[`(&F)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_PREV, "CN^T[`(&B)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_REGEXP_NEXT, "K\OCN^T[`(&R)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_REGEXP_PREV, "K\CN^T[`(&X)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_MIGEMO_NEXT, "MIGEMOOCN^T[`(&M)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_ISEARCH_MIGEMO_PREV, "MIGEMOCN^T[`(&N)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp, "CN^T[`(&S)" );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
// From Here 2001.12.03 hor
			// Jan. 10, 2005 genta ̂ŃubN}[NTuj[
			hMenuPopUp = ::CreatePopupMenu();
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BOOKMARK_SET	, "ubN}[NݒE(&S)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BOOKMARK_NEXT	, "̃ubN}[N(&A)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BOOKMARK_PREV	, "ÕubN}[N(&Z)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BOOKMARK_RESET	, "ubN}[N̑S(&X)" );
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BOOKMARK_VIEW	, "ubN}[N̈ꗗ(&V)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp, "ubN}[N(&M)" );
// To Here 2001.12.03 hor
			//	Aug. 19. 2003 genta ANZXL[\L𓝈
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_GREP_DIALOG		, "Grep(&G)..." );					//Oct. 7, 2000 JEPRO 炱Ɉړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_JUMP_DIALOG		, "wsփWv(&J)..." );	//Sept. 11, 2000 jepro LvVɁu Wvvǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_OUTLINE			, "AEgC(&L)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TAGJUMP			, "^OWv(&T)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TAGJUMPBACK		, "^OWvobN(&B)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TAGS_MAKE		, "^Ot@C̍쐬..." );	//@@@ 2003.04.13 MIK // 2004.05.06 MIK ...ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DIRECT_TAGJUMP	, "_CNg^OWv" );	//@@@ 2003.04.13 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TAGJUMP_KEYWORD	, "L[[hw肵ă^OWv" ); //@@ 2005.03.31 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_OPEN_HfromtoC				, "C/C++wb_(\[X)J(&C)" );	//Feb. 7, 2001 JEPRO ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_COMPARE			, "t@Cer(&@)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DIFF_DIALOG		, "DIFF\(&D)..." );	//@@@ 2002.05.25 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DIFF_NEXT		, "̍" );		//@@@ 2002.05.25 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DIFF_PREV		, "O̍" );		//@@@ 2002.05.25 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_DIFF_RESET		, "\̑S" );		//@@@ 2002.05.25 MIK
//	From Here Sept. 1, 2000 JEPRO	Ίʂ̌j[ɒǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_BRACKETPAIR		, "Ίʂ̌(&[)" );
//	To Here Sept. 1, 2000

			break;

//		case 6://case 4: (Oct. 22, 2000 JEPRO [ړ][I]V݂ߔԍ2Vtg)
		case 4://Feb. 19, 2001 JEPRO [ړ][I][ҏW]zɈړߔԍɖ߂
			m_CMenuDrawer.ResetContents();
			/* uIvVvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}

			if( !m_pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_RECKEYMACRO	, "L[}N̋L^Jn(&R)" );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SAVEKEYMACRO, "L[}N̕ۑ(&M)" );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_LOADKEYMACRO, "L[}N̓ǂݍ(&A)" );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXECKEYMACRO, "L[}N̎s(&D)" );
			}else{
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_RECKEYMACRO	, "L[}N̋L^I(&R)" );
				::CheckMenuItem( hMenu, F_RECKEYMACRO, MF_BYCOMMAND | MF_CHECKED );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SAVEKEYMACRO, "L[}N̋L^I&&ۑ(&M)" );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_LOADKEYMACRO, "L[}N̋L^I&&ǂݍ(&A)" );
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXECKEYMACRO, "L[}N̋L^I&&s(&D)" );
			}
			
			//	From Here Sep. 14, 2001 genta
			//uo^ς݃}Nv|bvAbv
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			
			for( i = 0; i < MAX_CUSTMACRO; ++i ){
				MacroRec *mp = &m_pShareData->m_MacroTable[i];
				if( mp->IsEnabled() ){
					if(  mp->m_szName[0] ){
						m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_USERMACRO_0 + i, mp->m_szName );
					}
					else {
						m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_USERMACRO_0 + i, mp->m_szFile );
					}
				}
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "o^ς݃}N(&B)" );
			//	To Here Sep. 14, 2001 genta

			if( m_pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
				::CheckMenuItem( hMenu, F_RECKEYMACRO, MF_BYCOMMAND | MF_CHECKED );
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXECEXTMACRO, "Ow肵ă}Ns(&E)..." ); // 2008.10.22 syat ǉ

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			//From Here Sept. 20, 2000 JEPRO CMMANDCOMMANDɕύX
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXECCMMAND, "OR}hs(&X)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXECCOMMAND_DIALOG, "OR}hs(&X)..." );	//Mar. 10, 2001 JEPRO @\Ȃ̂Ńj[B	//Mar.21, 2001 JEPRO Wo͂Ȃŕ // 2004.05.06 MIK ...ǉ
			//To Here Sept. 20, 2000

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_ACTIVATE_SQLPLUS			, "SQL*PlusANeBu\(&P)" );	//Sept. 11, 2000 JEPRO ANZXL[t^	́uANeBuvuANeBu\vɓ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PLSQL_COMPILE_ON_SQLPLUS	, "SQL*PlusŎs(&S)" );			//Sept. 11, 2000 JEPRO ANZXL[t^

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HOKAN			, "͕⊮(&/)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			//uJX^j[v|bvAbv
			hMenuPopUp = ::CreatePopupMenu();	// Jan. 29, 2002 genta
			//	ENbNj[
			if( m_pShareData->m_Common.m_nCustMenuItemNumArr[0] > 0 ){
				 m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING,
				 	F_MENU_RBUTTON, m_pShareData->m_Common.m_szCustMenuNameArr[0] );
			}
			//	JX^j[
			for( i = 1; i < MAX_CUSTOM_MENU; ++i ){
				if( m_pShareData->m_Common.m_nCustMenuItemNumArr[i] > 0 ){
					 m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING,
					 	F_CUSTMENU_BASE + i, m_pShareData->m_Common.m_szCustMenuNameArr[i] );
				}
			}

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "JX^j[(&U)" );

//		m_pShareData->m_hwndRecordingKeyMacro = NULL;	/* L[{[h}NL^̃EBhE */

			break;

		case 5://Feb. 28, 2004 genta uݒvj[
			//	ݒ荀ڂuc[vƗ
			m_CMenuDrawer.ResetContents();
			/* uEBhEvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}

//	From Here Sept. 17, 2000 JEPRO
//	͂WinWɍ킹ă`FbN}[Nŕ\^\𔻒f悤ɂ̂ŕύX
			if ( FALSE == m_pShareData->m_Common.m_bMenuIcon ){
				pszLabel = "c[o[\(&T)";				//̂ݕ\
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWTOOLBAR, pszLabel );	//̂
				pszLabel = "t@NVL[\(&K)";		//̂ݕ\
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWFUNCKEY, pszLabel );	//̂
				pszLabel = "^uo[\";		//̂ݕ\	//@@@ 2003.06.10 MIK	// 2007.02.13 ryoji u^uvu^uo[v
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWTAB, pszLabel );	//̂	//@@@ 2003.06.10 MIK
				pszLabel = "Xe[^Xo[\(&S)";			//̂ݕ\
//	To Here Sept.17, 2000 JEPRO
//	From Here Oct. 28, 2000 JEPRO
//	3{^̃ACRłƂɔ\^\̃bZ[Wς悤ɍĂѕύX
			}else{
				if( m_hwndToolBar == NULL ){
					pszLabel = "c[o[\(&T)";			//̂ݕ\
				}else{
					pszLabel = "\̃c[o[B(&T)";			//Sept. 9, 2000 jepro LvVɁu\́vǉ
				}
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWTOOLBAR, pszLabel );	//̂
				if( NULL == m_CFuncKeyWnd.m_hWnd ){
					pszLabel = "t@NVL[\(&K)";	//̂ݕ\
				}else{
					pszLabel = "\̃t@NVL[B(&K)";	//Sept. 9, 2000 jepro LvVɁu\́vǉ
				}
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWFUNCKEY, pszLabel );	//̂
				//@@@ 2003.06.10 MIK
				if( NULL == m_cTabWnd.m_hWnd ){
					pszLabel = "^uo[\(&M)";	//̂ݕ\	// 2007.02.13 ryoji u^uvu^uo[v
				}else{
					pszLabel = "\̃^uo[B(&M)";	// 2007.02.13 ryoji u^uvu^uo[v
				}
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWTAB, pszLabel );	//̂
				if( m_hwndStatusBar == NULL ){
					pszLabel = "Xe[^Xo[\(&S)";		//̂ݕ\
				}else{
					pszLabel = "\̃Xe[^Xo[B(&S)";		//Sept. 9, 2000 jepro LvVɁu\́vǉ
				}
			}
//	To Here Oct. 28, 2000

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SHOWSTATUSBAR, pszLabel );

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TYPE_LIST		, "^Cvʐݒꗗ(&L)..." );	//Sept. 13, 2000 JEPRO ݒɈړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_OPTION_TYPE		, "^Cvʐݒ(&Y)..." );		//Sept. 13, 2000 JEPRO ANZXL[ύX(SY)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_OPTION			, "ʐݒ(&C)..." );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FONT			, "tHgݒ(&F)..." );		//Sept. 17, 2000 jepro LvVɁuݒvǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FAVORITE		, "̊Ǘ(&O)..." );	//̊Ǘ	//@@@ 2003.04.08 MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );

			// 2008.05.30 nasukoji	eLXg̐܂Ԃ@̕ύXiꎞݒjǉ
			hMenuPopUp = ::CreatePopupMenu();
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TMPWRAPNOWRAP, "܂ԂȂ(&X)" );		// ܂ԂȂiꎞݒj
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TMPWRAPSETTING, "w茅Ő܂Ԃ(&S)" );	// w茅Ő܂Ԃiꎞݒj
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TMPWRAPWINDOW, "E[Ő܂Ԃ(&W)" );		// E[Ő܂Ԃiꎞݒj
			// ܂Ԃ@ɈꎞݒKp
			if( m_cEditDoc.m_bTextWrapMethodCurTemp )
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "܂Ԃ@iꎞݒKpj(&X)" );
			else
				m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "܂Ԃ@(&X)" );

//@@@ 2002.01.14 YAZAKI ܂ԂȂR}hǉ
// 20051022 aroka ^Cvʐݒlɖ߂R}hǉ
			//	Aug. 14, 2005 genta ܂ԂLayoutMgr擾悤
			//	Jan.  8, 2006 genta ʊ֐
			{
				int width;
				CEditView::TOGGLE_WRAP_ACTION mode = m_cEditDoc.ActiveView().GetWrapMode( width );
				if( mode == CEditView::TGWRAP_NONE ){
					pszLabel = "܂Ԃ(&W)";
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_GRAYED, F_WRAPWINDOWWIDTH , pszLabel );
				}
				else {
					char szBuf[60];
					pszLabel = szBuf;
					if( mode == CEditView::TGWRAP_FULL ){
						sprintf(
							szBuf,
							"܂Ԃ: %d iőj(&W)",
							MAXLINESIZE
						);
					}
					else if( mode == CEditView::TGWRAP_WINDOW ){
						int nActive = m_cEditDoc.GetActivePane();
						sprintf(
							szBuf,
							"܂Ԃ: %d iE[j(&W)",
							m_cEditDoc.m_cEditViewArr[nActive].ViewColNumToWrapColNum(
								m_cEditDoc.m_cEditViewArr[nActive].m_nViewColNum
							)
						);
					}
					else {	// TGWRAP_PROP
						sprintf(
							szBuf,
							"܂Ԃ: %d iwj(&W)",
							m_cEditDoc.GetDocumentAttribute().m_nMaxLineSize
						);
					}
					m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WRAPWINDOWWIDTH , pszLabel );
				}
			}
			//Sept. 13, 2000 JEPRO ANZXL[t^	//Oct. 7, 2000 JEPRO WRAPWINDIWWIDTH  WRAPWINDOWWIDTH ɕύX
//			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WRAPWINDOWWIDTH , "݂̃EBhEŐ܂Ԃ(&W)" );	//Sept. 13, 2000 JEPRO ANZXL[t^	//Oct. 7, 2000 JEPRO WRAPWINDIWWIDTH  WRAPWINDOWWIDTH ɕύX
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			// 2003.06.08 Moca ǉ
			// u[hύXv|bvAbvj[
			// Feb. 28, 2004 genta ҏWj[ړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_CHGMOD_INS	, "}^㏑[h(&I)" );	//Nov. 9, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_READONLY					, "ǂݎp(&R)" );
			if ( FALSE == m_pShareData->m_Common.m_bMenuIcon ){
				pszLabel = "L[[hwv\(&H)";
			}
			else if( IsFuncChecked( &m_cEditDoc, m_pShareData, F_TOGGLE_KEY_SEARCH ) ){
				pszLabel = "L[[hwv\Ȃ(&H)";
			}
			else {
				pszLabel = "L[[hwv\(&H)";
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOGGLE_KEY_SEARCH, pszLabel );
			hMenuPopUp = ::CreatePopupMenu();
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_CRLF, "͉sR[hw(&CRLF)" ); // ͉sR[hw(CRLF)
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_LF, "͉sR[hw(&LF)" ); // ͉sR[hw(LF)
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_CHGMOD_EOL_CR, "͉sR[hw(C&R)" ); // ͉sR[hw(CR)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp , "͉sR[hw(&E)" );


			break;

//		case 7://case 5: (Oct. 22, 2000 JEPRO [ړ][I]V݂ߔԍ2Vtg)
//		case 5://Feb. 19, 2001 JEPRO [ړ][I][ҏW]zɈړߔԍɖ߂
		case 6://Feb. 28, 2004 genta uݒv̐V݂̂ߔԍ炵
			m_CMenuDrawer.ResetContents();
			/* uEBhEvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}

			if( 1 == m_cEditDoc.m_cSplitterWnd.GetAllSplitRows() ){ // 2002/2/8 aroka \bhʂăANZX
				pszLabel = "㉺ɕ(&-)";	//Oct. 7, 2000 JEPRO ANZXL[ύX(T-)
			}else{
				pszLabel = "㉺̉(&-)";
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SPLIT_V , pszLabel );

			if( 1 == m_cEditDoc.m_cSplitterWnd.GetAllSplitCols() ){ // 2002/2/8 aroka \bhʂăANZX
				pszLabel = "Eɕ(&I)";	//Oct. 7, 2000 JEPRO ANZXL[ύX(YI)
			}else{
				pszLabel = "Ẻ(&I)";
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SPLIT_H , pszLabel );
//	From Here Sept. 17, 2000 JEPRO	c̏ꍇԂɂăj[bZ[Wς悤ɕύX
			if( (1 < m_cEditDoc.m_cSplitterWnd.GetAllSplitRows()) && (1 < m_cEditDoc.m_cSplitterWnd.GetAllSplitCols()) ){ // 2002/2/8 aroka \bhʂăANZX
				pszLabel = "c̉(&S)";	//Feb. 18, 2001 JEPRO ANZXL[ύX(QS)
			}else{
				pszLabel = "cɕ(&S)";	//Sept. 17, 2000 jepro ɁuɁvǉ	//Oct. 7, 2000 JEPRO ANZXL[ύX(SQ)	//Feb. 18, 2001 JEPRO ANZXL[ɖ߂(QS)
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_SPLIT_VH , pszLabel );
//	To Here Sept. 17, 2000
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WINCLOSE		, "(&C)" );			//Feb. 18, 2001 JEPRO ANZXL[ύX(OC)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WIN_CLOSEALL	, "ׂĕ(&Q)" );		//Oct. 17, 2000 JEPRO OύX(F_FILECLOSEALLF_WIN_CLOSEALL)	//Feb. 18, 2001 JEPRO ANZXL[ύX(LQ)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_NEXTWINDOW		, "̃EBhE(&N)" );	//Sept. 11, 2000 JEPRO """O"̑OɈړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_PREVWINDOW		, "ÕEBhE(&P)" );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WINLIST			, "EBhEꗗ(&W)..." );		// 2006.03.23 fon
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_CASCADE			, "d˂ĕ\(&E)" );		//Oct. 7, 2000 JEPRO ANZXL[ύX(CE)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TILE_V			, "㉺ɕׂĕ\(&H)" );	//Sept. 13, 2000 JEPRO ɍ킹ăj[̍EƏ㉺ւ //Oct. 7, 2000 JEPRO ANZXL[ύX(VH)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TILE_H			, "Eɕׂĕ\(&T)" );	//Oct. 7, 2000 JEPRO ANZXL[ύX(HT)
			if( (DWORD)::GetWindowLongPtr( m_hWnd, GWL_EXSTYLE ) & WS_EX_TOPMOST ){
				pszLabel = "ɎO(&F)";
			}else{
				pszLabel = "ɎOɕ\(&F)";
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_TOPMOST, pszLabel ); //2004.09.21 Moca	// 2007.06.20 ryoji ANZXL[ǉ

			hMenuPopUp = ::CreatePopupMenu();	// 2007.06.20 ryoji
			if( m_pShareData->m_Common.m_bDispTabWnd && !m_pShareData->m_Common.m_bDispTabWndMultiWin ){
				pszLabel = "O[v(&B)";
			}else{
				pszLabel = "O[v(&B)";
			}
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_BIND_WINDOW, pszLabel );		//2004.07.14 Kazika VKǉ	// 2007.02.13 ryoji uĕ\vuЂƂɂ܂Ƃ߂ĕ\v	// 2007.06.20 ryoji uO[vv
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_GROUPCLOSE		, "O[v(&G)" );	// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_NEXTGROUP		, "̃O[v(&N)" );			// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_PREVGROUP		, "ÕO[v(&P)" );			// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TAB_MOVERIGHT	, "^uEɈړ(&R)" );		// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TAB_MOVELEFT	, "^uɈړ(&L)" );		// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TAB_SEPARATE	, "VKO[v(&E)" );			// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TAB_JOINTNEXT	, "̃O[vɈړ(&X)" );	// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenuPopUp, MF_BYPOSITION | MF_STRING, F_TAB_JOINTPREV	, "ÕO[vɈړ(&V)" );	// 2007.06.20 ryoji
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp, "^ȗ(&B)" );		// 2007.06.20 ryoji

			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_MAXIMIZE_V		, "cɍő剻(&X)" );	//Sept. 13, 2000 JEPRO ANZXL[t^
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_MAXIMIZE_H		, "ɍő剻(&Y)" );	//2001.02.10 by MIK
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_MINIMIZE_ALL	, "ׂčŏ(&M)" );		//Sept. 17, 2000 jepro ́uSāvuׂāvɓ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */				//Oct. 22, 2000 JEPRO ́uĕ`vɔZp[^ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_REDRAW			, "ĕ`(&R)" );			//Oct. 22, 2000 JEPRO RgAEgĂ̂𕜊
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );	/* Zp[^ */
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_WIN_OUTPUT		, "AEgvbg(&U)" );		//Sept. 13, 2000 JEPRO ANZXL[ύX(OU)
// 2006.03.23 fon CHG-start>>
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );		/* Zp[^ */
			EditNode*	pEditNodeArr;
			nRowNum = CShareData::getInstance()->GetOpenedWindowArr( &pEditNodeArr, TRUE );
			WinListMenu(hMenu, pEditNodeArr, nRowNum, false);
			delete [] pEditNodeArr;
//<< 2006.03.23 fon CHG-end
			break;

//		case 8://case 6: (Oct. 22, 2000 JEPRO [ړ][I]V݂ߔԍ2Vtg)
//		case 6://Feb. 19, 2001 JEPRO [ړ][I][ҏW]zɈړߔԍɖ߂
		case 7://Feb. 28, 2004 genta uݒv̐V݂̂ߔԍ炵
			m_CMenuDrawer.ResetContents();
			/* uwvvj[ */
			cMenuItems = ::GetMenuItemCount( hMenu );
			for( i = cMenuItems - 1; i >= 0; i-- ){
				bRet = ::DeleteMenu( hMenu, i, MF_BYPOSITION );
			}
//Sept. 15, 2000Nov. 25, 2000 JEPRO //V[gJbgL[܂Ȃ̂ŎEĂ2sCE
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HELP_CONTENTS , "ڎ(&O)" );				//Sept. 7, 2000 jepro LvVuwvڎvύX	Oct. 13, 2000 JEPRO ANZXL[ugCE{^v̂߂ɕύX(CO)
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_HELP_SEARCH	,	 "L[[h(&S)..." );	//Sept. 7, 2000 jepro LvVuwvgsbŇvύX //Nov. 25, 2000 jeprougsbŃvuL[[hvɕύX // 2004.05.06 MIK ...ǉ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_MENU_ALLFUNC	, "R}hꗗ(&M)" );		//Oct. 13, 2000 JEPRO ANZXL[ugCE{^v̂߂ɕύX(LM)
//Sept. 16, 2000 JEPRO V[gJbgL[܂Ȃ̂Ŏs͎EČɖ߂Ă		//Dec. 25, 2000 
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_CREATEKEYBINDLIST	, "L[蓖ĈꗗRs[(&Q)" );			//Sept. 15, 2000 JEPRO LvV́u...XgvAANZXL[ύX(KQ) IDM_TESTFɕύX			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXTHELP1		, "OwvP(&E)" );		//Sept. 7, 2000 JEPRO ̃j[̏Ԃgbv牺Ɉړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_EXTHTMLHELP		, "OHTMLwv(&H)" );	//Sept. 7, 2000 JEPRO ̃j[̏ԂQԖڂ牺Ɉړ
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_ABOUT			, "o[W(&A)" );	//Dec. 25, 2000 JEPRO F_ɕύX
			break;
		}
	}

end_of_func_IsEnable:;
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	if (m_pPrintPreview)	return;	//	vr[[hȂrBi炭rȂĂƎv񂾂ǁAÔ߁j

	/* @\p\ǂA`FbNԂǂꊇ`FbN */
	cMenuItems = ::GetMenuItemCount( hMenu );
	for (nPos = 0; nPos < cMenuItems; nPos++) {
		id = ::GetMenuItemID(hMenu, nPos);
		/* @\p\ׂ */
		//	Jan.  8, 2006 genta @\Lȏꍇɂ͖IɍĐݒ肵Ȃ悤ɂD
		if( ! IsFuncEnable( &m_cEditDoc, m_pShareData, id ) ){
			fuFlags = MF_BYCOMMAND | MF_GRAYED;
			::EnableMenuItem(hMenu, id, fuFlags);
		}

		/* @\`FbNԂׂ */
		if( IsFuncChecked( &m_cEditDoc, m_pShareData, id ) ){
			fuFlags = MF_BYCOMMAND | MF_CHECKED;
			::CheckMenuItem(hMenu, id, fuFlags);
		}
		/* else{
			fuFlags = MF_BYCOMMAND | MF_UNCHECKED;
		}
		*/
	}
	return;
}




STDMETHODIMP CEditWnd::DragEnter(  LPDATAOBJECT pDataObject, DWORD dwKeyState, POINTL pt, LPDWORD pdwEffect )
{
	if( pDataObject == NULL || pdwEffect == NULL ){
		return E_INVALIDARG;
	}

	// E{^t@Chbv̏ꍇ
	if( !((MK_RBUTTON & dwKeyState) && IsDataAvailable(pDataObject, CF_HDROP)) ){
		*pdwEffect = DROPEFFECT_NONE;
		return E_INVALIDARG;
	}

	// vr[ł͎󂯕tȂ
	if( m_pPrintPreview ){
		*pdwEffect = DROPEFFECT_NONE;
		return E_INVALIDARG;
	}

	*pdwEffect &= DROPEFFECT_LINK;
	return S_OK;
}

STDMETHODIMP CEditWnd::DragOver( DWORD dwKeyState, POINTL pt, LPDWORD pdwEffect )
{
	if( pdwEffect == NULL )
		return E_INVALIDARG;

	*pdwEffect &= DROPEFFECT_LINK;
	return S_OK;
}

STDMETHODIMP CEditWnd::DragLeave( void )
{
	return S_OK;
}

STDMETHODIMP CEditWnd::Drop( LPDATAOBJECT pDataObject, DWORD dwKeyState, POINTL pt, LPDWORD pdwEffect )
{
	if( pDataObject == NULL || pdwEffect == NULL )
		return E_INVALIDARG;

	// t@ChbvANeBur[ŏ
	*pdwEffect &= DROPEFFECT_LINK;
	return m_cEditDoc.m_cEditViewArr[m_cEditDoc.GetActivePane()].PostMyDropFiles( pDataObject );
}

/* t@Chbvꂽ */
void CEditWnd::OnDropFiles( HDROP hDrop )
{
		POINT		pt;
		WORD		cFiles, i;
		char		szFile[_MAX_PATH + 1];
		char		szWork[_MAX_PATH + 1];
		BOOL		bOpened;
		FileInfo*	pfi;
		HWND		hWndOwner;

		::DragQueryPoint( hDrop, &pt );
		cFiles = ::DragQueryFile( hDrop, 0xFFFFFFFF, (LPSTR) NULL, 0);
		/* t@ChbvƂ͕ĊJ */
		if( m_pShareData->m_Common.m_bDropFileAndClose ){
			cFiles = 1;
		}
		/* xɃhbv\ȃt@C */
		if( cFiles > m_pShareData->m_Common.m_nDropFileNumMax ){
				cFiles = m_pShareData->m_Common.m_nDropFileNumMax;
		}
		for( i = 0; i < cFiles; i++ ) {
				// 2008.07.28 nasukoji	pXhbvƈُI邱Ƃւ̑΍
				if( ::DragQueryFile( hDrop, i, NULL, 0 ) >= _MAX_PATH ){
					::MessageBeep( MB_ICONSTOP );
					MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONSTOP | MB_TOPMOST, GSTR_APPNAME,
								  "t@CpX܂B ANSI łł %d oCgȏ̐΃pX܂B",
								  _MAX_PATH );
					continue;
				}

				::DragQueryFile( hDrop, i, szFile, sizeof(szFile) );
				/* V[gJbg(.lnk)̉ */
				if( TRUE == ResolveShortcutLink( NULL, szFile, szWork ) ){
					strcpy( szFile, szWork );
				}
				/* Ot@C擾 */
				if( TRUE == ::GetLongFileName( szFile, szWork ) ){
						strcpy( szFile, szWork );
				}

				/* wt@CJĂ邩ׂ */
				if( CShareData::getInstance()->IsPathOpened( szFile, &hWndOwner ) ){
					::SendMessage( hWndOwner, MYWM_GETFILEINFO, 0, 0 );
					pfi = (FileInfo*)&m_pShareData->m_FileInfo_MYWM_GETFILEINFO;
					/* ANeBuɂ */
					ActivateFrameWindow( hWndOwner );
					/* MRUXgւ̓o^ */
					CMRU cMRU;
					cMRU.Add( pfi );
				}else{
						/* ύXtOItŁAt@CǂݍłȂꍇ */
						//	2005.06.24 Moca
						if( m_cEditDoc.IsFileOpenInThisWindow() ){
								/* t@Cǂݍ */
								m_cEditDoc.FileRead(
										szFile,
										&bOpened,
										CODE_AUTODETECT,	/* R[h */
										FALSE,				/* ǂݎp */
										//	Oct. 03, 2004 genta R[hmF͐ݒɈˑ
										m_pShareData->m_Common.m_bQueryIfCodeChange
								);
								hWndOwner = m_hWnd;
								/* ANeBuɂ */
								// 2007.06.17 maru łɊJĂ邩`FbNς݂
								// hbvꂽ̂̓tH_Ȃ̂ōă`FbN
								if(FALSE==bOpened) ActivateFrameWindow( hWndOwner );
						}else{
								/* t@ChbvƂ͕ĊJ */
								if( m_pShareData->m_Common.m_bDropFileAndClose ){
										/* t@CƂMRUo^ & ۑmF & ۑs */
										if( m_cEditDoc.OnFileClose() ){
												/* f[^̃NA */
												m_cEditDoc.Init();

												/* Sr[̏ */
												m_cEditDoc.InitAllView();

												/* eEBhẼ^CgXV */
												m_cEditDoc.SetParentCaption();

												/* t@Cǂݍ */
														m_cEditDoc.FileRead(
														szFile,
														&bOpened,
														CODE_AUTODETECT,	/* R[h */
														FALSE,				/* ǂݎp */
														//	Oct. 03, 2004 genta R[hmF͐ݒɈˑ
														m_pShareData->m_Common.m_bQueryIfCodeChange
														//TRUE
												);
												hWndOwner = m_hWnd;
												/* ANeBuɂ */
												ActivateFrameWindow( hWndOwner );
										}
										goto end_of_drop_query;
								}else{
										/* ҏWEBhȄ`FbN */
										if( m_pShareData->m_nEditArrNum >= MAX_EDITWINDOWS ){	//őlC	//@@@ 2003.05.31 MIK
												char szMsg[512];
												wsprintf( szMsg, "ҏWEBhȄ%dłB\nȏ͓ɊJ܂B", MAX_EDITWINDOWS );
												::MessageBox( NULL, szMsg, GSTR_APPNAME, MB_OK );
												::DragFinish( hDrop );
												return;
										}
										char	szFile2[_MAX_PATH + 3];
										if( strchr( szFile, ' ' ) ){
												wsprintf( szFile2, "\"%s\"", szFile );
												strcpy( szFile, szFile2 );
										}
										/* VȕҏWEBhEN */
										CEditApp::OpenNewEditor(
												m_hInstance,
												m_hWnd,
												szFile,
												CODE_AUTODETECT,	/* R[h */
												FALSE				/* ǂݎp */
										);
								}
						}
				}
		}
end_of_drop_query:;
		::DragFinish( hDrop );
		return;
}

/*! WM_TIMER  
	@date 2007.04.03 ryoji VK
	@date 2008.04.19 ryoji IDT_FIRST_IDLE ł MYWM_FIRST_IDLE |Xgǉ
*/
LRESULT CEditWnd::OnTimer( WPARAM wParam, LPARAM lParam )
{
	// ^C}[ ID ŏU蕪
	switch( wParam )
	{
	case IDT_EDIT:
		OnEditTimer();
		break;
	case IDT_TOOLBAR:
		OnToolbarTimer();
		break;
	case IDT_CAPTION:
		OnCaptionTimer();
		break;
	case IDT_SYSMENU:
		OnSysMenuTimer();
		break;
	case IDT_FIRST_IDLE:
		CShareData::getInstance()->PostMessageToAllEditors( MYWM_FIRST_IDLE, ::GetCurrentProcessId(), 0, NULL );	// vZX̏AChOʒm	// 2008.04.19 ryoji
		::KillTimer( m_hWnd, wParam );
		break;
	default:
		return 1L;
	}

	return 0L;
}

/*! ^C}[̏
	@date 2002.01.03 YAZAKI m_tbMyButtonȂǂCShareDataCMenuDrawerֈړƂɂCB
	@date 2003.08.29 wmlhq, ryoji nTimerCount̓
	@date 2006.01.28 aroka c[o[XV OnToolbarTimerɈړ
	@date 2007.04.03 ryoji p[^ɂ
*/
void CEditWnd::OnEditTimer( void )
{
	//static	int	nLoopCount = 0; // wmlhq m_nTimerCountɈڍs
	// ^C}[̌ĂяoԊu 500msɕύXB300*10500*6ɂB 20060128 aroka
	m_nTimerCount++;
	if( 6 < m_nTimerCount ){
		m_nTimerCount = 0;
	}

	// 2006.01.28 aroka c[o[XV֘A OnToolbarTimerɈړB
	
	//	Aug. 29, 2003 wmlhq, ryoji
	if( m_nTimerCount == 0 && GetCapture() == NULL ){ 
		/* t@C̃^CX^ṽ`FbN */
		m_cEditDoc.CheckFileTimeStamp() ;
	}

	m_cEditDoc.CheckAutoSave();
	return;
}

/*! c[o[XVp^C}[̏
	@date 2002.01.03 YAZAKI m_tbMyButtonȂǂCShareDataCMenuDrawerֈړƂɂCB
	@date 2003.08.29 wmlhq, ryoji nTimerCount̓
	@date 2006.01.28 aroka OnTimer番
	@date 2007.04.03 ryoji p[^ɂ
	@date 2008.09.23 nasukoji c[o[XVOɏo
*/
void CEditWnd::OnToolbarTimer( void )
{
	m_nTimerCount++;
	if( 10 < m_nTimerCount ){
		m_nTimerCount = 0;
	}

	UpdateToolbar();	// 2008.09.23 nasukoji	c[o[̕\XV

	return;
}

/*!
	@brief c[o[̕\XV
	
	@note Ăׂ悤OnToolbarTimer()؂o
	
	@date 2008.09.23 nasukoji
*/
void CEditWnd::UpdateToolbar( void )
{
	//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	/* vr[ȂAȂBłȂ΁Ac[o[̏ԍXV */
	if( !m_pPrintPreview && NULL != m_hwndToolBar ){
		for( int i = 0; i < m_pShareData->m_Common.m_nToolBarButtonNum; ++i ){
			TBBUTTON tbb = m_CMenuDrawer.getButton(m_pShareData->m_Common.m_nToolBarButtonIdxArr[i]);

			/* @\p\ׂ */
			::PostMessage(
				m_hwndToolBar, TB_ENABLEBUTTON, tbb.idCommand,
				(LPARAM) MAKELONG( (IsFuncEnable( &m_cEditDoc, m_pShareData, tbb.idCommand ) ) , 0 )
			);

			/* @\`FbNԂׂ */
			::PostMessage(
				m_hwndToolBar, TB_CHECKBUTTON, tbb.idCommand,
				(LPARAM) MAKELONG( IsFuncChecked( &m_cEditDoc, m_pShareData, tbb.idCommand ), 0 )
			);
		}
	}
}

/*! LvVXVp^C}[̏
	@date 2007.04.03 ryoji VK
*/
void CEditWnd::OnCaptionTimer( void )
{
	// ҏWʂ̐ؑցi^u܂ƂߎjIĂ^C}[Iă^Cgo[XV
	// ܂ؑ֒Ȃ^C}[p
	if( !m_pShareData->m_bEditWndChanging ){
		::KillTimer( m_hWnd, IDT_CAPTION );
		::SetWindowText( m_hWnd, m_pszLastCaption );
	}
}

/*! VXej[\p^C}[̏
	@date 2007.04.03 ryoji p[^ɂ
	                       ȑO̓R[obN֐łĂKillTimer()ōs悤ɂ
*/
void CEditWnd::OnSysMenuTimer( void ) //by S(2)
{
	::KillTimer( m_hWnd, IDT_SYSMENU );	// 2007.04.03 ryoji

	if(m_IconClicked == icClicked)
	{
		ReleaseCapture();

		//VXej[\
		// 2006.04.21 ryoji }`j^Ή̏C
		// 2007.05.13 ryoji 0x0313bZ[W|XgɕύXiTrackPopupMenuƃj[ڂ̗L^ԂsɂȂ΍j
		RECT R;
		GetWindowRect(m_hWnd, &R);
		POINT pt;
		pt.x = R.left + GetSystemMetrics(SM_CXFRAME);
		pt.y = R.top + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME);
		GetMonitorWorkRect( pt, &R );
		::PostMessage( m_hWnd, 0x0313, 0, MAKELPARAM( (pt.x > R.left)? pt.x: R.left, (pt.y < R.bottom)? pt.y: R.bottom ));
	}
	m_IconClicked = icNone;
}

/* @\`FbNԂׂ */
int CEditWnd::IsFuncChecked( CEditDoc* pcEditDoc, DLLSHAREDATA*	pShareData, int nId )
{
	CEditWnd* pCEditWnd;
	// Modified by KEITA for WIN64 2003.9.6
	pCEditWnd = ( CEditWnd* )::GetWindowLongPtr( pcEditDoc->m_hwndParent, GWLP_USERDATA );
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂAvr[폜
	switch( nId ){
	case F_FILE_REOPEN_SJIS:
		if( CODE_SJIS == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_JIS:
		if( CODE_JIS == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_EUC:
		if( CODE_EUC == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_UNICODE:
		if( CODE_UNICODE == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_UNICODEBE:
		if( CODE_UNICODEBE == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_UTF8:
		if( CODE_UTF8 == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_FILE_REOPEN_UTF7:
		if( CODE_UTF7 == pcEditDoc->m_nCharCode ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_RECKEYMACRO:	/* L[}N̋L^Jn^I */
		if( pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
			if( pShareData->m_hwndRecordingKeyMacro == pcEditDoc->m_hwndParent ){	/* L[{[h}NL^̃EBhE */
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return FALSE;
		}
	case F_SHOWTOOLBAR:
		if( pCEditWnd->m_hwndToolBar != NULL ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_SHOWFUNCKEY:
		if( pCEditWnd->m_CFuncKeyWnd.m_hWnd != NULL ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_SHOWTAB:	//@@@ 2003.06.10 MIK
		if( pCEditWnd->m_cTabWnd.m_hWnd != NULL ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_SHOWSTATUSBAR:
		if( pCEditWnd->m_hwndStatusBar != NULL ){
			return TRUE;
		}else{
			return FALSE;
		}
	// 2008.05.30 nasukoji	eLXg̐܂Ԃ@
	case F_TMPWRAPNOWRAP:		// ܂ԂȂ
		if( pcEditDoc->m_nTextWrapMethodCur == WRAP_NO_TEXT_WRAP ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_TMPWRAPSETTING:		// w茅Ő܂Ԃ
		if( pcEditDoc->m_nTextWrapMethodCur == WRAP_SETTING_WIDTH ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_TMPWRAPWINDOW:		// E[Ő܂Ԃ
		if( pcEditDoc->m_nTextWrapMethodCur == WRAP_WINDOW_WIDTH ){
			return TRUE;
		}else{
			return FALSE;
		}
	// Mar. 6, 2002 genta
	case F_READONLY://ǂݎp
		if( pcEditDoc->m_bReadOnly ){ /* ύXtO */
			return TRUE;
		}else{
			return FALSE;
		}
	//	From Here 2003.06.23 Moca
	case F_CHGMOD_EOL_CRLF:
		if( EOL_CRLF == pcEditDoc->GetNewLineCode() ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_CHGMOD_EOL_LF:
		if( EOL_LF == pcEditDoc->GetNewLineCode() ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_CHGMOD_EOL_CR:
		if( EOL_CR == pcEditDoc->GetNewLineCode() ){
			return TRUE;
		}else{
			return FALSE;
		}
	//	To Here 2003.06.23 Moca
	//	2003.07.21 genta
	case F_CHGMOD_INS:
		//	Oct. 2, 2005 genta }[h̓hLgɕ⊮悤ɕύX
		if( pcEditDoc->IsInsMode() ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_TOGGLE_KEY_SEARCH:
		//	2007.02.03 genta L[[h|bvAbvON/OFFԂ𔽉f
		if( pShareData->m_Common.m_bUseCaretKeyWord ){
			return TRUE;
		}
		else {
			return FALSE;
		}
	//Start 2004.07.14 Kazika ǉ
	case F_BIND_WINDOW:	//
		return ((pShareData->m_Common.m_bDispTabWnd) && !(pShareData->m_Common.m_bDispTabWndMultiWin));

	// 2004.09.21 Moca
	case F_TOPMOST:
		if( (DWORD)::GetWindowLongPtr( pCEditWnd->m_hWnd, GWL_EXSTYLE ) & WS_EX_TOPMOST ){
			return TRUE;
		}else{
			return FALSE;
		}
		break;
	// Jan. 10, 2004 genta CN^T[`
	case F_ISEARCH_NEXT:
	case F_ISEARCH_PREV:
	case F_ISEARCH_REGEXP_NEXT:
	case F_ISEARCH_REGEXP_PREV:
	case F_ISEARCH_MIGEMO_NEXT:
	case F_ISEARCH_MIGEMO_PREV:
		return pcEditDoc->ActiveView().IsISearchEnabled( nId );
	case F_OUTLINE_TOGGLE: // 20060201 aroka AEgCEBhE
		// ToDo:ubN}[NXgoĂƂւł܂B
		return (pcEditDoc->m_cDlgFuncList.m_hWnd != NULL);
	}
	//End 2004.07.14 Kazika

	return FALSE;
}




/* @\p\ׂ */
int CEditWnd::IsFuncEnable( CEditDoc* pcEditDoc, DLLSHAREDATA* pShareData, int nId )
{
	/* ֎~̂Ƃꊇ`FbN */
	if( pcEditDoc->IsModificationForbidden( nId ) )
		return FALSE;

	switch( nId ){
	case F_RECKEYMACRO:	/* L[}N̋L^Jn^I */
		if( pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
			if( pShareData->m_hwndRecordingKeyMacro == pcEditDoc->m_hwndParent ){	/* L[{[h}NL^̃EBhE */
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return TRUE;
		}
	case F_SAVEKEYMACRO:	/* L[}N̕ۑ */
		//	Jun. 16, 2002 genta
		//	L[}NGWȊÕ}NǂݍłƂ
		//	s͂ł邪ۑ͂łȂD
		if( pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
			if( pShareData->m_hwndRecordingKeyMacro == pcEditDoc->m_hwndParent ){	/* L[{[h}NL^̃EBhE */
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return pcEditDoc->m_pcSMacroMgr->IsSaveOk();
		}
	case F_EXECKEYMACRO:	/* L[}N̎s */
		if( pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
			if( pShareData->m_hwndRecordingKeyMacro == pcEditDoc->m_hwndParent ){	/* L[{[h}NL^̃EBhE */
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			//@@@ 2002.1.24 YAZAKI m_szKeyMacroFileNameɃt@CRs[Ă邩ǂB
			if (pShareData->m_szKeyMacroFileName[0] ) {
				return TRUE;
			}else{
				return FALSE;
			}
		}
	case F_LOADKEYMACRO:	/* L[}N̓ǂݍ */
		if( pShareData->m_bRecordingKeyMacro ){	/* L[{[h}N̋L^ */
			if( pShareData->m_hwndRecordingKeyMacro == pcEditDoc->m_hwndParent ){	/* L[{[h}NL^̃EBhE */
				return TRUE;
			}else{
				return FALSE;
			}
		}else{
			return TRUE;
		}
	case F_EXECEXTMACRO:	/* Ow肵ă}Ns */
		return TRUE;

	case F_SEARCH_CLEARMARK:	//}[ÑNA
		return TRUE;

	// 02/06/26 ai Start
	case F_JUMP_SRCHSTARTPOS:	// Jnʒu֖߂
		if( 0 <= pcEditDoc->m_cEditViewArr[pcEditDoc->m_nActivePaneIndex].m_nSrchStartPosX_PHY &&
			0 <= pcEditDoc->m_cEditViewArr[pcEditDoc->m_nActivePaneIndex].m_nSrchStartPosY_PHY) {
			return TRUE;
		}else{
			return FALSE;
		}
	// 02/06/26 ai End

	case F_COMPARE:	/* t@Cer */
		if( 2 <= pShareData->m_nEditArrNum ){
			return TRUE;
		}else{
			return FALSE;
		}

	case F_DIFF_NEXT:	/* ̍ */	//@@@ 2002.05.25 MIK
	case F_DIFF_PREV:	/* O̍ */	//@@@ 2002.05.25 MIK
	case F_DIFF_RESET:	/* ̑S */	//@@@ 2002.05.25 MIK
		if( ! pcEditDoc->m_cDocLineMgr.IsDiffUse() ) return FALSE;
		return TRUE;
	case F_DIFF_DIALOG:	/* DIFF\ */	//@@@ 2002.05.25 MIK
		//if( pcEditDoc->IsModified() ) return FALSE;
		//if( ! pcEditDoc->IsFilePathAvailable() ) return FALSE;
		return TRUE;

	case F_BEGIN_BOX:	//`͈͑IJn
		if( TRUE == pShareData->m_Common.m_bFontIs_FIXED_PITCH ){	/* ݂̃tHg͌Œ蕝tHgł */
			return TRUE;
		}else{
			return FALSE;
		}
	case F_PASTEBOX:
		/* Nbv{[h\t\H */
		if( pcEditDoc->IsEnablePaste() &&
			TRUE == pShareData->m_Common.m_bFontIs_FIXED_PITCH
		){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_PASTE:
		/* Nbv{[h\t\H */
		if( pcEditDoc->IsEnablePaste() ){
			return TRUE;
		}else{
			return FALSE;
		}

	case F_FILENEW:	/* VK쐬 */
	case F_GREP_DIALOG:	/* Grep */
		/* ҏWEBhȄ`FbN */
		if( pShareData->m_nEditArrNum >= MAX_EDITWINDOWS ){	//őlC	//@@@ 2003.05.31 MIK
			return FALSE;
		}else{
			return TRUE;
		}

	case F_FILESAVE:	/* ㏑ۑ */
		if( !pcEditDoc->m_bReadOnly ){	/* ǂݎp[h */
			if( pcEditDoc->IsModified() ){	/* ύXtO */
				return TRUE;
			}else{
				/* ύXł㏑邩 */
				if( FALSE == pShareData->m_Common.m_bEnableUnmodifiedOverwrite ){
					return FALSE;
				}else{
					return TRUE;
				}
			}
		}else{
			return FALSE;
		}
	case F_COPYLINES:				//I͈͓SsRs[
	case F_COPYLINESASPASSAGE:		//I͈͓SsptRs[
	case F_COPYLINESWITHLINENUMBER:	//I͈͓SssԍtRs[
		if( pcEditDoc->IsTextSelected( ) ){/* eLXgIĂ邩 */
			return TRUE;
		}else{
			return FALSE;
		}

	case F_TOLOWER:					/*  */
	case F_TOUPPER:					/* 啶 */
	case F_TOHANKAKU:				/* Spp */
	case F_TOHANKATA:				/* SpJ^JipJ^Ji */	//Aug. 29, 2002 ai
	case F_TOZENEI:					/* ppSpp */			//July. 30, 2001 Misaka
	case F_TOHANEI:					/* Spppp */
	case F_TOZENKAKUKATA:			/* p{SЂ灨SpEJ^Ji */	//Sept. 17, 2000 jepro upSpJ^JivύX
	case F_TOZENKAKUHIRA:			/* p{SJ^SpEЂ炪 */	//Sept. 17, 2000 jepro upSpЂ炪ȁvύX
	case F_HANKATATOZENKAKUKATA:	/* pJ^JiSpJ^Ji */
	case F_HANKATATOZENKAKUHIRA:	/* pJ^JiSpЂ炪 */
	case F_TABTOSPACE:				/* TAB */
	case F_SPACETOTAB:				/* 󔒁TAB */  //#### Stonee, 2001/05/27
	case F_CODECNV_AUTO2SJIS:		/* ʁSJISR[hϊ */
	case F_CODECNV_EMAIL:			/* E-Mail(JISSJIS)R[hϊ */
	case F_CODECNV_EUC2SJIS:		/* EUCSJISR[hϊ */
	case F_CODECNV_UNICODE2SJIS:	/* UnicodeSJISR[hϊ */
	case F_CODECNV_UNICODEBE2SJIS:	/* UnicodeBESJISR[hϊ */
	case F_CODECNV_UTF82SJIS:		/* UTF-8SJISR[hϊ */
	case F_CODECNV_UTF72SJIS:		/* UTF-7SJISR[hϊ */
	case F_CODECNV_SJIS2JIS:		/* SJISJISR[hϊ */
	case F_CODECNV_SJIS2EUC:		/* SJISEUCR[hϊ */
	case F_CODECNV_SJIS2UTF8:		/* SJISUTF-8R[hϊ */
	case F_CODECNV_SJIS2UTF7:		/* SJISUTF-7R[hϊ */
	case F_BASE64DECODE:			/* Base64fR[hĕۑ */
	case F_UUDECODE:				//uudecodeĕۑ	//Oct. 17, 2000 jepro uI𕔕UUENCODEfR[hvύX

		/* eLXgIĂ邩 */
		if( pcEditDoc->IsTextSelected( ) ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_SELECTWORD:	/* ݈ʒu̒PI */
	case F_CUT_LINE:	//s؂(܂ԂP)
	case F_DELETE_LINE:	//s폜(܂ԂP)
		/* eLXgIĂ邩 */
		if( pcEditDoc->IsTextSelected( ) ){
			return FALSE;
		}else{
			return TRUE;
		}
	case F_UNDO:
		/* Undo(ɖ߂)\ȏԂH */
		if( pcEditDoc->IsEnableUndo() ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_REDO:
		/* Redo(蒼)\ȏԂH */
		if( pcEditDoc->IsEnableRedo() ){
			return TRUE;
		}else{
			return FALSE;
		}

	case F_COPYPATH:
	case F_COPYTAG:
	case F_COPYFNAME:					// 2002/2/3 aroka
	case F_OPEN_HfromtoC:				//C/C++wb_(\[X)J	//Feb. 7, 2001 JEPRO ǉ
	case F_OPEN_HHPP:					//C/C++wb_t@CJ	//Feb. 9, 2001 jeprou.c܂.cppƓ.hJvύX
	case F_OPEN_CCPP:					//C/C++\[Xt@CJ	//Feb. 9, 2001 jeprou.hƓ.c(Ȃ.cpp)JvύX
	case F_PLSQL_COMPILE_ON_SQLPLUS:	/* Oracle SQL*PlusŎs */
	case F_BROWSE:						//uEY
	//case F_READONLY:					//ǂݎp	//	Sep. 10, 2002 genta Ɏg悤
	case F_PROPERTY_FILE:
		/* ݕҏW̃t@C̃pXNbv{[hɃRs[ł邩 */
		if( pcEditDoc->IsFilePathAvailable() ){
			return TRUE;
		}else{
			return FALSE;
		}
	case F_JUMPHIST_PREV:	//	ړ: O
		if( pcEditDoc->ActiveView().m_cHistory->CheckPrev() )
			return TRUE;
		else
			return FALSE;
	case F_JUMPHIST_NEXT:	//	ړ: 
		if( pcEditDoc->ActiveView().m_cHistory->CheckNext() )
			return TRUE;
		else
			return FALSE;
	case F_JUMPHIST_SET:	//	݈ʒuړɓo^
		return TRUE;
	case F_DIRECT_TAGJUMP:	//_CNg^OWv	//@@@ 2003.04.15 MIK
	case F_TAGJUMP_KEYWORD:	//L[[hw肵ă_CNg^OWv	//@@@ 2005.03.31 MIK
	//	2003.05.12 MIK ^Ot@C쐬Iׂ悤ɂ̂ŁAɍ쐬\Ƃ
//	case F_TAGS_MAKE:	//^Ot@C̍쐬	//@@@ 2003.04.13 MIK
		if( pcEditDoc->IsFilePathAvailable() ){
			return TRUE;
		}else{
			return FALSE;
		}
	
	//^u[h̓EChEבւ֎~łB	@@@ 2003.06.12 MIK
	case F_TILE_H:
	case F_TILE_V:
	case F_CASCADE:
		//Start 2004.07.15 Kazika ^uEBhs\
		return TRUE;
		//End 2004.07.15 Kazika
	case F_BIND_WINDOW:	//2004.07.14 Kazika VKǉ
	case F_TAB_MOVERIGHT:	// 2007.06.20 ryoji ǉ
	case F_TAB_MOVELEFT:	// 2007.06.20 ryoji ǉ
		//^u[h̓EBhEĕ\łȂ
		return (pShareData->m_Common.m_bDispTabWnd);
	case F_GROUPCLOSE:		// 2007.06.20 ryoji ǉ
	case F_NEXTGROUP:		// 2007.06.20 ryoji ǉ
	case F_PREVGROUP:		// 2007.06.20 ryoji ǉ
		return ( pShareData->m_Common.m_bDispTabWnd && !pShareData->m_Common.m_bDispTabWndMultiWin );
	case F_TAB_SEPARATE:	// 2007.06.20 ryoji ǉ
	case F_TAB_JOINTNEXT:	// 2007.06.20 ryoji ǉ
	case F_TAB_JOINTPREV:	// 2007.06.20 ryoji ǉ
		return ( pShareData->m_Common.m_bDispTabWnd && !pShareData->m_Common.m_bDispTabWndMultiWin );
	}
	return TRUE;
}

//#ifdef _DEBUG
	/* fobOj^[hɐݒ */
	void CEditWnd::SetDebugModeON( void )
	{
		if( NULL != m_pShareData->m_hwndDebug ){
			if( CShareData::IsEditWnd( m_pShareData->m_hwndDebug ) ){
				return;
			}
		}
		m_pShareData->m_hwndDebug = m_hWnd;
		m_cEditDoc.m_bDebugMode = TRUE;

// 2001/06/23 N.Nakatani AEgvbgւ̏o̓eLXg̒ǉF_ADDTAIL}~̂łƂ肠ǂݎp[h͎߂܂
		m_cEditDoc.m_bReadOnly = FALSE;		/* ǂݎp[h */
		/* eEBhẼ^CgXV */
		m_cEditDoc.SetParentCaption();
		return;
	}
	
	// 2005.06.24 Moca
	//! fobNj^[h̉
	void CEditWnd::SetDebugModeOFF( void )
	{
		if( m_pShareData->m_hwndDebug == m_hWnd ){
			m_pShareData->m_hwndDebug = NULL;
			m_cEditDoc.m_bDebugMode = FALSE;
			m_cEditDoc.SetParentCaption();
		}
	}
//#endif


/* @\IDɑΉwvReLXgԍԂ */
// Modified by Stonee, 2001/02/23
// etc_uty.cppɒgړ
/*	2002/04/17 YAZAKI RgAEg
int CEditWnd::FuncID_To_HelpContextID( int nFuncID )
{
	return ::FuncID_To_HelpContextID(nFuncID);
}
*/

/* j[ACeɑΉwv\ */
void CEditWnd::OnHelp_MenuItem( HWND hwndParent, int nFuncID )
{
	char	szHelpFile[_MAX_PATH + 1];
	int		nHelpContextID;

	/* wvt@C̃tpXԂ */
	::GetHelpFilePath( szHelpFile );

	/* @\IDɑΉwvReLXgԍԂ */
	nHelpContextID = FuncID_To_HelpContextID( nFuncID );
	if( 0 != nHelpContextID ){
		MyWinHelp( hwndParent, szHelpFile, HELP_CONTEXT, nHelpContextID );	// 2006.10.10 ryoji MyWinHelpɕύXɕύX
	}
	return;
}


//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX

/* vr[[h̃I/It */
void CEditWnd::PrintPreviewModeONOFF( void )
{
	HMENU	hMenu;
	HWND	hwndToolBar;

	// 2006.06.17 ryoji Rebar ΂c[o[
	hwndToolBar = (NULL != m_hwndReBar)? m_hwndReBar: m_hwndToolBar;

	/* vr[[h */
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	if( m_pPrintPreview ){
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		/*	vr[[h܂B	*/
		delete m_pPrintPreview;	//	폜B
		m_pPrintPreview = NULL;	//	NULLۂŁAvgvr[[hf邽߁B

		/*	ʏ탂[hɖ߂	*/
		::ShowWindow( m_cEditDoc.m_hWnd, SW_SHOW );
		::ShowWindow( hwndToolBar, SW_SHOW );	// 2006.06.17 ryoji
		::ShowWindow( m_hwndStatusBar, SW_SHOW );
		::ShowWindow( m_CFuncKeyWnd.m_hWnd, SW_SHOW );
		::ShowWindow( m_cTabWnd.m_hWnd, SW_SHOW );	//@@@ 2003.06.25 MIK

		::SetFocus( m_hWnd );

		hMenu = ::LoadMenu( m_hInstance, MAKEINTRESOURCE( IDR_MENU1 ) );
		::SetMenu( m_hWnd, hMenu );
		::DrawMenuBar( m_hWnd );

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		::InvalidateRect( m_hWnd, NULL, TRUE );
	}else{
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		/*	ʏ탂[hB	*/
		hMenu = ::GetMenu( m_hWnd );
		//	Jun. 18, 2001 genta Print Previewł̓j[폜
		::SetMenu( m_hWnd, NULL );
		::DestroyMenu( hMenu );
		::DrawMenuBar( m_hWnd );

		::ShowWindow( m_cEditDoc.m_hWnd, SW_HIDE );
		::ShowWindow( hwndToolBar, SW_HIDE );	// 2006.06.17 ryoji
		::ShowWindow( m_hwndStatusBar, SW_HIDE );
		::ShowWindow( m_CFuncKeyWnd.m_hWnd, SW_HIDE );
		::ShowWindow( m_cTabWnd.m_hWnd, SW_HIDE );	//@@@ 2003.06.25 MIK

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		m_pPrintPreview = new CPrintPreview( this );
		/* ݂̈ݒ */
		m_pPrintPreview->SetPrintSetting(
			&m_pShareData->m_PrintSettingArr[
				m_cEditDoc.GetDocumentAttribute().m_nCurrentPrintSetting]
		);

		//	v^̏擾B

		/* ݂̃ftHgv^̏擾 */
		BOOL bRes;
		bRes = m_pPrintPreview->GetDefaultPrinterInfo();
		if( FALSE == bRes ){
			::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONINFORMATION | MB_TOPMOST, GSTR_APPNAME,
				"vr[sOɁAv^CXg[ĂB\n"
			);
			return;
		}

		/* ݒ̔f */
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		m_pPrintPreview->OnChangePrintSetting();
		::InvalidateRect( m_hWnd, NULL, TRUE );
		::UpdateWindow( m_hWnd /* m_pPrintPreview->GetPrintPreviewBarHANDLE() */);

	}
	return;

}




/* WM_SIZE  */
LRESULT CEditWnd::OnSize( WPARAM wParam, LPARAM lParam )
{
	HWND		hwndToolBar;
	int			cx;
	int			cy;
	int			nToolBarHeight;
	int			nStatusBarHeight;
	int			nFuncKeyWndHeight;
	int			nTabWndHeight;	//^uEChE	//@@@ 2003.05.31 MIK
	RECT		rc, rcClient;
	int			nCxHScroll;
	int			nCyHScroll;
	int			nCxVScroll;
	int			nCyVScroll;
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂ
//	ϐ폜

	RECT		rcWin;



	cx = LOWORD( lParam );
	cy = HIWORD( lParam );

	/* EBhETCYp */
	if( wParam != SIZE_MINIMIZED ){						/* ŏ͌pȂ */
		//	2004.05.13 Moca m_nSaveWindowSizẻߒǉ̂
		if( WINSIZEMODE_SAVE == m_pShareData->m_Common.m_nSaveWindowSize ){		/* EBhETCYp邩 */
			if( wParam == SIZE_MAXIMIZED ){					/* ő剻̓TCYL^Ȃ */
				if( m_pShareData->m_Common.m_nWinSizeType != (int)wParam ){
					m_pShareData->m_Common.m_nWinSizeType = wParam;
				}
			}else{
				::GetWindowRect( m_hWnd, &rcWin );
				/* EBhETCYɊւf[^ύXꂽ */
				if( m_pShareData->m_Common.m_nWinSizeType != (int)wParam ||
					m_pShareData->m_Common.m_nWinSizeCX != rcWin.right - rcWin.left ||
					m_pShareData->m_Common.m_nWinSizeCY != rcWin.bottom - rcWin.top
				){
					m_pShareData->m_Common.m_nWinSizeType = wParam;
					m_pShareData->m_Common.m_nWinSizeCX = rcWin.right - rcWin.left;
					m_pShareData->m_Common.m_nWinSizeCY = rcWin.bottom - rcWin.top;
				}
			}
		}

		// ɖ߂Ƃ̃TCYʂL	// 2007.06.20 ryoji
		EditNode *p = CShareData::getInstance()->GetEditNode( m_hWnd );
		if( p != NULL ){
			p->m_showCmdRestore = ::IsZoomed( p->m_hWnd )? SW_SHOWMAXIMIZED: SW_SHOWNORMAL;
		}
	}

	m_nWinSizeType = wParam;	/* TCYύX̃^Cv */
	nCxHScroll = ::GetSystemMetrics( SM_CXHSCROLL );
	nCyHScroll = ::GetSystemMetrics( SM_CYHSCROLL );
	nCxVScroll = ::GetSystemMetrics( SM_CXVSCROLL );
	nCyVScroll = ::GetSystemMetrics( SM_CYVSCROLL );

	// 2006.06.17 ryoji Rebar ΂c[o[
	hwndToolBar = (NULL != m_hwndReBar)? m_hwndReBar: m_hwndToolBar;
	nToolBarHeight = 0;
	if( NULL != hwndToolBar ){
		::SendMessage( hwndToolBar, WM_SIZE, wParam, lParam );
		::GetWindowRect( hwndToolBar, &rc );
		nToolBarHeight = rc.bottom - rc.top;
	}
	nFuncKeyWndHeight = 0;
	if( NULL != m_CFuncKeyWnd.m_hWnd ){
		::SendMessage( m_CFuncKeyWnd.m_hWnd, WM_SIZE, wParam, lParam );
		::GetWindowRect( m_CFuncKeyWnd.m_hWnd, &rc );
		nFuncKeyWndHeight = rc.bottom - rc.top;
	}
	//@@@ From Here 2003.05.31 MIK
	//^uEChE
	nTabWndHeight = 0;
	if( NULL != m_cTabWnd.m_hWnd )
	{
		::SendMessage( m_cTabWnd.m_hWnd, WM_SIZE, wParam, lParam );
		::GetWindowRect( m_cTabWnd.m_hWnd, &rc );
		nTabWndHeight = rc.bottom - rc.top;
	}
	//@@@ To Here 2003.05.31 MIK
	nStatusBarHeight = 0;
	if( NULL != m_hwndStatusBar ){
		::SendMessage( m_hwndStatusBar, WM_SIZE, wParam, lParam );
		::GetClientRect( m_hwndStatusBar, &rc );
		//	May 12, 2000 genta
		//	2JڂɉsR[h̕\}
		//	From Here
		int			nStArr[8];
		// 2003.08.26 Moca CR0LF0p~ɏ]AKɒ
		// 2004-02-28 yasu ȍ͎ɍ킹
		// ςꍇɂCEditView::DrawCaretPosInfo()ł̕\@KvD
		const char*	pszLabel[7] = { "", "99999 s 9999 ", "CRLF", "0000", "Unicode", "REC", "㏑" };	//Oct. 30, 2000 JEPRO 疜sv
		int			nStArrNum = 7;
		//	To Here
		int			nAllWidth = rc.right - rc.left;
		int			nSbxWidth = ::GetSystemMetrics(SM_CXVSCROLL) + ::GetSystemMetrics(SM_CXEDGE); // TCY{bNX̕
		int			nBdrWidth = ::GetSystemMetrics(SM_CXSIZEFRAME) + ::GetSystemMetrics(SM_CXEDGE) * 2; // E̕
		SIZE		sz;
		HDC			hdc;
		int			i;
		// 2004-02-28 yasu
		// mȕvZ邽߂ɁA\tHg擾hdcɑIB
		hdc = ::GetDC( m_hwndStatusBar );
		HFONT hFont = (HFONT)::SendMessage(m_hwndStatusBar, WM_GETFONT, 0, 0);
		if (hFont != NULL)
		{
			hFont = (HFONT)::SelectObject(hdc, hFont);
		}
		nStArr[nStArrNum - 1] = nAllWidth;
		if( wParam != SIZE_MAXIMIZED ){
			nStArr[nStArrNum - 1] -= nSbxWidth;
		}
		for( i = nStArrNum - 1; i > 0; i-- ){
			::GetTextExtentPoint32( hdc, pszLabel[i], lstrlen( pszLabel[i] ), &sz );
			nStArr[i - 1] = nStArr[i] - ( sz.cx + nBdrWidth );
		}

		//	Nov. 8, 2003 genta
		//	Ԃłׂ͂Ă̕ugvCbZ[WGA͘g`悵Ȃ悤ɂĂ
		//	߁C̘gςȕɎcĂ܂DԂŘg`悳Ȃ邽߁C
		//	ŏɁugvԂݒ肵Ńo[̕sD
		::SendMessage( m_hwndStatusBar, SB_SETTEXT, 0 | SBT_NOBORDERS, (LPARAM) (LPINT)"" );

		::SendMessage( m_hwndStatusBar, SB_SETPARTS, nStArrNum, (LPARAM) (LPINT)nStArr );
		if (hFont != NULL)
		{
			::SelectObject(hdc, hFont);
		}
		::ReleaseDC( m_hwndStatusBar, hdc );

		::UpdateWindow( m_hwndStatusBar );	// 2006.06.17 ryoji `ł炷
		::GetWindowRect( m_hwndStatusBar, &rc );
		nStatusBarHeight = rc.bottom - rc.top;
	}
	::GetClientRect( m_hWnd, &rcClient );

	//@@@ From 2003.05.31 MIK
	//^uEChEǉɔCt@NVL[\ʒu

	//^uEChE
	if( m_cTabWnd.m_hWnd )
	{
		if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 0 )
		{
			::MoveWindow( m_cTabWnd.m_hWnd, 0, nToolBarHeight + nFuncKeyWndHeight, cx, nTabWndHeight, TRUE );
		}
		else
		{
			::MoveWindow( m_cTabWnd.m_hWnd, 0, nToolBarHeight, cx, nTabWndHeight, TRUE );
		}
	}

	//	2005.04.23 genta t@NVL[\͈̎ړȂ
	if( m_CFuncKeyWnd.m_hWnd != NULL ){
		if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 0 )
		{	/* t@NVL[\ʒu^0: 1: */
			::MoveWindow(
				m_CFuncKeyWnd.m_hWnd,
				0,
				nToolBarHeight,
				cx,
				nFuncKeyWndHeight, TRUE );
		}
		else if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 1 )
		{	/* t@NVL[\ʒu^0: 1: */
			::MoveWindow(
				m_CFuncKeyWnd.m_hWnd,
				0,
				cy - nFuncKeyWndHeight - nStatusBarHeight,
				cx,
				nFuncKeyWndHeight, TRUE
			);

			BOOL	bSizeBox = TRUE;
			if( NULL != m_hwndStatusBar ){
				bSizeBox = FALSE;
			}
			if( wParam == SIZE_MAXIMIZED ){
				bSizeBox = FALSE;
			}
			m_CFuncKeyWnd.SizeBox_ONOFF( bSizeBox );
		}
		::UpdateWindow( m_CFuncKeyWnd.m_hWnd );	// 2006.06.17 ryoji `ł炷
	}

	if( m_pShareData->m_Common.m_nFUNCKEYWND_Place == 0 )
	{
		m_cEditDoc.OnMove(
			0,
			nToolBarHeight + nFuncKeyWndHeight + nTabWndHeight,	//@@@ 2003.05.31 MIK
			cx,
			cy - nToolBarHeight - nFuncKeyWndHeight - nTabWndHeight - nStatusBarHeight	//@@@ 2003.05.31 MIK
		);
	}
	else
	{
		m_cEditDoc.OnMove(
			0,
			nToolBarHeight + nTabWndHeight,
			cx,
			cy - nToolBarHeight - nTabWndHeight - nFuncKeyWndHeight - nStatusBarHeight	//@@@ 2003.05.31 MIK
		);
	}
	//@@@ To 2003.05.31 MIK

	/* vr[[h */
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	if( !m_pPrintPreview ){
		return 0L;
	}
	return m_pPrintPreview->OnSize(wParam, lParam);
}




/* WM_PAINT `揈 */
LRESULT CEditWnd::OnPaint(
	HWND			hwnd,	// handle of window
	UINT			uMsg,	// message identifier
	WPARAM			wParam,	// first message parameter
	LPARAM			lParam 	// second message parameter
)
{
	HDC				hdc;
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	/* vr[[h */
	if( !m_pPrintPreview ){
		PAINTSTRUCT		ps;
		hdc = ::BeginPaint( hwnd, &ps );
		::EndPaint( hwnd, &ps );
		return 0L;
	}
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	return m_pPrintPreview->OnPaint(hwnd, uMsg, wParam, lParam);
}

/* vr[ XN[o[bZ[W WM_VSCROLL */
LRESULT CEditWnd::OnVScroll( WPARAM wParam, LPARAM lParam )
{
	/* vr[[h */
	if( !m_pPrintPreview ){
		return 0;
	}
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	return m_pPrintPreview->OnVScroll(wParam, lParam);
}




/* vr[ XN[o[bZ[W */
LRESULT CEditWnd::OnHScroll( WPARAM wParam, LPARAM lParam )
{
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	/* vr[[h */
	if( !m_pPrintPreview ){
		return 0;
	}
	return m_pPrintPreview->OnHScroll( wParam, lParam );
}

LRESULT CEditWnd::OnLButtonDown( WPARAM wParam, LPARAM lParam )
{
	//by S(2) Lv`[ĉꂽNCAgłɗ
	if(m_IconClicked != icNone)
		return 0;

	WPARAM		fwKeys;
	int			xPos;
	int			yPos;
	fwKeys = wParam;		// key flags
	xPos = LOWORD(lParam);	// horizontal position of cursor
	yPos = HIWORD(lParam);	// vertical position of cursor
	m_nDragPosOrgX = xPos;
	m_nDragPosOrgY = yPos;
	SetCapture( m_hWnd );
	m_bDragMode = TRUE;

	return 0;
}

LRESULT CEditWnd::OnLButtonUp( WPARAM wParam, LPARAM lParam )
{
	//by S 2002/04/18
	if(m_IconClicked != icNone)
	{
		if(m_IconClicked == icDown)
		{
			m_IconClicked = icClicked;
			//by S(2) ^C}[(ID͓Kł)
			SetTimer(m_hWnd, IDT_SYSMENU, GetDoubleClickTime(), NULL);
		}
		return 0;
	}

	m_bDragMode = FALSE;
	ReleaseCapture();
	::InvalidateRect( m_hWnd, NULL, TRUE );
	return 0;
}


/*!	WM_MOUSEMOVE
	@date 2008.05.05 novice [NC
*/
LRESULT CEditWnd::OnMouseMove( WPARAM wParam, LPARAM lParam )
{
	//by S
	if(m_IconClicked != icNone)
	{
		//by S(2) 񉟂ꂽ
		if(m_IconClicked == icDown)
		{
			POINT P;
			GetCursorPos(&P); //XN[W
			if(SendMessage(m_hWnd, WM_NCHITTEST, 0, P.x | (P.y << 16)) != HTSYSMENU)
			{
				ReleaseCapture();
				m_IconClicked = icNone;

				if(m_cEditDoc.IsFilePathAvailable())
				{
					const char *PathEnd = m_cEditDoc.GetFilePath();
					for(const char* I = m_cEditDoc.GetFilePath(); *I != 0; ++I)
					{
						//by S(2): DBCS
						if(IsDBCSLeadByte(*I))
							++I;
						else if(*I == '\\')
							PathEnd = I;
					}

					wchar_t WPath[MAX_PATH];
					int c = MultiByteToWideChar(CP_ACP, 0, m_cEditDoc.GetFilePath(), PathEnd - m_cEditDoc.GetFilePath(), WPath, MAX_PATH);
					WPath[c] = 0;
					wchar_t WFile[MAX_PATH];
					MultiByteToWideChar(CP_ACP, 0, PathEnd + 1, -1, WFile, MAX_PATH);

					IDataObject *DataObject;
					IMalloc *Malloc;
					IShellFolder *Desktop, *Folder;
					LPITEMIDLIST PathID, ItemID;
					SHGetMalloc(&Malloc);
					SHGetDesktopFolder(&Desktop);
					DWORD Eaten, Attribs;
					if(SUCCEEDED(Desktop->ParseDisplayName(0, NULL, WPath, &Eaten, &PathID, &Attribs)))
					{
						Desktop->BindToObject(PathID, NULL, IID_IShellFolder, (void**)&Folder);
						Malloc->Free(PathID);
						if(SUCCEEDED(Folder->ParseDisplayName(0, NULL, WFile, &Eaten, &ItemID, &Attribs)))
						{
							LPCITEMIDLIST List[1];
							List[0] = ItemID;
							Folder->GetUIObjectOf(0, 1, List, IID_IDataObject, NULL, (void**)&DataObject);
							Malloc->Free(ItemID);
#define DDASTEXT
#ifdef  DDASTEXT
							//eLXgłc֗
							int Len = lstrlen(m_cEditDoc.GetFilePath());
							FORMATETC F;
							STGMEDIUM M;

							F.cfFormat = CF_TEXT;
							F.ptd      = NULL;
							F.dwAspect = DVASPECT_CONTENT;
							F.lindex   = -1;
							F.tymed    = TYMED_HGLOBAL;

							M.tymed = TYMED_HGLOBAL;
							M.pUnkForRelease = NULL;
							M.hGlobal = GlobalAlloc(GMEM_MOVEABLE, Len+1);

							void* P = GlobalLock(M.hGlobal);
							CopyMemory(P, m_cEditDoc.GetFilePath(), Len+1);
							GlobalUnlock(M.hGlobal);

							DataObject->SetData(&F, &M, TRUE);
#endif
							//ړ͋֎~
							DWORD R;
							CDropSource drop(TRUE);
							DoDragDrop(DataObject, &drop, DROPEFFECT_COPY | DROPEFFECT_LINK, &R);
							DataObject->Release();
						}
						Folder->Release();
					}
					Desktop->Release();
					Malloc->Release();
				}
			}
		}
		return 0;
	}

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	if (!m_pPrintPreview){
		return 0;
	}
	else {
		return m_pPrintPreview->OnMouseMove( wParam, lParam );
	}
}




LRESULT CEditWnd::OnMouseWheel( WPARAM wParam, LPARAM lParam )
{
	if( m_pPrintPreview ){
		return m_pPrintPreview->OnMouseWheel( wParam, lParam );
	}
	return m_cEditDoc.DispatchEvent( m_hWnd, WM_MOUSEWHEEL, wParam, lParam );
}

/** }EXzC[

	@date 2007.10.16 ryoji OnMouseWheel()珈o
*/
BOOL CEditWnd::DoMouseWheel( WPARAM wParam, LPARAM lParam )
{
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	/* vr[[h */
	if( !m_pPrintPreview ){
		// 2006.03.26 ryoji by assitance with John ^uȂEBhE؂ւ
		if( m_pShareData->m_Common.m_bChgWndByWheel && NULL != m_cTabWnd.m_hwndTab )
		{
			POINT pt;
			pt.x = (short)LOWORD( lParam );
			pt.y = (short)HIWORD( lParam );
			int nDelta = (short)HIWORD( wParam );
			HWND hwnd = ::WindowFromPoint( pt );
			if( (hwnd == m_cTabWnd.m_hwndTab || hwnd == m_cTabWnd.m_hWnd) )
			{
				// ݊JĂҏW̃Xg𓾂
				EditNode* pEditNodeArr;
				int nRowNum = CShareData::getInstance()->GetOpenedWindowArr( &pEditNodeArr, TRUE );
				if(  nRowNum > 0 )
				{
					// ̃EBhE𒲂ׂ
					int i, j;
					int nGroup = 0;
					for( i = 0; i < nRowNum; ++i )
					{
						if( m_hWnd == pEditNodeArr[i].m_hWnd )
						{
							nGroup = pEditNodeArr[i].m_nGroup;
							break;
						}
					}
					if( i < nRowNum )
					{
						if( nDelta < 0 )
						{
							// ̃EBhE
							for( j = i + 1; j < nRowNum; ++j )
							{
								if( nGroup == pEditNodeArr[j].m_nGroup )
									break;
							}
							if( j >= nRowNum )
							{
								for( j = 0; j < i; ++j )
								{
									if( nGroup == pEditNodeArr[j].m_nGroup )
										break;
								}
							}
						}
						else
						{
							// ÕEBhE
							for( j = i - 1; j >= 0; --j )
							{
								if( nGroup == pEditNodeArr[j].m_nGroup )
									break;
							}
							if( j < 0 )
							{
								for( j = nRowNum - 1; j > i; --j )
								{
									if( nGroup == pEditNodeArr[j].m_nGroup )
										break;
								}
							}
						}

						/* ́ior ÓjEBhEANeBuɂ */
						if( i != j )
							ActivateFrameWindow( pEditNodeArr[j].m_hWnd );
					}

					delete []pEditNodeArr;
				}
				return TRUE;	// 
			}
		}
		return FALSE;	// Ȃ
	}
	return FALSE;	// Ȃ
}

/* y[Wݒ
	vr[ɂAłȂƂłĂ΂\B
*/
BOOL CEditWnd::OnPrintPageSetting( void )
{
	/* ݒiCANCELƂɔj邽߂̗̈j */
	CDlgPrintSetting	cDlgPrintSetting;
	BOOL				bRes;
	PRINTSETTING		PrintSettingArr[MAX_PRINTSETTINGARR];
	int					i;
	int					nCurrentPrintSetting;
	for( i = 0; i < MAX_PRINTSETTINGARR; ++i ){
		PrintSettingArr[i] = m_pShareData->m_PrintSettingArr[i];
	}

//	cDlgPrintSetting.Create( m_hInstance, m_hWnd );
	nCurrentPrintSetting = m_cEditDoc.GetDocumentAttribute().m_nCurrentPrintSetting;
	bRes = cDlgPrintSetting.DoModal(
		m_hInstance,
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		m_hWnd,
		&nCurrentPrintSetting, /* ݑIĂݒ */
		PrintSettingArr
	);

	if( TRUE == bRes ){
		/* ݑIĂy[Wݒ̔ԍύXꂽ */
		if( nCurrentPrintSetting !=
			m_pShareData->m_Types[m_cEditDoc.GetDocumentType()].m_nCurrentPrintSetting
		){
//			/* ύXtO(^Cvʐݒ) */
			m_cEditDoc.GetDocumentAttribute().m_nCurrentPrintSetting = nCurrentPrintSetting;
		}

//		/* ꂼ̃y[Wݒ̓eύXꂽ */
//		if( 0 != memcmp(
//			&m_pShareData->m_PrintSettingArr,
//			&PrintSettingArr,
//			sizeof( m_pShareData->m_PrintSettingArr ) )
//		){
//			m_pShareData->m_bPrintSettingModify = TRUE;	/* ύXtO(̑S) */
			for( i = 0; i < MAX_PRINTSETTINGARR; ++i ){
//				if( 0 != memcmp(
//					&m_pShareData->m_PrintSettingArr[i],
//					&PrintSettingArr[i],
//					sizeof( m_pShareData->m_PrintSettingArr[i] ) )
//				){
//					/* ύXtO(ݒ育) */
//					m_pShareData->m_bPrintSettingModifyArr[i] = TRUE;
					m_pShareData->m_PrintSettingArr[i] = PrintSettingArr[i];
//				}
			}
//		}

//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
		//	vr[̂݁B
		if ( m_pPrintPreview ){
			/* ݂̈ݒ */
			m_pPrintPreview->SetPrintSetting( &m_pShareData->m_PrintSettingArr[m_cEditDoc.GetDocumentAttribute().m_nCurrentPrintSetting] );

			/* vr[ XN[o[ */
			m_pPrintPreview->InitPreviewScrollBar();

			/* ݒ̔f */
			m_pPrintPreview->OnChangePrintSetting( );

			::InvalidateRect( m_hWnd, NULL, TRUE );
		}
	}
//@@@ 2002.01.14 YAZAKI vr[CPrintPreviewɓƗƂɂύX
	::UpdateWindow( m_hWnd /* m_pPrintPreview->GetPrintPreviewBarHANDLE() */);
	return bRes;
}

///////////////////////////// by S

LRESULT CEditWnd::OnNcLButtonDown(WPARAM wp, LPARAM lp)
{
	LRESULT Result;
	if(wp == HTSYSMENU)
	{
		SetCapture(m_hWnd);
		m_IconClicked = icDown;
		Result = 0;
	}
	else
		Result = DefWindowProc(m_hWnd, WM_NCLBUTTONDOWN, wp, lp);

	return Result;
}

LRESULT CEditWnd::OnNcLButtonUp(WPARAM wp, LPARAM lp)
{
	LRESULT Result;
	if(m_IconClicked != icNone)
	{
		//Ô
		ReleaseCapture();
		m_IconClicked = icNone;
		Result = 0;
	}
	else if(wp == HTSYSMENU)
		Result = 0;
	else{
		//	2004.05.23 Moca bZ[W~XC
		//	t[̃_uNbNɃEBhETCY
		//	ύX[hȂĂ
		Result = DefWindowProc(m_hWnd, WM_NCLBUTTONUP, wp, lp);
	}

	return Result;
}

LRESULT CEditWnd::OnLButtonDblClk(WPARAM wp, LPARAM lp) //by S(2)
{
	LRESULT Result;
	if(m_IconClicked != icNone)
	{
		ReleaseCapture();
		m_IconClicked = icDoubleClicked;

		SendMessage(m_hWnd, WM_SYSCOMMAND, SC_CLOSE, 0);

		Result = 0;
	}
	else {
		//	2004.05.23 Moca bZ[W~XC
		Result = DefWindowProc(m_hWnd, WM_LBUTTONDBLCLK, wp, lp);
	}

	return Result;
}

/*! hbv_Ej[(J) */	//@@@ 2002.06.15 MIK
int	CEditWnd::CreateFileDropDownMenu( HWND hwnd )
{
	int			nId;
	HMENU		hMenu;
	HMENU		hMenuPopUp;
	POINT		po;
	RECT		rc;
	int			nIndex;

	// j[\ʒu߂	// 2007.03.25 ryoji
	//  TBN_DROPDOWN  NMTOOLBAR::iItem  NMTOOLBAR::rcButton ɂ̓hbv_Ej[(J){^
	//    Ƃ͂ǂPڂ̃{^񂪓悤Ȃ̂Ń}EXʒu{^ʒu߂
	::GetCursorPos( &po );
	::ScreenToClient( hwnd, &po );
	nIndex = ::SendMessage( hwnd, TB_HITTEST, (WPARAM)0, (LPARAM)&po );
	if( nIndex < 0 ){
		return 0;
	}
	::SendMessage( hwnd, TB_GETITEMRECT, (WPARAM)nIndex, (LPARAM)&rc );
	po.x = rc.left;
	po.y = rc.bottom;
	::ClientToScreen( hwnd, &po );
	GetMonitorWorkRect( po, &rc );
	if( po.x < rc.left )
		po.x = rc.left;
	if( po.y < rc.top )
		po.y = rc.top;


	m_CMenuDrawer.ResetContents();

	/* MRUXg̃t@C̃Xgj[ɂ */
	CMRU cMRU;
	hMenu = cMRU.CreateMenu( &m_CMenuDrawer );
	if( cMRU.Length() > 0 )
	{
		m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL, FALSE );
	}

	/* ŋߎgtH_̃j[쐬 */
	CMRUFolder cMRUFolder;
	hMenuPopUp = cMRUFolder.CreateMenu( &m_CMenuDrawer );
	if ( cMRUFolder.Length() > 0 )
	{
		//	ANeBu
		m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hMenuPopUp, "ŋߎgtH_(&D)" );
	}
	else 
	{
		//	ANeBu
		m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING | MF_POPUP | MF_GRAYED, (UINT)hMenuPopUp, "ŋߎgtH_(&D)" );
	}

	m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL, FALSE );

	m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILENEW, "VK쐬(&N)", FALSE );
	m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, F_FILEOPEN, "J(&O)...", FALSE );

	nId = ::TrackPopupMenu(
		hMenu,
		TPM_TOPALIGN
		| TPM_LEFTALIGN
		| TPM_RETURNCMD
		| TPM_LEFTBUTTON
		,
		po.x,
		po.y,
		0,
		m_hWnd,	// 2009.02.03 ryoji ANZXL[L̂ hwnd -> m_hWnd ɕύX
		NULL
	);

	::DestroyMenu( hMenu );

	return nId;
}

/*! {bNXł̏ */
void CEditWnd::ProcSearchBox( MSG *msg )
{
	if( msg->message == WM_KEYDOWN /* && ::GetParent( msg->hwnd ) == m_hwndSearchBox */ )
	{
		if( (TCHAR)msg->wParam == VK_RETURN )  //^[L[
		{
			//L[[h擾
			char	szText[_MAX_PATH];
			memset( szText, 0, sizeof(szText) );
			::SendMessage( m_hwndSearchBox, WM_GETTEXT, _MAX_PATH - 1, (LPARAM)szText );
			if( szText[0] )	//L[񂪂
			{
				//L[o^
				CShareData::getInstance()->AddToSearchKeyArr( (const char*)szText );

				//::SetFocus( m_hWnd );	//ɃtH[JXړĂȂƃLbg
				::SetFocus( m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_hWnd );

				// JñJ[\ʒuo^ύX 02/07/28 ai start
				m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nSrchStartPosX_PHY = m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nCaretPosX_PHY;
				m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nSrchStartPosY_PHY = m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_nCaretPosY_PHY;
				// 02/07/28 ai end

				//
				OnCommand( (WORD)0 /*j[*/, (WORD)F_SEARCH_NEXT, (HWND)0 );
			}
		}
		else if( (TCHAR)msg->wParam == VK_TAB )	//^uL[
		{
			//tH[JXړ
			//	2004.10.27 MIK IME\ʒûC
			::SetFocus( m_hWnd  );
		}
	}

	return;
}

/*!
	@brief EBhẼACRݒ

	w肳ꂽACREBhEɐݒ肷D
	ȑÕACR͔jD

	@param hIcon [in] ݒ肷ACR
	@param flag [in] ACRʁDICON_BIG܂ICON_SMALL.
	@author genta
	@date 2002.09.10
*/
void CEditWnd::SetWindowIcon(HICON hIcon, int flag)
{
	HICON hOld = (HICON)::SendMessage( m_hWnd, WM_SETICON, flag, (LPARAM)hIcon );
	if( hOld != NULL ){
		::DestroyIcon( hOld );
	}
}

/*!
	WACR̎擾

	@param hIconBig   [out] 傫ACR̃nh
	@param hIconSmall [out] ACR̃nh

	@author genta
	@date 2002.09.10
	@date 2002.12.02 genta V݂ʊ֐g悤
*/
void CEditWnd::GetDefaultIcon( HICON& hIconBig, HICON& hIconSmall ) const
{
	hIconBig = GetAppIcon( m_hInstance, ICON_DEFAULT_APP, FN_APP_ICON, false );
	hIconSmall = GetAppIcon( m_hInstance, ICON_DEFAULT_APP, FN_APP_ICON, true );
}

/*!
	ACR̎擾
	
	w肳ꂽt@CɑΉACR(E)擾ĕԂD
	
	@param szFile     [in] t@C
	@param hIconBig   [out] 傫ACR̃nh
	@param hIconSmall [out] ACR̃nh
	
	@retval true ֘AÂꂽACR
	@retval false ֘AÂꂽACRȂ
	
	@author genta
	@date 2002.09.10
*/
bool CEditWnd::GetRelatedIcon(const char* szFile, HICON& hIconBig, HICON& hIconSmall) const
{
	if( NULL != szFile && szFile[0] != '\0' ){
		char szExt[_MAX_EXT];
		char FileType[1024];

		// (.Ŏn܂)gq̎擾
		_splitpath( szFile, NULL, NULL, NULL, szExt );
		
		if( ReadRegistry(HKEY_CLASSES_ROOT, szExt, NULL, FileType, sizeof(FileType) - 13)){
			lstrcat( FileType, "\\DefaultIcon" );
			if( ReadRegistry(HKEY_CLASSES_ROOT, FileType, NULL, NULL, 0)){
				// ֘AÂꂽACR擾
				SHFILEINFO shfi;
				SHGetFileInfo( szFile, 0, &shfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_LARGEICON );
				hIconBig = shfi.hIcon;
				SHGetFileInfo( szFile, 0, &shfi, sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_SMALLICON );
				hIconSmall = shfi.hIcon;
				return true;
			}
		}
	}

	//	W̃ACRԂ
	GetDefaultIcon( hIconBig, hIconSmall );
	return false;
}

/*
	@brief j[o[\ptHg̏
	
	j[o[\ptHg̏sD
	
	@date 2002.12.04 CEditView̃RXgN^ړ
*/
void CEditWnd::InitMenubarMessageFont(void)
{
	TEXTMETRIC	tm;
	LOGFONT		lf;
	HDC			hdc;
	HFONT		hFontOld;
	int			i;

	/* LOGFONT̏ */
	memset( &lf, 0, sizeof( LOGFONT ) );
	lf.lfHeight			= -12;
	lf.lfWidth			= 0;
	lf.lfEscapement		= 0;
	lf.lfOrientation	= 0;
	lf.lfWeight			= 400;
	lf.lfItalic			= 0x0;
	lf.lfUnderline		= 0x0;
	lf.lfStrikeOut		= 0x0;
	lf.lfCharSet		= 0x80;
	lf.lfOutPrecision	= 0x3;
	lf.lfClipPrecision	= 0x2;
	lf.lfQuality		= 0x1;
	lf.lfPitchAndFamily	= 0x31;
	strcpy( lf.lfFaceName, "lr SVbN" );
	m_hFontCaretPosInfo = ::CreateFontIndirect( &lf );

	hdc = ::GetDC( ::GetDesktopWindow() );
	hFontOld = (HFONT)::SelectObject( hdc, m_hFontCaretPosInfo );
	::GetTextMetrics( hdc, &tm );
	m_nCaretPosInfoCharWidth = tm.tmAveCharWidth;
	m_nCaretPosInfoCharHeight = tm.tmHeight;
	for( i = 0; i < ( sizeof( m_pnCaretPosInfoDx ) / sizeof( m_pnCaretPosInfoDx[0] ) ); ++i ){
		m_pnCaretPosInfoDx[i] = ( m_nCaretPosInfoCharWidth );
	}
	::SelectObject( hdc, hFontOld );
	::ReleaseDC( ::GetDesktopWindow(), hdc );
}

/*
	@brief j[o[ɃbZ[W\
	
	OɃj[o[\ptHgĂȂĂ͂ȂȂD
	wł镶͍ő30oCgDȏ̏ꍇ͂؂ĕ\D
	
	@author genta
	@date 2002.12.04
*/
void CEditWnd::PrintMenubarMessage( const char* msg )
{
	if( NULL == ::GetMenu( m_hWnd ) )	// 2007.03.08 ryoji ǉ
		return;

	HDC		hdc;
	POINT	po,poFrame;
	RECT	rc,rcFrame;
	HFONT	hFontOld;
	int		nStrLen;
	const int MAX_LEN = 30;
	char	szText[MAX_LEN + 1];
	
	int len = strlen( msg );
	strncpy( szText, msg, MAX_LEN );
	
	if( len < MAX_LEN ){
		memset( szText + len, ' ', MAX_LEN - len );
	}
	szText[MAX_LEN] = '\0';
	
	hdc = ::GetWindowDC( m_hWnd );
	poFrame.x = 0;
	poFrame.y = 0;
	::ClientToScreen( m_hWnd, &poFrame );
	::GetWindowRect( m_hWnd, &rcFrame );
	po.x = rcFrame.right - rcFrame.left;
	po.y = poFrame.y - rcFrame.top;
	hFontOld = (HFONT)::SelectObject( hdc, m_hFontCaretPosInfo );
	nStrLen = MAX_LEN;
	rc.left = po.x - nStrLen * m_nCaretPosInfoCharWidth - ( ::GetSystemMetrics( SM_CXSIZEFRAME ) + 2 );
	rc.right = rc.left + nStrLen * m_nCaretPosInfoCharWidth;
	rc.top = po.y - m_nCaretPosInfoCharHeight - 2;
	rc.bottom = rc.top + m_nCaretPosInfoCharHeight;
	::SetTextColor( hdc, ::GetSysColor( COLOR_MENUTEXT ) );
	//	Sep. 6, 2003 genta Windows XP(Luna)̏ꍇɂCOLOR_MENUBARgȂĂ͂ȂȂ
	COLORREF bkColor =
		::GetSysColor( COsVersionInfo().IsWinXP_or_later() ? COLOR_MENUBAR : COLOR_MENU );
	::SetBkColor( hdc, bkColor );
	::ExtTextOut( hdc,rc.left,rc.top,ETO_OPAQUE,&rc,szText,nStrLen,m_pnCaretPosInfoDx);
	::SelectObject( hdc, hFontOld );
	::ReleaseDC( m_hWnd, hdc );
}

/*!
	@brief bZ[W̕\
	
	w肳ꂽbZ[WXe[^Xo[ɕ\D
	Xe[^Xo[\̏ꍇ̓j[o[̉E[ɕ\D
	
	@param msg [in] \郁bZ[W
	@date 2002.01.26 hor VK쐬
	@date 2002.12.04 genta CEditViewړ
*/
void CEditWnd::SendStatusMessage( const char* msg )
{
	if( NULL == m_hwndStatusBar ){
		// j[o[
		PrintMenubarMessage( msg );
	}else{
		// Xe[^Xo[
		::SendMessage( m_hwndStatusBar,SB_SETTEXT,0 | SBT_NOBORDERS,(LPARAM) (LPINT)msg );
	}
}

/*!
	@brief bZ[W̕\
	
	w肳ꂽbZ[WXe[^Xo[ɕ\D
	j[o[E[ɓȂ̂Cʒu\BȂ̂Ɏg
	
	ĂяoOSendStatusMessage2IsEffective()ŏ̗L
	mF邱ƂŖʂȏȂƂoD

	@param msg [in] \郁bZ[W
	@date 2005.07.09 genta VK쐬
	
	@sa SendStatusMessage2IsEffective
*/
void CEditWnd::SendStatusMessage2( const char* msg )
{
	if( NULL != m_hwndStatusBar ){
		// Xe[^Xo[
		::SendMessage( m_hwndStatusBar,SB_SETTEXT,0 | SBT_NOBORDERS,(LPARAM) (LPINT)msg );
	}
}

/*! t@CύXʒm

	@author MIK
	@date 2003.05.31 VK쐬
	@date 2006.01.28 ryoji t@CAGrep[hp[^ǉ
*/
void CEditWnd::ChangeFileNameNotify( const char *pszTabCaption, const char *pszFilePath, BOOL bIsGrep )
{
	CRecent	cRecentEditNode;
	EditNode	*p;
	int		nIndex;

	if( NULL == pszTabCaption ) pszTabCaption = "";	//K[h
	if( NULL == pszFilePath ) pszFilePath = "";		//K[h 2006.01.28 ryoji

	cRecentEditNode.EasyCreate( RECENT_FOR_EDITNODE );
	nIndex = cRecentEditNode.FindItem( (const char*)&m_hWnd );
	if( -1 != nIndex )
	{
		p = (EditNode*)cRecentEditNode.GetItem( nIndex );
		if( p )
		{
			int	size = sizeof( p->m_szTabCaption ) - 1;
			strncpy( p->m_szTabCaption, pszTabCaption, size );
			p->m_szTabCaption[ size ] = '\0';

			// 2006.01.28 ryoji t@CAGrep[hǉ
			size = sizeof( p->m_szFilePath ) - 1;
			strncpy( p->m_szFilePath, pszFilePath, size );
			p->m_szFilePath[ size ] = '\0';

			p->m_bIsGrep = bIsGrep;
		}
	}
	cRecentEditNode.Terminate();

	//t@CύXʒmu[hLXgB
	int nGroup = CShareData::getInstance()->GetGroupId( m_hWnd );
	CShareData::getInstance()->PostMessageToAllEditors( MYWM_TAB_WINDOW_NOTIFY, (WPARAM)TWNT_FILE, (LPARAM)m_hWnd, m_hWnd, nGroup );

	return;
}
/*!	@brief ToolBarOwnerDraw

	@param pnmh [in] Owner Draw

	@note Common Control V4.71ȍ~NMTBCUSTOMDRAW𑗂Ă邪C
	Common Control V4.70LPNMCUSTOMDRAWĂȂ̂
	Ŝߏɍ킹ďsD
	
	@author genta
	@date 2003.07.21 쐬

*/
LPARAM CEditWnd::ToolBarOwnerDraw( LPNMCUSTOMDRAW pnmh )
{
	switch( pnmh->dwDrawStage ){
	case CDDS_PREPAINT:
		//	`JnO
		//	ACeOŕ`悷|ʒm
		return CDRF_NOTIFYITEMDRAW;
	
	case CDDS_ITEMPREPAINT:
		//	ʓ|̂ŁCgToolbarɕ`Ă炤
		//	ACRo^ĂȂ̂Œg͉`Ȃ
		return CDRF_NOTIFYPOSTPAINT;
	
	case CDDS_ITEMPOSTPAINT:
		{
			//	`
			// R}hԍipnmh->dwItemSpecjACRԍ擾	// 2007.11.02 ryoji
			int nIconId = ::SendMessage( pnmh->hdr.hwndFrom, TB_GETBITMAP, (WPARAM)pnmh->dwItemSpec, 0 );

			int offset = ((pnmh->rc.bottom - pnmh->rc.top) - m_cIcons.cy()) / 2;		// ACe`̉摜̃ItZbg	// 2007.03.25 ryoji
			int shift = pnmh->uItemState & ( CDIS_SELECTED | CDIS_CHECKED ) ? 1 : 0;	//	Aug. 30, 2003 genta {^ꂽ炿Ɖ摜炷
			int color = pnmh->uItemState & CDIS_CHECKED ? COLOR_3DHILIGHT : COLOR_3DFACE;

			//	Sep. 6, 2003 genta ͉EłȂɂ炷
			m_cIcons.Draw( nIconId, pnmh->hdc, pnmh->rc.left + offset + shift, pnmh->rc.top + offset + shift,
				(pnmh->uItemState & CDIS_DISABLED ) ? ILD_MASK : ILD_NORMAL
			);
		}
		break;
	default:
		break;
	}
	return CDRF_DODEFAULT;
}

/*! ɎOɕ\
	@param top  0:gO 1:őO 2:őOʉ ̑:ȂɂȂ
	@date 2004.09.21 Moca
*/
void CEditWnd::WindowTopMost( int top )
{
	if( 0 == top ){
		DWORD dwExstyle = (DWORD)::GetWindowLongPtr( m_hWnd, GWL_EXSTYLE );
		if( dwExstyle & WS_EX_TOPMOST ){
			top = 2; // őOʂł -> 
		}else{
			top = 1;
		}
	}

	HWND hwndInsertAfter;
	switch( top ){
	case 1:
		hwndInsertAfter = HWND_TOPMOST;
		break;
	case 2:
		hwndInsertAfter = HWND_NOTOPMOST;
		break;
	default:
		return;
	}

	::SetWindowPos( m_hWnd, hwndInsertAfter, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );

	// ^u܂Ƃߎ WS_EX_TOPMOST ԂSEBhEœ	// 2007.05.18 ryoji
	if( m_pShareData->m_Common.m_bDispTabWnd && !m_pShareData->m_Common.m_bDispTabWndMultiWin ){
		HWND hwnd;
		int i;
		for( i = 0, hwndInsertAfter = m_hWnd; i < m_pShareData->m_nEditArrNum; i++ ){
			hwnd = m_pShareData->m_pEditArr[i].m_hWnd;
			if( hwnd != m_hWnd && CShareData::getInstance()->IsEditWnd( hwnd ) ){
				if( !CShareData::getInstance()->IsSameGroup( m_hWnd, hwnd ) )
					continue;
				::SetWindowPos( hwnd, hwndInsertAfter, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );
				hwndInsertAfter = hwnd;
			}
		}
	}
}

/*!
c[o[̌{bNXɃtH[JXړ.
	@date 2006.06.04 yukihane VK쐬
*/
void CEditWnd::SetFocusSearchBox( void ) const
{
	if( m_hwndSearchBox ){
		::SetFocus(m_hwndSearchBox);
	}
}


// ^C}[̍XVJn^~B 20060128 aroka
// c[o[\̓^C}[ɂXVĂ邪A
// AṽtH[JXOꂽƂɃEBhEON/OFF
//	ĂяoĂ炤ƂɂA]vȕׂ~B
void CEditWnd::Timer_ONOFF( BOOL bStart )
{
	if( NULL != m_hWnd ){
		if( bStart ){
			/* ^C}[N */
			if( 0 == ::SetTimer( m_hWnd, IDT_TOOLBAR, 300, NULL ) ){
				::MYMESSAGEBOX( m_hWnd, MB_OK | MB_ICONEXCLAMATION, GSTR_APPNAME,
					"CEditWnd::Create()\n^C}[Nł܂B\nVXe\[XsĂ̂܂B"
				);
			}
		} else {
			/* ^C}[폜 */
			::KillTimer( m_hWnd, IDT_TOOLBAR );
		}
	}
	return;
}

/*!	@brief EBhEꗗ|bvAbv\

	@param[in] bMousePos true: }EXʒuɃ|bvAbv\

	@date 2006.03.23 fon OnListBtnClickx[XɐVK쐬
	@date 2006.05.10 ryoji |bvAbvʒuύXȂC
	@data 2007.02.28 ryoji tpXw̃p[^폜
*/
LRESULT CEditWnd::PopupWinList( bool bMousePos )
{
	POINT pt;

	// |bvAbvʒuANeBur[̏ӂɐݒ
	RECT rc;
	
	if( bMousePos ){
		::GetCursorPos( &pt );	// }EXJ[\ʒuɕύX
	}
	else {
		::GetWindowRect( m_cEditDoc.m_cEditViewArr[m_cEditDoc.m_nActivePaneIndex].m_hWnd, &rc );
		pt.x = rc.right - 150;
		if( pt.x < rc.left )
			pt.x = rc.left;
		pt.y = rc.top;
	}

	// EBhEꗗj[|bvAbv\
	if( NULL != m_cTabWnd.m_hWnd ){
		m_cTabWnd.TabListMenu( pt );
	}
	else{
		EditNode*	pEditNodeArr;
		HMENU hMenu = ::CreatePopupMenu();	// 2006.03.23 fon
		int nRowNum = CShareData::getInstance()->GetOpenedWindowArr( &pEditNodeArr, TRUE );
		WinListMenu( hMenu, pEditNodeArr, nRowNum, TRUE );
		// j[\
		RECT rcWork;
		GetMonitorWorkRect( pt, &rcWork );	// j^̃[NGA
		int nId = ::TrackPopupMenu( hMenu, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON | TPM_RETURNCMD,
									( pt.x > rcWork.left )? pt.x: rcWork.left,
									( pt.y < rcWork.bottom )? pt.y: rcWork.bottom,
									0, m_hWnd, NULL);
		delete [] pEditNodeArr;
		::DestroyMenu( hMenu );
		::SendMessage( m_hWnd, WM_COMMAND, (WPARAM)nId, (LPARAM)NULL );
	}

	return 0L;
}

/*! @brief ݊JĂҏW̃Xgj[ɂ 
	@date  2006.03.23 fon CEditWnd::InitMenuړB////炠RgB//>͒ǉRgAEgB
*/
LRESULT CEditWnd::WinListMenu( HMENU hMenu, EditNode* pEditNodeArr, int nRowNum, BOOL bFull )
{
	int			i;
	char		szMemu[280];
//>	EditNode*	pEditNodeArr;
	FileInfo*	pfi;

//>	int	nRowNum = CShareData::getInstance()->GetOpenedWindowArr( &pEditNodeArr, TRUE );
	if( nRowNum > 0 ){
//>		/* Zp[^ */
//>		m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_SEPARATOR, 0, NULL );
		CShareData::getInstance()->TransformFileName_MakeCache();
		for( i = 0; i < nRowNum; ++i ){
			/* gCGfB^ւ̕ҏWt@Cvʒm */
			::SendMessage( pEditNodeArr[i].m_hWnd, MYWM_GETFILEINFO, 0, 0 );
			pfi = (FileInfo*)&m_pShareData->m_FileInfo_MYWM_GETFILEINFO;
			if( pfi->m_bIsGrep ){
				/* f[^woCgȓɐ؂l߂ */
				CMemory		cmemDes;
				int			nDesLen;
				const char*	pszDes;
				LimitStringLengthB( pfi->m_szGrepKey, lstrlen( pfi->m_szGrepKey ), 64, cmemDes );
				pszDes = cmemDes.GetPtr();
				nDesLen = lstrlen( pszDes );
////	From Here Oct. 4, 2000 JEPRO commented out & modified	JĂt@C킩悤ɗƂ͈1琔
////		i >= 10 + 26 ̎̍lȂ(ɋ߂)Jt@C36z邱Ƃ͂܂Ȃ̂ŎOKł傤
				wsprintf( szMemu, "&%c yGrepz\"%s%s\"", ((1 + i) <= 9)?('1' + i):('A' + i - 9),
					pszDes, ( (int)lstrlen( pfi->m_szGrepKey ) > nDesLen ) ? "EEE":""
				);
			}else
			if( pEditNodeArr[i].m_hWnd == m_pShareData->m_hwndDebug ){
////		i >= 10 + 26 ̎̍lȂ(ɋ߂)o̓t@C36z邱Ƃ͂܂Ȃ̂ŎOKł傤
				wsprintf( szMemu, "&%c AEgvbg", ((1 + i) <= 9)?('1' + i):('A' + i - 9) );

			}else{
////		From Here Jan. 23, 2001 JEPRO
////		t@CpX'&'gĂƂɗ𓙂ŃL`ƕ\ȂC(&&&ɒu邾)
////<----- From Here Added
				char	szFile2[_MAX_PATH * 2];
				if( '\0' == pfi->m_szPath[0] ){
					strcpy( szFile2, "()" );
				}else{
					char buf[_MAX_PATH];
					CShareData::getInstance()->GetTransformFileNameFast( pfi->m_szPath, buf, _MAX_PATH );
					dupamp( buf, szFile2 );
				}
				wsprintf( szMemu, "&%c %s %s", ((1 + i) <= 9)?('1' + i):('A' + i - 9),
					szFile2,
					pfi->m_bIsModified ? "*":" "
				);
////-----> To Here Added
////		To Here Jan. 23, 2001

////	To Here Oct. 4, 2000
				// SJISȊO̕R[h̎ʂ\
				// gm_pszCodeNameArr_3 Rs[悤ɕύX
				if( 0 < pfi->m_nCharCode && pfi->m_nCharCode < CODE_CODEMAX ){
					strcat( szMemu, gm_pszCodeNameArr_3[pfi->m_nCharCode] );
				}
			}
			m_CMenuDrawer.MyAppendMenu( hMenu, MF_BYPOSITION | MF_STRING, IDM_SELWINDOW + pEditNodeArr[i].m_nIndex, szMemu );
			if( m_hWnd == pEditNodeArr[i].m_hWnd ){
				::CheckMenuItem( hMenu, IDM_SELWINDOW + pEditNodeArr[i].m_nIndex, MF_BYCOMMAND | MF_CHECKED );
			}
		}
//>		delete [] pEditNodeArr;
	}
	return 0L;
}


/*!
	@brief }EX̏ԂNAizC[XN[LԂNAj

	@note zC[ɂy[WXN[EXN[Ή̂߂ɒǉB
		  y[WXN[EXN[tOOFFB

	@date 2009.01.12 nasukoji	VK쐬
*/
void CEditWnd::ClearMouseState( void )
{
	SetPageScrollByWheel( FALSE );		// zC[ɂy[WXN[L
	SetHScrollByWheel( FALSE );			// zC[ɂ鉡XN[L
}


/*[EOF]*/
